package com.prolog.cs.base.gsp.vo;

import com.prolog.framework.core.annotation.Column;
import com.prolog.framework.core.annotation.Id;
import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description
 * @Date 2021-07-13
 * 回传OMS接口平台对象
 */

@ApiModel
@Data
public class DxiGspMaintenanceRecordVO implements Serializable {
	private static final long serialVersionUID =  2378979319518916810L;
	

	@ApiModelProperty(value = "单据编号")
	private String billno;

	@ApiModelProperty(value = "单据日期")
	private String billdate;

	@ApiModelProperty(value = "养护商品类型")
	private String maintenanceType;

	@ApiModelProperty(value = "仓库编码")
	private String branchcode;

	@ApiModelProperty(value = "货主编码")
	private String consignorcode;

	@ApiModelProperty(value = "商品编号")
	private String itemcode;

	@ApiModelProperty(value = "商品ID")
	private String itemid;

	@ApiModelProperty(value = "商品规格")
	private String capacity;

	@ApiModelProperty(value = "批准文号")
	private String fsymbol;

	@ApiModelProperty(value = "生产厂家")
	private String ffactory;

	@ApiModelProperty(value = "养护措施")
	private String maintenanceMeasure;

	@ApiModelProperty(value = "批号")
	private String lotNo;

	@ApiModelProperty(value = "库存数量")
	private String onhandQuantity;

	@ApiModelProperty(value = "养护结论")
	private String maintenanceResult;

	@ApiModelProperty(value = "养护员")
	private String maintenanceby;

	@ApiModelProperty(value = "审核员")
	private String auditby;

	@ApiModelProperty(value = "审核意见")
	private String auditOpinion;

	@ApiModelProperty(value = "养护数量")
	private String maintenanceNum;

	@ApiModelProperty(value = "养护待处理数量")
	private String pendingNum;

	@ApiModelProperty(value = "质量状况")
	private String qualityState;

	@ApiModelProperty(value = "温湿度状况")
	private String humitureState;

	@ApiModelProperty(value = "养护待处理原因")
	private String manageReason;

	@ApiModelProperty(value = "复检员")
	private String recheckby;

	@ApiModelProperty(value = "养护时间")
	private String maintenanceDate;

	@ApiModelProperty(value = "复检日期")
	private String recheckDate;

	@ApiModelProperty(value = "复检意见")
	private String reviewOpinion;

	@ApiModelProperty(value = "备注")
	private String remark;

	@ApiModelProperty(value = "企业ID")
	private String penterpriseid;

}
