package com.prolog.cs.base.gsp.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * EIS作业完成确认VO
 *
 * @author 鄢菁KingYan
 * @date 2022/07/13
 */
@Data
public class EisTaskFinishedConfirmVO {

    @ApiModelProperty(value = "容器编号", required = true)
    private String containerNo;
    @ApiModelProperty(value = "部分是包括托盘对应的拣选信息")
    private List<TaskFinishedConfirmSubListVO> subList;

}
