package com.prolog.cs.base.gsp.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.prolog.framework.core.annotation.Column;
import com.prolog.framework.core.annotation.Id;
import com.prolog.framework.core.annotation.Ignore;
import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description  
 * @Date 2022-05-28
 */

@ApiModel
@Data
public class GspQualityCheckMoveVo implements Serializable {


	private static final long serialVersionUID = 7988031893076318975L;


	@ApiModelProperty(value = "质量复查id")
	private String billId;

	@ApiModelProperty(value = "仓ID")
	private String warehouseId;

	@ApiModelProperty(value = "仓库Name")
	private String warehouseName;

	@ApiModelProperty(value = "货主id")
	private String cargoOwnerId;

	@ApiModelProperty(value = "货主")
	private String cargoOwnerName;

	@ApiModelProperty(value = "创建日期")
	private Date gmtCreate;

	@ApiModelProperty(value = "创建人")
	private String creator;

	@ApiModelProperty(value = "创建人")
	private String creatorName;

	@ApiModelProperty(value = "最后修改日期")
	private Date gmtModified;

	@ApiModelProperty(value = "最后修改人")
	private String modifier;

	@ApiModelProperty(value = "最后修改人")
	private String modifierName;

	@ApiModelProperty(value = "备注")
	private String remark;
	
}
