package com.prolog.cs.base.gsp.dao;

import com.prolog.cs.base.gsp.QueryDTO;
import com.prolog.cs.base.gsp.model.DxiGspQualityReviewH;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Description  
 * @Date 2022-05-27
 */
@Repository
public interface DxiGspQualityReviewHMapper extends BaseMapper<DxiGspQualityReviewH> {


    List<DxiGspQualityReviewH> findQualityReview4MovePick(QueryDTO upkeepCheckDTO);

    List<DxiGspQualityReviewH> findNoEnd(@Param("branchcode")String branchcode,
                                         @Param("consignorcode")String consignorcode,
                                         @Param("requestBilltype")String requestBilltype,
                                         @Param("billNo")String billNo,
                                         @Param("status")String status);
}
