package com.prolog.cs.base.gsp.resource;

import com.prolog.framework.common.message.RestMessage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;
import java.util.Map;

@FeignClient(value = "${prolog.service.presto}")
public interface PrestoClient {
	
	/**
	 *
	 */
	@PostMapping("/search")
	RestMessage<List<Map>> search(@RequestBody Map map);

}
