package com.prolog.cs.biz.inbound.constant;

/**
 * 入库业务常用类
 * 
 * @author Xiong
 *
 */
public class InboundBizConstant {

	/**
	 * 默认复检次数不超过2
	 */
	public final static Integer DEFAULT_RECHECK_TIMES = 2;  // 复检2次
	
	/**
	 * 合格
	 */
	public final static String QUALIFIED = "0";
	/**
	 * 不合格
	 */
	public final static String UN_QUALIFIED = "1";
	/**
	 * 待处理
	 */
	public final static String PENDING = "2";
	/**
	 * 拒收
	 */
	public final static String REJECT = "3";

	/**
	 * 下传默认值
	 */
	public final static String CREATE_BY = "admin";//默认创建人

	public final static String WAREHOUSE_ID = "759131791285161984";//默认仓id
	public final static String WAREHOUSE_CODE = "siyuan2022";//默认仓code

	public final static String WAREHOUSE_NAME = "思源华中仓";//默认仓名称

	public final static String P_ENTERPRISEID = "900356013474058240";//默认企业id
	public final static String P_ENTERPRISE_NAME = "江西青牛";//默认企业id

	public final static String ATTAIN_DATE = "9999-12-31";//默认到货日期

	public final static String SHIPPER_TYPE = "2";//发货类型

	public final static String[] EIS_DEVICE_AREA_CODES = {"AGVL", "AGVSP", "AGVQX", "AGVZ", "MJK","AGVZY"};

	public final static String[] EIS_PAPER_AREA_CODES = {"ZJK", "ZYK", "WLK", "NHK"};

}
