package com.prolog.cs.biz.inbound.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class ErpInfCgddBillDto {

    @ApiModelProperty("单位id")
    private String dwid;

    @ApiModelProperty("采购单号")
    private String djbh;

    @ApiModelProperty("ydhrq")
    private String ydhrq;

    @ApiModelProperty("货主id")
    private String yzid;

    @ApiModelProperty("dmrq datetime")
    private String dmrq;

    @ApiModelProperty("bmid")
    private String bmid;

    @ApiModelProperty("件数")
    private BigDecimal js;

    @ApiModelProperty("生产日期")
    private String rq_sc;

    @ApiModelProperty("下传标识")
    private String wmflg;

    @ApiModelProperty("商品id")
    private String spid;

    @ApiModelProperty("零散数")
    private BigDecimal lss;

    @ApiModelProperty("有效期至")
    private String yxqz;

    @ApiModelProperty("单据类型")
    private String rktype;

    @ApiModelProperty("采购员")
    private String cgy;

    @ApiModelProperty("单据行号")
    private String dj_sort;

    @ApiModelProperty("批号")
    private String ph;

    @ApiModelProperty("数量 decimal")
    private BigDecimal sl;

    @ApiModelProperty("开票日期")
    private String rq;

    @ApiModelProperty("灭菌批号")
    private String mjph;

    @ApiModelProperty("进口药品注册证号")
    private String jkzczh;

}
