package com.prolog.cs.biz.inbound.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description 监管码/防窜码/唯一码记录表 
 * @Author Xiong  
 * @Date 2021-06-16 
 */
@Data
@ApiModel
public class RelationCodeResult implements Serializable {

    private static final long serialVersionUID =  2291818160143936395L;

	@ApiModelProperty(value = "监管码平台返回的批号")
	private String batchNo;

	@ApiModelProperty(value = "监管码平台返回的有效期")
	private Date expireDate;

	@ApiModelProperty(value = "监管码平台返回的生产日期")
	private Date produceDate;

	@ApiModelProperty(value = "监管码平台返回的子码")
	private String code;

	@ApiModelProperty(value = "监管码平台返回的父码")
	private String parentCode;


}
