package com.prolog.cs.biz.inbound.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @Description 监管码/防窜码/唯一码记录表 
 * @Author Xiong  
 * @Date 2021-06-16 
 */
@Data
@ApiModel
public class RelationCodeResultDTO implements Serializable {

    private static final long serialVersionUID =  2291818160143936395L;

	@ApiModelProperty(value = "监管码code")
	private String supervisionCode;

	@ApiModelProperty(value = "查询小码返回信息")
	private String message;

	@ApiModelProperty(value = "查询是否成功表示 1-成功 2-失败")
	private Integer flag;

	@ApiModelProperty(value = "监管码平台返回的关系集合")
	private List<RelationCodeResult> relationCodeResults;


}
