package com.prolog.cs.biz.inbound.dto.print;

import lombok.Data;

import java.io.Serializable;

/**
 * 收货(验收)通知单打印报表头
 * 
 * @author Xiong
 *
 */
@Data
public class RcvLinesHeadPrintDTO implements Serializable {
	private static final long serialVersionUID = 3557749111521296582L;
	// 单据编号
	private String autoBillNum;
	// 采购单号
	private String asnAutoBillNum;
	// 货主
	private String mtlOwnerName;
	// 供货单位(暂定供应商)
	private String vendorName;
	// 供货单位(暂定供应商)
	private String vendorNum;
	// 收货日期
	private String rcvDate;
	// 收货员
	private String executorUser;
	//单据类型
	private String rcvType;
	//采购员
	private String buyerMane;
	//单据类型名称
	private String billType;
}
