package com.prolog.cs.biz.inbound.dto.print;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 收货(验收)通知单明细打印table
 * 
 * @author Xiong
 *
 */
@Data
public class RcvLinesPrintDTO implements Serializable {
	private static final long serialVersionUID = -6746023450751082673L;
	// 商品编号
	private String itemNum;
	// 产品名称
	private String itemName;
	// 规格
	private String specification;
	// 生产厂家
	private String manufacturerName;
	// 数量
	private String pieceQty;
	// 件数
	private String caseQty;
	// 零散
	private String oddPieceQty;
	// 批号
	private String manufacturerLotNum;
	// 生产日期
	private String productionDate;
	// 有效期至
	private String expiredDate;
	// 收货结论
	private String stockStatus;
	// 容器编号
	private String containerCode;
	// 包装含量
	private String conversionRate;
	//剂型
	private String itemHealthType;
	//包装单位
	private String uom;
	//上市许可持有人
	private String itemHealthListedLicensor;

	//产地
	private String productionPlace;

	//批准文号
	private String approvalNumber;

	//到货数量
	private BigDecimal attQty;

	//存储条件
	private String storeTemperature;

	private String isSupervise;

	private String whAreaCategoryCode;

}
