package com.prolog.cs.biz.inbound.dto.rcv;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

@Data
public class EisInStockWmsResponseDetailDTO implements Serializable {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "货主ID")
	private String ownerId;

	@ApiModelProperty(value = "物料ID")
	private String itemId;

	@ApiModelProperty(value = "批次ID")
	private String lotId;

	@ApiModelProperty(value = "包装ID")
	private String packId;

	@ApiModelProperty(value = "入库数量")
	private BigDecimal qty;

	@ApiModelProperty(value = "预留字段1")
	private String attrStr1;

	@ApiModelProperty(value = "预留字段2")
	private String attrStr2;

	@ApiModelProperty(value = "预留字段3")
	private String attrStr3;

	@ApiModelProperty(value = "预留字段4")
	private String attrStr4;

	@ApiModelProperty(value = "预留字段5")
	private String attrStr5;




}
