package com.prolog.cs.biz.inbound.dto.rqc;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description
 * 根据条件获取入库库别
 * @Author liuTao
 * @Date 2022-07-12
 */
@Data
@ApiModel(value ="根据条件获取入库库别")
public class RcvLineParam implements Serializable {
	private static final long serialVersionUID = 5335730467723668610L;

	@ApiModelProperty(value = "企业(id)")
	private String enterpriseId;

	@ApiModelProperty(value = "仓库(id)")
	private String warehouseId;

	@ApiModelProperty(value = "货主id")
	private String mtlOwnerId;

	@ApiModelProperty(value = "数据来源")
	private String dataSource;

	@ApiModelProperty(value = "单据类型")
	private String billType;

	@ApiModelProperty(value = "质量状态")
	private String qualityStatus;

	@ApiModelProperty(value = "单品数量")
	private BigDecimal pieceQty;

	@ApiModelProperty(value = "包装含量")
	private BigDecimal conversionRate;

	@ApiModelProperty(value = "是否异型(0否，1是)")
	private Integer abnormal;
}
