package com.prolog.cs.biz.inbound.dto.rqc;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @Description
 * 根据条件获取入库库别结果集
 * @Author liuTao
 * @Date 2022-07-12
 */
@Data
@ApiModel(value ="根据条件获取入库库别结果集")
public class RcvLineResult implements Serializable {
	private static final long serialVersionUID = 5335730467723668610L;

	@ApiModelProperty(value = "推荐库别(名称)")
	private String warehouseRoomName;

	@ApiModelProperty(value = "推荐库别(code)")
	private String warehouseRoomCode;
}
