package com.prolog.cs.biz.inbound.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description
 * @Date 2021-11-19
 */

@ApiModel
@Data
public class IncomingRecordBackHVO implements Serializable {
	private static final long serialVersionUID = 5958305350431815211L;

	@ApiModelProperty(value = "ID标识")
	private String billid;

	@ApiModelProperty(value = "单据编号")
	private String billno;

	@ApiModelProperty(value = "入库单类型")
	private String billtype;

	@ApiModelProperty(value = "货主ID")
	private String consignorcode;

	@ApiModelProperty(value = "关联采购单号")
	private String refBillno;

	@ApiModelProperty(value = "单位内码")
	private String companyCode;

	@ApiModelProperty(value = "仓库编码")
	private String branchcode;

	@ApiModelProperty(value = "上架员")
	private String saleBy;

	@ApiModelProperty(value = "收货时间")
	private String receiptDate;

	@ApiModelProperty(value = "收货单号")
	private String receiptNo;

	@ApiModelProperty(value = "录入员")
	private String buyerName;

	@ApiModelProperty(value = "录入员")
	private String buyerId;

	@ApiModelProperty(value = "单据日期")
	private String billdate;
}