package com.prolog.cs.biz.inbound.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description
 * @Date 2021-11-19
 */

@ApiModel
@Data
public class OrderStatusBackVO implements Serializable {
	private static final long serialVersionUID = 50135163699565532L;

	@ApiModelProperty(value = "单据ID")
	private String id;

	@ApiModelProperty(value = "企业编码")
	private String tenantCode;

	@ApiModelProperty(value = "状态")
	private String doStatus;

	@ApiModelProperty(value = "承运商ID")
	private String distributionSupplierId;

	@ApiModelProperty(value = "实际出入库时间")
	private String orderOutOfInvTime;

	@ApiModelProperty(value = "运单号")
	private String expressNbr;

	@ApiModelProperty(value = "单据类型")
	private String orderType;

	@ApiModelProperty(value = "货主")
	private String ownerCode;

	@ApiModelProperty(value = "仓库ID")
	private String wareHouseId;

	@ApiModelProperty(value = "总箱数")
	private BigDecimal casesShpd;

	@ApiModelProperty(value = "备注")
	private String notes;

	@ApiModelProperty(value = "冻结原因编码")
	private String holdCode;

	@ApiModelProperty(value = "操作时间")
	private String doOperateTime;

	@ApiModelProperty(value = "核验包装人")
	private String packedBy;

	@ApiModelProperty(value = "扩展属性")
	private String extendProps;

}