package com.prolog.cs.biz.inbound.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

@Data
public class SupervisionCodeVO implements Serializable {
	private static final long serialVersionUID =  6537384287014396743L;

	@ApiModelProperty(value = "【2.RUCKD_NO? 入出库单号】上级单据ID")
	private String refBillId;

	@ApiModelProperty(value = "【RUCKD_NO? 入出库单号】上级单据LINE ID")
	private String refBillLineId;

	@ApiModelProperty(value = "操作人")
	private String userId;

	@ApiModelProperty(value = "当前页数")
	private Integer pageNum;

	@ApiModelProperty(value = "每页行数")
	private Integer pageSize;

	@ApiModelProperty(value = "其他选中行的上级单据ID/上级单据LINE ID")
	private List<SupervisionCodeVO> otherSelectBillList;
}
