package com.prolog.cs.biz.inbound.controller.task;//package com.prolog.cs.biz.inbound.controller.task;

import javax.annotation.Resource;

import com.prolog.cs.biz.inbound.service.task.TaskStraightService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.prolog.cs.biz.inbound.constant.ValidatorGroup.validAdd;
import com.prolog.cs.biz.inbound.dto.task.TaskRejectedDetailDTO;
import com.prolog.cs.biz.inbound.service.task.TaskRejectedDetailService;
import com.prolog.framework.common.message.RestMessage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * @Description // TODO
 * @Date 2021-03-24
 */

@Api(tags = "定时任务自动完成直通入库单据")
@RestController
@RequestMapping("/taskStraight")
public class StraightInboundController {

	@Resource
	private TaskStraightService taskStraightService;

	@ApiOperation("定时任务自动完成直通入库单据")
	@PostMapping("/taskExecute")
	public RestMessage<String> taskExecute(){
        taskStraightService.taskExecute();
        return RestMessage.newInstance(true, "操作成功", null);
	}

}
