package com.prolog.cs.biz.inbound.dao;

import com.prolog.cs.biz.inbound.model.IncomingRecordD;
import com.prolog.cs.biz.inbound.vo.IncomingRecordQueryVO;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @Description  
 * @Date 2021-11-19 
 */
public interface IncomingRecordDMapper extends BaseMapper<IncomingRecordD> {

	List<IncomingRecordD> getInsertData(IncomingRecordQueryVO vo);

	List<Map<String,Object>> getSyncErpDataInfo(@Param("rcvHeaderId") String rcvHeaderId);

}
