package com.prolog.cs.biz.inbound.dao;

import com.prolog.cs.biz.inbound.model.IncomingRecordD;
import com.prolog.cs.biz.inbound.model.ReceivingRecordBackD;
import com.prolog.cs.biz.inbound.vo.IncomingRecordQueryVO;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @Description  
 * @Date 2021-11-19 
 */
public interface ReceivingRecordBackDMapper extends BaseMapper<ReceivingRecordBackD> {

	List<ReceivingRecordBackD> getRcvInsertData(@Param("rcvHeaderId") String rcvHeaderId);

	List<ReceivingRecordBackD> getRqcInsertData(@Param("rqcHeaderId") String rqcHeaderId);
}
