package com.prolog.cs.biz.inbound.dao.task;

import com.prolog.cs.biz.inbound.dto.rcv.RcvHDTO;
import com.prolog.cs.biz.inbound.dto.task.TaskQcRecheckDetailDTO;
import com.prolog.cs.biz.inbound.model.task.TaskQcRecheckDetail;
import com.prolog.cs.biz.inbound.vo.RcvQueryVO;
import com.prolog.cs.biz.inbound.vo.task.TaskQcDetailQueryVO;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @Description  
 * @Date 2021-03-24 
 */
public interface TaskQcRecheckDetailMapper extends BaseMapper<TaskQcRecheckDetail> {

	List<TaskQcRecheckDetailDTO> findList(TaskQcDetailQueryVO taskQcDetailQueryVO);

	List<RcvHDTO> extractRcvHWithNativeSql(RcvQueryVO rcvQueryVO);

	Long updatePreNodeLineId(@Param("taskId")String taskId,@Param("userName") String userName);

}
