package com.prolog.cs.biz.inbound.flow;

import com.prolog.function.annotation.Flow;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;


@Service
public class AsnQueryFlow {

    @PostConstruct
    public void initFunctions() {
        
    }

    @Flow(name = "查询asn头表", category = "root/收货/提取asn表,明细/查询asn头表", index = 10, description = "控制点:"
            + "\n1. ans单状态 20 "
            + "\n2. asn单订单未过期"
            + "\n3. 排除货主转换的"
            + "\n4. 订单的剩余总量大于0的"
            + "\n5. 需要关联仓库,货主,供应商,客户,账期类型等等转义数据")
    public void queryHead() {
        
        
        return;
    }

    @Flow(name = "查询asn单明细", category = "root/收货/提取asn表,明细/查询asn明细", index = 11, description = "控制点:"
            + "\n1. 注意剩余待收的数量需要大于0"
            + "\n2. 和商品,字典表等关联转义前端所需的字段")
    public void queryDetails() {
    }
}