package com.prolog.cs.biz.inbound.remote;

import com.prolog.cs.data.exchange.client.core.EtlMessage;
import com.prolog.framework.common.message.RestMessage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(value = "${prolog.service.dataExchange}")
public interface DataExchangeRemoteCaller {

//	@ApiOperation("手动回传数据")
	@PostMapping("data/callBack")
//	@ApiParam(value="{'id':'回传的id','etlType':'回传类型','etlData':{额外map数据}}")
	public RestMessage<String> callBack(@RequestBody EtlMessage etl) throws Exception;
}
