package com.prolog.cs.biz.inbound.service.impl.eis;

import com.prolog.cs.biz.inbound.service.MqInBoundProducer;
import com.prolog.entity.vo.ContainerTailgatingRequestVO;
import com.prolog.entity.vo.InBoundRequestVO;
import com.prolog.inte.EisHandler;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Slf4j
@Service
public class EisInBoundHandler implements EisHandler {

    @Resource
    private MqInBoundProducer producer;

    @Override
    public void inBoundRequest(List<InBoundRequestVO> list) {
        producer.inBoundRequest(list);
    }

    @Override
    public void containerTailgatingRequest(List<ContainerTailgatingRequestVO> list) {
        producer.containerTailgatingRequest(list);
    }



}
