package com.prolog.cs.biz.inbound.service.impl.rcv;

import com.alibaba.fastjson.JSON;
import com.netflix.hystrix.strategy.concurrency.HystrixRequestContext;
import com.prolog.cs.biz.inbound.dto.rcv.RcvDTO;
import com.prolog.cs.biz.inbound.remote.BaseItemRemoteCaller;
import com.prolog.cs.biz.inbound.remote.ChainRemoteCaller;
import com.prolog.framework.authority.util.HystrixVarUtil;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.context.web.WebAppConfiguration;

import java.util.HashSet;
import java.util.Set;

@RunWith(SpringRunner.class)
@SpringBootTest
@WebAppConfiguration 
public class RcvHeadersServiceImplTest { 

    @Autowired
    private RcvHeadersServiceImpl RcvHeadersServiceImpl;

    @Autowired
    private ChainRemoteCaller ChainRemoteCaller;

    @Autowired
    private com.prolog.cs.biz.inbound.remote.BaseItemRemoteCaller BaseItemRemoteCaller;
    
    @Before
    public void before() throws Exception { 
        HystrixRequestContext context = HystrixRequestContext.initializeContext();
        HystrixVarUtil.setUserKey("kzywms-admin");
    } 
    
    @After
    public void after() throws Exception { 
    } 

    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findByPkId()));
    public void testFindByPkId() throws Exception {
        Set<String> itmeIds=new HashSet<>();
        itmeIds.add("0000128829");
        System.out.println(JSON.toJSONString(BaseItemRemoteCaller.getListByIds(itmeIds)));
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.addWithRelated()));
    public void testAddWithRelated() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.addWithRelatedTemp()));
    public void testAddWithRelatedTemp() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findWithRelatedTemp()));
    public void testFindWithRelatedTemp() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findItemWithRelatedTemp()));
    public void testFindItemWithRelatedTemp() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.bean2map()));
    public void testBean2map() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findWithRelatedTempPage()));
    public void testFindWithRelatedTempPage() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findWithRelatedTempById()));
    public void testFindWithRelatedTempById() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findListWithProfile()));
    public void testFindListWithProfile() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findList()));
    public void testFindList() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findById()));
    public void testFindById() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.add()));
    public void testAdd() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.edit()));
    public void testEdit() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.delIds()));
    public void testDelIds() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.deletePkId()));
    public void testDeletePkId() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.batchAdd()));
    public void testBatchAdd() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.batchEdit()));
    public void testBatchEdit() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findAll()));
    public void testFindAll() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.editWithRelated()));
    public void testEditWithRelated() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.batchAddWithRelated()));
    public void testBatchAddWithRelated() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.batchEditWithRelated()));
    public void testBatchEditWithRelated() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.submitConclusion()));
    public void testSubmitConclusion() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.findListWithPro()));
    public void testFindListWithPro() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getRcvPrintData()));
    public void testGetRcvPrintData() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getRcvItemLotNum()));
    public void testGetRcvItemLotNum() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.vaildateRcvItemLotNum()));
    public void testVaildateRcvItemLotNum() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.vaildateRcvComplete()));
    public void testVaildateRcvComplete() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.vaildateRcvSplit()));
    public void testVaildateRcvSplit() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportHeader()));
    public void testGetReportHeader() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportRcvLine()));
    public void testGetReportRcvLine() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportRqcLine()));
    public void testGetReportRqcLine() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportRqcReLine()));
    public void testGetReportRqcReLine() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportRejectLine()));
    public void testGetReportRejectLine() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportExceptionLine()));
    public void testGetReportExceptionLine() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.getReportInstockLine()));
    public void testGetReportInstockLine() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.testGetRcvNO()));
    public void testTestGetRcvNO() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.lockBill()));
    public void testLockBill() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.cargoChangeIn()));
    public void testCargoChangeIn() throws Exception { 
        
    } 
    @Test//System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.cargoChangeInBillInfo()));
    public void testCargoChangeInBillInfo() throws Exception { 
        
    }

    @Test
    public void testAddWithRelated1() {
        String s="{\"rcvHeadersDTO\":{\"srcWarehouseId\":\"\",\"pieceQty\":\"1\",\"caseQty\":\"1\",\"warehouseId\":\"599581702716788736\",\"orgnId\":\"K23LYW6FBF0\",\"vendorId\":\"\",\"mtlOwnerId\":\"E23A4BUUPPW\",\"srcBillType\":\"\",\"srcHeaderId\":\"\",\"categoryId\":\"\",\"shipperZjm\":\"SXKYZYYXGS\",\"warehouseName\":\"曲靖仓\",\"asnHeaderId\":\"DZ1016\",\"asnAutoBillNum\":\"DZ1016\",\"autoBillNum\":\"1647936121286\",\"rcvType\":\"1\",\"refBilltype\":\"\",\"needDept\":\"K23LYW6FBF0\",\"needUser\":\"蒋建勤\",\"agent\":\"\",\"vendorName\":\"\",\"customBillNum\":\"\",\"department\":\"K23LYW6FBF0\",\"shipArriveTime\":\"Invalid date\",\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"srcAutoBillNum\":\"DZ1016\",\"buyerMane\":\"徐艳丽\",\"rcvDate\":\"2022-03-22 15:53:54\",\"asnRemark\":\"\",\"arrivalMode\":\"2\",\"executorUser\":\"昆中药WMS管理员\",\"comments\":\"\",\"inventoryOpType\":\"0\",\"status\":1},\"rcvHeadersProfilesDTO\":{\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"pieceQty\":0,\"itemCategoryCode\":null,\"shipArriveTime\":\"\",\"vendorCode\":null,\"remainqty\":48,\"saleBillNo\":\"DZ1016\",\"SHIPMENT_TOWN_NO\":null,\"needUser\":\"蒋建勤\",\"asnAutoBillNum\":\"DZ1016\",\"mtlOwnerNum\":\"E23A4BUUPPW\",\"saleBillType\":null,\"CARRIER_ID\":null,\"BRANCHID\":\"599581702716788736\",\"srcBillId\":\"DZ1016\",\"rcvType\":\"1\",\"shipperid\":\"S1YB7IX4YRG\",\"SHIPMENT_ADDRESS\":null,\"orgnId\":\"K23LYW6FBF0\",\"orgnNum\":null,\"SHIPMENT_COUNTRY_NAME\":null,\"TOT_VOLUME\":0,\"CREATEDATE\":\"2021-08-09 19:55:01\",\"buyerMane\":\"徐艳丽\",\"srcBillType\":null,\"customerName\":null,\"LASTMODIFYBY\":null,\"SHIPMENT_CITY_NO\":null,\"warehouseId\":\"599581702716788736\",\"returnType\":\"暂无\",\"BRANCHAREAID\":null,\"CONSIGNORID\":\"E23A4BUUPPW\",\"warehouseAreaCode\":null,\"SHIPPERNAME\":\"昆明量康经贸有限公司\",\"shipFromAdd\":\"暂无\",\"asnHeaderId\":\"DZ1016\",\"SHIPMENT_DISTRICT_NAME\":null,\"warehouseName\":\"曲靖仓\",\"ATTAIN_DATE\":null,\"bizUser\":\"徐艳丽\",\"billid\":\"DZ1016\",\"customerId\":null,\"REMARK\":null,\"auditDate\":null,\"onPassageDays\":0,\"SHIP_LINE_ID\":null,\"mtlOwnerId\":\"E23A4BUUPPW\",\"needDept\":\"K23LYW6FBF0\",\"srcAutoBillNum\":\"DZ1016\",\"SHIPMENT_DISTRICT_NO\":null,\"BRANCH_ADDRESS\":null,\"transportationParty\":\"暂无\",\"caozy\":null,\"caseQty\":0,\"CREATEBY\":\"SYSTEM\",\"DELIVERER_CONTACT_TEL\":\"无\",\"buyerNum\":null,\"enterpriseId\":\"106\",\"EXAMINE_STATE\":null,\"agent\":null,\"CLOSED_REASON\":null,\"SHIPMENT_COUNTRY_NO\":null,\"SHIPMENT_COMMUNITY_NO\":null,\"taTe\":null,\"vendorId\":null,\"shipperType\":\"2\",\"STATUS\":\"20\",\"carrierName\":null,\"SHIPMENT_PROVINCE_NAME\":null,\"LASTMODIFYDATE\":null,\"orgName\":\"K23LYW6FBF0\",\"customerNum\":null,\"billDate\":\"2022-03-01 00:00:00\",\"vendorName\":null,\"SHIPPERCODE\":\"GSIXAPF010\",\"asnRemark\":null,\"ROW_ID\":5,\"shipType\":\"11\",\"shipFromDate\":\"2022-03-22\",\"BILLNO\":\"DZ1016\",\"carriername\":\"12\",\"warehouseCode\":\"C002\",\"arrivalMode\":\"2\",\"TOT_WEIGHT\":0,\"BILL_DATE\":\"2022-03-01 00:00:00\",\"department\":\"K23LYW6FBF0\",\"P_ENTERPRISENAME\":\"昆中药\",\"shipperZjm\":\"SXKYZYYXGS\",\"SHIPMENT_TOWN_NAME\":null,\"SHIPMENT_COMMUNITY_NAME\":null,\"SHIPMENT_PROVINCE_NO\":null,\"PRIORITY_LEVEL\":null,\"expirationdate\":\"2022-08-08\",\"SHIPMENT_CITY_NAME\":null,\"executorUser\":null,\"taTi\":null,\"RT_REASON\":null,\"_row_count\":5,\"rcvHeaderId\":\"\",\"srcMtlOwnerName\":\"\",\"srcMtlOwnerNum\":\"\",\"deliveryMan\":\"\",\"deliveryNum\":\"\",\"deliveryDate\":\"\",\"tempcontrolMode\":\"\",\"deviceNo\":\"\",\"shipTemPerature\":\"\",\"shipArriveTemPerature\":\"\",\"tempcontrolStatus\":\"\"},\"rcvHeadersSrcBillsDTOList\":[{\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"pieceQty\":0,\"itemCategoryCode\":null,\"shipArriveTime\":null,\"vendorCode\":null,\"remainqty\":48,\"saleBillNo\":\"DZ1016\",\"SHIPMENT_TOWN_NO\":null,\"needUser\":\"蒋建勤\",\"asnAutoBillNum\":\"DZ1016\",\"mtlOwnerNum\":\"E23A4BUUPPW\",\"saleBillType\":null,\"CARRIER_ID\":null,\"BRANCHID\":\"599581702716788736\",\"srcBillId\":\"DZ1016\",\"rcvType\":\"1\",\"shipperid\":\"S1YB7IX4YRG\",\"SHIPMENT_ADDRESS\":null,\"orgnId\":\"K23LYW6FBF0\",\"orgnNum\":null,\"SHIPMENT_COUNTRY_NAME\":null,\"TOT_VOLUME\":0,\"CREATEDATE\":\"2021-08-09 19:55:01\",\"buyerMane\":\"徐艳丽\",\"srcBillType\":null,\"customerName\":null,\"LASTMODIFYBY\":null,\"SHIPMENT_CITY_NO\":null,\"warehouseId\":\"599581702716788736\",\"returnType\":\"暂无\",\"BRANCHAREAID\":null,\"CONSIGNORID\":\"E23A4BUUPPW\",\"warehouseAreaCode\":null,\"SHIPPERNAME\":\"昆明量康经贸有限公司\",\"shipFromAdd\":\"暂无\",\"asnHeaderId\":\"DZ1016\",\"SHIPMENT_DISTRICT_NAME\":null,\"warehouseName\":\"曲靖仓\",\"ATTAIN_DATE\":null,\"bizUser\":\"徐艳丽\",\"billid\":\"DZ1016\",\"customerId\":null,\"REMARK\":null,\"auditDate\":null,\"onPassageDays\":0,\"SHIP_LINE_ID\":null,\"mtlOwnerId\":\"E23A4BUUPPW\",\"needDept\":\"K23LYW6FBF0\",\"srcAutoBillNum\":\"DZ1016\",\"SHIPMENT_DISTRICT_NO\":null,\"BRANCH_ADDRESS\":null,\"transportationParty\":\"暂无\",\"caozy\":null,\"caseQty\":0,\"CREATEBY\":\"SYSTEM\",\"DELIVERER_CONTACT_TEL\":\"无\",\"buyerNum\":null,\"enterpriseId\":\"106\",\"EXAMINE_STATE\":null,\"agent\":null,\"CLOSED_REASON\":null,\"SHIPMENT_COUNTRY_NO\":null,\"SHIPMENT_COMMUNITY_NO\":null,\"taTe\":null,\"vendorId\":null,\"shipperType\":\"2\",\"STATUS\":\"20\",\"carrierName\":null,\"SHIPMENT_PROVINCE_NAME\":null,\"LASTMODIFYDATE\":null,\"orgName\":\"K23LYW6FBF0\",\"customerNum\":null,\"billDate\":\"2022-03-01 00:00:00\",\"vendorName\":null,\"SHIPPERCODE\":\"GSIXAPF010\",\"asnRemark\":null,\"ROW_ID\":5,\"shipType\":null,\"shipFromDate\":null,\"BILLNO\":\"DZ1016\",\"carriername\":null,\"warehouseCode\":\"C002\",\"arrivalMode\":\"2\",\"TOT_WEIGHT\":0,\"BILL_DATE\":\"2022-03-01 00:00:00\",\"department\":\"K23LYW6FBF0\",\"P_ENTERPRISENAME\":\"昆中药\",\"shipperZjm\":\"SXKYZYYXGS\",\"SHIPMENT_TOWN_NAME\":null,\"SHIPMENT_COMMUNITY_NAME\":null,\"SHIPMENT_PROVINCE_NO\":null,\"PRIORITY_LEVEL\":null,\"expirationdate\":\"2022-08-08\",\"SHIPMENT_CITY_NAME\":null,\"executorUser\":null,\"taTi\":null,\"RT_REASON\":null,\"_row_count\":5,\"srcHeaderType\":\"\",\"rcvDate\":\"2022-03-22 15:53:54\"}],\"rcvLinesDTOList\":[{\"commonName\":\"*\",\"itemVolume\":0,\"itemHealthProduceLicense\":null,\"pieceConversionRate\":300,\"pieceQty\":24,\"shelfStockCount\":4845,\"manufacturerName\":\"莱阳市江波制药有限责任公司\",\"preQty\":48,\"showProductionDate\":\"20210726\",\"itemZjm\":\"SLFSNLDKYZSY\",\"isCaseOrPiece\":1,\"srcLineId\":null,\"registerNbrEn\":null,\"allowDecimal\":\"-\",\"ITEM_HEALTH_CATEGORY\":\"001\",\"itemHealthListedLicensor\":\"莱阳市江波制药有限责任公司\",\"itemName\":\"非洛地平缓释片\",\"uom\":\"盒\",\"recordNbr\":null,\"manufacturerLotNum\":\"2107262\",\"isBacteria\":0,\"manufactureCode\":null,\"remainStackStockCount\":2116,\"asnAutoBillNum\":\"DZ1016\",\"ID\":\"DZ1016\",\"BRANCHID\":\"599581702716788736\",\"tempControlScope\":null,\"itemIsUnpack\":1,\"isRetrospect\":1,\"itemBarcode\":\"\",\"freeQty\":0,\"ITEM_HEALTH_CATEGORY_NAME\":\"普通药品\",\"isInstrument\":0,\"productionPlace\":\"莱阳市经济开发区隆茂街中段\",\"barCode\":null,\"poAuditOpinion\":\"N/A\",\"rejectQty\":0,\"itemId\":\"0021266968\",\"receivedQty\":0,\"itemIsSpecial\":0,\"warehouseId\":\"599581702716788736\",\"stackStockCount\":320,\"shelfLifeDays\":720,\"itemHealthStoreCategory\":\"整散分开\",\"itemHealthIsDouble\":\"0\",\"TYPE_NAME\":null,\"qcMode\":null,\"isDelegate\":1,\"isSupervise\":1,\"registerNbr\":\"2020R002325\",\"srcHeaderId\":null,\"pieceBarCode\":null,\"caseConversionRate\":300,\"asnHeaderId\":\"DZ1016\",\"industry\":null,\"batchId\":\"647850900894912516\",\"rcvRtReason\":null,\"categoryName\":\"普通药品\",\"remainShelfStockCount\":1094,\"manufacturer\":\"莱阳市江波制药有限责任公司\",\"isLock\":0,\"itemNum\":\"YCYXN0942\",\"showExpiredDate\":\"20230716\",\"managementExpiredDate\":null,\"itemWeight\":0,\"countryOriginId\":\"莱阳市经济开发区隆茂街中段\",\"oddCaseQty\":0,\"asnLineId\":\"DZ1016\",\"shelfLifeUnit\":\"日\",\"isHosted\":0,\"mtlOwnerId\":\"E23A4BUUPPW\",\"itemIsImported\":0,\"manufacturerId\":null,\"batchNum\":\"647850900894912517\",\"specification\":\"5mg*10片*2板\",\"oddPieceQty\":24,\"categoryCode\":\"001\",\"itemHealthCommonName\":\"*\",\"approvalNumber\":\"国药准字H20103190\",\"conversionRate\":300,\"asnLineRemark\":null,\"piecePriceTi\":0.52,\"itemHealthTwovoteflag\":null,\"storeTemperature\":\"YLZG\",\"piecePriceTe\":1,\"SEQNO\":\"1\",\"itemAssistantCode\":\"FLDPHSP\",\"itemHealthRegisterNbr\":\"2020R002325\",\"batchExpiredDate\":\"2023-07-16 00:00:00\",\"shelfLifeNum\":720,\"inStoreDay\":null,\"itemIsRecheck\":0,\"itemHealthStorenote\":null,\"categoryId\":\"001\",\"batchProductionDate\":\"2021-07-26 00:00:00\",\"_row_count\":1,\"warehouseAreaCodes\":null,\"warehouseAreaCategorys\":null,\"warehouseRoomCodes\":null,\"stockStatus\":\"0\",\"qty\":\"0.08\",\"oldPieceQty\":48,\"bldgId\":\"599581810778836992\",\"rqcReportNo\":\"20211019026\",\"containerCode\":null,\"locatorCode\":null,\"goodsCaseCode\":null,\"rcvReason1\":\"\",\"rcvReason2\":\"\",\"rcvrEason3\":\"\",\"comments\":null,\"whAreaCategory\":null,\"delegationPartyName\":\"云南楚雄天利药业有限公司\",\"operation\":null,\"isDoubleReceive\":null,\"caseBarCode\":null,\"rcvLinesPicDTOList\":null,\"shipperid\":null,\"rcvType\":\"1\",\"locatorName\":null,\"inventoryOpType\":null,\"bldgName\":\"曲靖康桥仓\",\"bldgCode\":\"001\",\"showProductionDateOld\":\"20210726\",\"showExpiredDateOld\":\"20230716\",\"batchProductionDateOld\":\"2021-07-26\",\"batchExpiredDateOld\":\"2023-07-16 00:00:00\",\"manufacturerLotNumOld\":\"2107261\",\"hostLocatorId\":null,\"lineNum\":1,\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"warehouseName\":\"曲靖仓\",\"srcBillType\":\"\",\"rcvLinesProfilesDTO\":{\"commonName\":\"*\",\"itemVolume\":0,\"itemHealthProduceLicense\":null,\"pieceConversionRate\":300,\"pieceQty\":48,\"shelfStockCount\":4845,\"manufacturerName\":\"莱阳市江波制药有限责任公司\",\"preQty\":48,\"showProductionDate\":null,\"itemZjm\":\"SLFSNLDKYZSY\",\"isCaseOrPiece\":1,\"srcLineId\":null,\"registerNbrEn\":null,\"allowDecimal\":\"-\",\"ITEM_HEALTH_CATEGORY\":\"001\",\"itemHealthListedLicensor\":\"莱阳市江波制药有限责任公司\",\"itemName\":\"非洛地平缓释片\",\"uom\":\"盒\",\"recordNbr\":null,\"manufacturerLotNum\":null,\"isBacteria\":0,\"manufactureCode\":null,\"remainStackStockCount\":2116,\"asnAutoBillNum\":\"DZ1016\",\"ID\":\"DZ1016\",\"BRANCHID\":\"599581702716788736\",\"tempControlScope\":null,\"itemIsUnpack\":1,\"isRetrospect\":1,\"itemBarcode\":null,\"freeQty\":0,\"ITEM_HEALTH_CATEGORY_NAME\":\"普通药品\",\"isInstrument\":0,\"productionPlace\":\"莱阳市经济开发区隆茂街中段\",\"barCode\":null,\"poAuditOpinion\":\"N/A\",\"rejectQty\":0,\"itemId\":\"0021266968\",\"receivedQty\":0,\"itemIsSpecial\":0,\"warehouseId\":\"599581702716788736\",\"stackStockCount\":320,\"shelfLifeDays\":720,\"itemHealthStoreCategory\":\"整散分开\",\"itemHealthIsDouble\":0,\"TYPE_NAME\":null,\"qcMode\":null,\"isDelegate\":1,\"isSupervise\":1,\"registerNbr\":\"2020R002325\",\"srcHeaderId\":null,\"pieceBarCode\":null,\"caseConversionRate\":300,\"asnHeaderId\":\"DZ1016\",\"industry\":null,\"batchId\":null,\"rcvRtReason\":null,\"categoryName\":\"普通药品\",\"remainShelfStockCount\":1094,\"manufacturer\":\"莱阳市江波制药有限责任公司\",\"isLock\":0,\"itemNum\":\"YCYXN0942\",\"showExpiredDate\":null,\"managementExpiredDate\":null,\"itemWeight\":0,\"countryOriginId\":\"莱阳市经济开发区隆茂街中段\",\"oddCaseQty\":0,\"asnLineId\":\"DZ1016\",\"shelfLifeUnit\":\"日\",\"isHosted\":0,\"mtlOwnerId\":\"E23A4BUUPPW\",\"itemIsImported\":0,\"manufacturerId\":null,\"batchNum\":null,\"specification\":\"5mg*10片*2板\",\"oddPieceQty\":48,\"categoryCode\":\"001\",\"itemHealthCommonName\":\"*\",\"approvalNumber\":\"国药准字H20103190\",\"conversionRate\":300,\"asnLineRemark\":null,\"piecePriceTi\":0.52,\"itemHealthTwovoteflag\":null,\"storeTemperature\":\"YLZG\",\"piecePriceTe\":1,\"SEQNO\":\"1\",\"itemAssistantCode\":\"FLDPHSP\",\"itemHealthRegisterNbr\":\"2020R002325\",\"batchExpiredDate\":null,\"shelfLifeNum\":720,\"inStoreDay\":null,\"itemIsRecheck\":0,\"itemHealthStorenote\":null,\"categoryId\":\"001\",\"batchProductionDate\":null,\"_row_count\":1,\"warehouseAreaCodes\":null,\"warehouseAreaCategorys\":null,\"warehouseRoomCodes\":null,\"lineNum\":2},\"editFlag\":2},{\"isRetrospect\":1,\"itemNum\":\"YCYXN0942\",\"itemName\":\"非洛地平缓释片\",\"categoryName\":\"普通药品\",\"oddCaseQty\":0,\"oddPieceQty\":24,\"pieceQty\":24,\"bldgId\":\"599581810778836992\",\"manufacturerLotNum\":\"2107261\",\"showProductionDate\":\"20210726\",\"showExpiredDate\":\"20230716\",\"batchProductionDate\":\"2021-07-26 00:00:00\",\"batchExpiredDate\":\"2023-07-16 00:00:00\",\"stockStatus\":\"0\",\"manufacturerName\":\"莱阳市江波制药有限责任公司\",\"productionPlace\":\"莱阳市经济开发区隆茂街中段\",\"specification\":\"5mg*10片*2板\",\"uom\":\"盒\",\"conversionRate\":300,\"piecePriceTi\":0.52,\"rqcReportNo\":\"20211019026\",\"containerCode\":null,\"locatorCode\":null,\"warehouseRoomCodes\":null,\"goodsCaseCode\":null,\"rcvReason1\":\"\",\"rcvReason2\":\"\",\"rcvrEason3\":\"\",\"asnLineRemark\":null,\"comments\":null,\"approvalNumber\":\"国药准字H20103190\",\"storeTemperature\":\"YLZG\",\"itemHealthStoreCategory\":\"整散分开\",\"warehouseAreaCategorys\":null,\"whAreaCategory\":null,\"warehouseAreaCodes\":null,\"itemHealthListedLicensor\":\"莱阳市江波制药有限责任公司\",\"itemHealthRegisterNbr\":\"2020R002325\",\"itemHealthProduceLicense\":null,\"batchNum\":\"647850900894912517\",\"pieceConversionRate\":300,\"itemIsImported\":0,\"isInstrument\":0,\"delegationPartyName\":\"云南楚雄天利药业有限公司\",\"itemId\":\"0021266968\",\"mtlOwnerId\":\"E23A4BUUPPW\",\"itemHealthIsDouble\":\"0\",\"isDoubleReceive\":null,\"qcMode\":null,\"managementExpiredDate\":null,\"itemHealthTwovoteflag\":null,\"industry\":null,\"commonName\":\"*\",\"countryOriginId\":\"莱阳市经济开发区隆茂街中段\",\"caseConversionRate\":300,\"caseBarCode\":null,\"pieceBarCode\":null,\"itemAssistantCode\":\"FLDPHSP\",\"itemVolume\":0,\"itemWeight\":0,\"freeQty\":0,\"warehouseId\":\"599581702716788736\",\"asnHeaderId\":\"DZ1016\",\"asnAutoBillNum\":\"DZ1016\",\"asnLineId\":\"DZ1016\",\"categoryId\":\"001\",\"shelfLifeUnit\":\"日\",\"shelfLifeNum\":720,\"stackStockCount\":320,\"remainStackStockCount\":2116,\"shelfStockCount\":4845,\"remainShelfStockCount\":1094,\"rcvLinesPicDTOList\":null,\"shipperid\":null,\"tempControlScope\":null,\"itemZjm\":\"SLFSNLDKYZSY\",\"isDelegate\":1,\"rcvType\":\"1\",\"locatorName\":null,\"inventoryOpType\":null,\"bldgName\":\"曲靖康桥仓\",\"bldgCode\":\"001\",\"showProductionDateOld\":\"20210726\",\"showExpiredDateOld\":\"20230716\",\"batchProductionDateOld\":\"2021-07-26\",\"batchExpiredDateOld\":\"2023-07-16 00:00:00\",\"manufacturerLotNumOld\":\"2107261\",\"batchId\":\"647850900894912516\",\"qty\":\"0.08\",\"piecePriceTe\":1,\"hostLocatorId\":null,\"isCaseOrPiece\":1,\"_row_count\":2,\"lineNum\":2,\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"warehouseName\":\"曲靖仓\",\"srcBillType\":\"\",\"rcvLinesProfilesDTO\":{\"commonName\":\"*\",\"itemVolume\":0,\"itemHealthProduceLicense\":null,\"pieceConversionRate\":300,\"pieceQty\":48,\"shelfStockCount\":4845,\"manufacturerName\":\"莱阳市江波制药有限责任公司\",\"preQty\":48,\"showProductionDate\":null,\"itemZjm\":\"SLFSNLDKYZSY\",\"isCaseOrPiece\":1,\"srcLineId\":null,\"registerNbrEn\":null,\"allowDecimal\":\"-\",\"ITEM_HEALTH_CATEGORY\":\"001\",\"itemHealthListedLicensor\":\"莱阳市江波制药有限责任公司\",\"itemName\":\"非洛地平缓释片\",\"uom\":\"盒\",\"recordNbr\":null,\"manufacturerLotNum\":null,\"isBacteria\":0,\"manufactureCode\":null,\"remainStackStockCount\":2116,\"asnAutoBillNum\":\"DZ1016\",\"ID\":\"DZ1016\",\"BRANCHID\":\"599581702716788736\",\"tempControlScope\":null,\"itemIsUnpack\":1,\"isRetrospect\":1,\"itemBarcode\":null,\"freeQty\":0,\"ITEM_HEALTH_CATEGORY_NAME\":\"普通药品\",\"isInstrument\":0,\"productionPlace\":\"莱阳市经济开发区隆茂街中段\",\"barCode\":null,\"poAuditOpinion\":\"N/A\",\"rejectQty\":0,\"itemId\":\"0021266968\",\"receivedQty\":0,\"itemIsSpecial\":0,\"warehouseId\":\"599581702716788736\",\"stackStockCount\":320,\"shelfLifeDays\":720,\"itemHealthStoreCategory\":\"整散分开\",\"itemHealthIsDouble\":0,\"TYPE_NAME\":null,\"qcMode\":null,\"isDelegate\":1,\"isSupervise\":1,\"registerNbr\":\"2020R002325\",\"srcHeaderId\":null,\"pieceBarCode\":null,\"caseConversionRate\":300,\"asnHeaderId\":\"DZ1016\",\"industry\":null,\"batchId\":null,\"rcvRtReason\":null,\"categoryName\":\"普通药品\",\"remainShelfStockCount\":1094,\"manufacturer\":\"莱阳市江波制药有限责任公司\",\"isLock\":0,\"itemNum\":\"YCYXN0942\",\"showExpiredDate\":null,\"managementExpiredDate\":null,\"itemWeight\":0,\"countryOriginId\":\"莱阳市经济开发区隆茂街中段\",\"oddCaseQty\":0,\"asnLineId\":\"DZ1016\",\"shelfLifeUnit\":\"日\",\"isHosted\":0,\"mtlOwnerId\":\"E23A4BUUPPW\",\"itemIsImported\":0,\"manufacturerId\":null,\"batchNum\":null,\"specification\":\"5mg*10片*2板\",\"oddPieceQty\":48,\"categoryCode\":\"001\",\"itemHealthCommonName\":\"*\",\"approvalNumber\":\"国药准字H20103190\",\"conversionRate\":300,\"asnLineRemark\":null,\"piecePriceTi\":0.52,\"itemHealthTwovoteflag\":null,\"storeTemperature\":\"YLZG\",\"piecePriceTe\":1,\"SEQNO\":\"1\",\"itemAssistantCode\":\"FLDPHSP\",\"itemHealthRegisterNbr\":\"2020R002325\",\"batchExpiredDate\":null,\"shelfLifeNum\":720,\"inStoreDay\":null,\"itemIsRecheck\":0,\"itemHealthStorenote\":null,\"categoryId\":\"001\",\"batchProductionDate\":null,\"_row_count\":1,\"warehouseAreaCodes\":null,\"warehouseAreaCategorys\":null,\"warehouseRoomCodes\":null,\"lineNum\":2},\"editFlag\":2}]}";
        s="{\"rcvHeadersDTO\":{\"srcWarehouseId\":\"\",\"pieceQty\":\"1\",\"caseQty\":\"1\",\"warehouseId\":\"599581702716788736\",\"orgnId\":\"\",\"vendorId\":\"E23A4BUUPPW-GZL00040414\",\"mtlOwnerId\":\"E23A4BUUPPW\",\"srcBillType\":\"\",\"srcHeaderId\":\"\",\"categoryId\":\"\",\"shipperZjm\":\"\",\"warehouseName\":\"曲靖康桥仓\",\"asnHeaderId\":\"704771165528395776\",\"asnAutoBillNum\":\"704771165528395776\",\"autoBillNum\":\"1648201640795\",\"rcvType\":\"1\",\"refBilltype\":\"\",\"needDept\":\"\",\"needUser\":\"\",\"agent\":\"\",\"vendorName\":\"长春金赛药业有限责任公司\",\"customBillNum\":\"\",\"department\":\"\",\"shipArriveTime\":\"Invalid date\",\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"srcAutoBillNum\":\"\",\"buyerMane\":\"2\",\"rcvDate\":\"2022-03-25 17:45:43\",\"asnRemark\":\"\",\"arrivalMode\":\"1\",\"executorUser\":\"昆中药WMS管理员\",\"comments\":\"\",\"inventoryOpType\":\"0\",\"status\":1},\"rcvHeadersProfilesDTO\":{\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"pieceQty\":480,\"itemCategoryCode\":null,\"shipArriveTime\":\"\",\"vendorCode\":\"GJL100026\",\"remainqty\":480,\"saleBillNo\":null,\"SHIPMENT_TOWN_NO\":null,\"needUser\":null,\"asnAutoBillNum\":\"704771165528395776\",\"mtlOwnerNum\":\"E23A4BUUPPW\",\"saleBillType\":null,\"CARRIER_ID\":null,\"BRANCHID\":\"599581702716788736\",\"srcBillId\":null,\"rcvType\":\"1\",\"shipperid\":\"E23A4BUUPPW-GZL00040414\",\"SHIPMENT_ADDRESS\":null,\"orgnId\":null,\"orgnNum\":null,\"SHIPMENT_COUNTRY_NAME\":null,\"TOT_VOLUME\":0,\"CREATEDATE\":\"2022-03-25 16:30:05\",\"buyerMane\":\"2\",\"srcBillType\":null,\"customerName\":null,\"LASTMODIFYBY\":null,\"SHIPMENT_CITY_NO\":null,\"warehouseId\":\"599581702716788736\",\"returnType\":\"暂无\",\"BRANCHAREAID\":null,\"CONSIGNORID\":\"E23A4BUUPPW\",\"warehouseAreaCode\":null,\"SHIPPERNAME\":\"长春金赛药业有限责任公司\",\"shipFromAdd\":\"暂无\",\"asnHeaderId\":\"704771165528395776\",\"SHIPMENT_DISTRICT_NAME\":null,\"warehouseName\":\"曲靖康桥仓\",\"ATTAIN_DATE\":null,\"bizUser\":\"2\",\"billid\":\"704771165528395776\",\"customerId\":null,\"REMARK\":null,\"auditDate\":null,\"onPassageDays\":0,\"SHIP_LINE_ID\":null,\"mtlOwnerId\":\"E23A4BUUPPW\",\"needDept\":null,\"srcAutoBillNum\":null,\"SHIPMENT_DISTRICT_NO\":null,\"BRANCH_ADDRESS\":null,\"transportationParty\":\"暂无\",\"caozy\":null,\"caseQty\":1,\"CREATEBY\":\"kzywms-admin\",\"DELIVERER_CONTACT_TEL\":null,\"buyerNum\":null,\"enterpriseId\":\"106\",\"EXAMINE_STATE\":null,\"agent\":null,\"CLOSED_REASON\":null,\"SHIPMENT_COUNTRY_NO\":null,\"SHIPMENT_COMMUNITY_NO\":null,\"taTe\":0,\"vendorId\":\"E23A4BUUPPW-GZL00040414\",\"shipperType\":\"2\",\"STATUS\":\"20\",\"carrierName\":null,\"SHIPMENT_PROVINCE_NAME\":null,\"LASTMODIFYDATE\":null,\"orgName\":null,\"customerNum\":null,\"billDate\":null,\"vendorName\":\"长春金赛药业有限责任公司\",\"SHIPPERCODE\":\"GJL100026\",\"asnRemark\":null,\"ROW_ID\":1,\"shipType\":\"11\",\"shipFromDate\":\"2022-03-25\",\"BILLNO\":\"704771165528395776\",\"carriername\":\"12\",\"warehouseCode\":\"C002\",\"arrivalMode\":\"1\",\"TOT_WEIGHT\":0,\"BILL_DATE\":null,\"department\":null,\"P_ENTERPRISENAME\":\"昆药商业\",\"shipperZjm\":null,\"SHIPMENT_TOWN_NAME\":null,\"SHIPMENT_COMMUNITY_NAME\":null,\"SHIPMENT_PROVINCE_NO\":null,\"PRIORITY_LEVEL\":\"2\",\"expirationdate\":\"2022-07-03\",\"SHIPMENT_CITY_NAME\":null,\"executorUser\":null,\"taTi\":0,\"RT_REASON\":null,\"_row_count\":1,\"rcvHeaderId\":\"\",\"srcMtlOwnerName\":\"\",\"srcMtlOwnerNum\":\"\",\"deliveryMan\":\"\",\"deliveryNum\":\"\",\"deliveryDate\":\"\",\"tempcontrolMode\":\"\",\"deviceNo\":\"\",\"shipTemPerature\":\"\",\"shipArriveTemPerature\":\"\",\"tempcontrolStatus\":\"\"},\"rcvHeadersSrcBillsDTOList\":[{\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"pieceQty\":480,\"itemCategoryCode\":null,\"shipArriveTime\":null,\"vendorCode\":\"GJL100026\",\"remainqty\":480,\"saleBillNo\":null,\"SHIPMENT_TOWN_NO\":null,\"needUser\":null,\"asnAutoBillNum\":\"704771165528395776\",\"mtlOwnerNum\":\"E23A4BUUPPW\",\"saleBillType\":null,\"CARRIER_ID\":null,\"BRANCHID\":\"599581702716788736\",\"srcBillId\":null,\"rcvType\":\"1\",\"shipperid\":\"E23A4BUUPPW-GZL00040414\",\"SHIPMENT_ADDRESS\":null,\"orgnId\":null,\"orgnNum\":null,\"SHIPMENT_COUNTRY_NAME\":null,\"TOT_VOLUME\":0,\"CREATEDATE\":\"2022-03-25 16:30:05\",\"buyerMane\":\"2\",\"srcBillType\":null,\"customerName\":null,\"LASTMODIFYBY\":null,\"SHIPMENT_CITY_NO\":null,\"warehouseId\":\"599581702716788736\",\"returnType\":\"暂无\",\"BRANCHAREAID\":null,\"CONSIGNORID\":\"E23A4BUUPPW\",\"warehouseAreaCode\":null,\"SHIPPERNAME\":\"长春金赛药业有限责任公司\",\"shipFromAdd\":\"暂无\",\"asnHeaderId\":\"704771165528395776\",\"SHIPMENT_DISTRICT_NAME\":null,\"warehouseName\":\"曲靖康桥仓\",\"ATTAIN_DATE\":null,\"bizUser\":\"2\",\"billid\":\"704771165528395776\",\"customerId\":null,\"REMARK\":null,\"auditDate\":null,\"onPassageDays\":0,\"SHIP_LINE_ID\":null,\"mtlOwnerId\":\"E23A4BUUPPW\",\"needDept\":null,\"srcAutoBillNum\":\"\",\"SHIPMENT_DISTRICT_NO\":null,\"BRANCH_ADDRESS\":null,\"transportationParty\":\"暂无\",\"caozy\":null,\"caseQty\":1,\"CREATEBY\":\"kzywms-admin\",\"DELIVERER_CONTACT_TEL\":null,\"buyerNum\":null,\"enterpriseId\":\"106\",\"EXAMINE_STATE\":null,\"agent\":null,\"CLOSED_REASON\":null,\"SHIPMENT_COUNTRY_NO\":null,\"SHIPMENT_COMMUNITY_NO\":null,\"taTe\":0,\"vendorId\":\"E23A4BUUPPW-GZL00040414\",\"shipperType\":\"2\",\"STATUS\":\"20\",\"carrierName\":null,\"SHIPMENT_PROVINCE_NAME\":null,\"LASTMODIFYDATE\":null,\"orgName\":null,\"customerNum\":null,\"billDate\":null,\"vendorName\":\"长春金赛药业有限责任公司\",\"SHIPPERCODE\":\"GJL100026\",\"asnRemark\":null,\"ROW_ID\":1,\"shipType\":null,\"shipFromDate\":null,\"BILLNO\":\"704771165528395776\",\"carriername\":null,\"warehouseCode\":\"C002\",\"arrivalMode\":\"1\",\"TOT_WEIGHT\":0,\"BILL_DATE\":null,\"department\":null,\"P_ENTERPRISENAME\":\"昆药商业\",\"shipperZjm\":null,\"SHIPMENT_TOWN_NAME\":null,\"SHIPMENT_COMMUNITY_NAME\":null,\"SHIPMENT_PROVINCE_NO\":null,\"PRIORITY_LEVEL\":\"2\",\"expirationdate\":\"2022-07-03\",\"SHIPMENT_CITY_NAME\":null,\"executorUser\":null,\"taTi\":0,\"RT_REASON\":null,\"_row_count\":1,\"srcHeaderType\":\"\",\"rcvDate\":\"2022-03-25 17:45:43\"}],\"rcvLinesDTOList\":[{\"commonName\":\"*\",\"itemVolume\":null,\"itemHealthProduceLicense\":null,\"pieceConversionRate\":480,\"pieceQty\":480,\"shelfStockCount\":1989,\"manufacturerName\":\"广东省惠州市中药厂有限公司\",\"preQty\":480,\"showProductionDate\":\"20220321\",\"itemZjm\":null,\"isCaseOrPiece\":1,\"srcLineId\":null,\"registerNbrEn\":null,\"allowDecimal\":\"-\",\"ITEM_HEALTH_CATEGORY\":\"001\",\"itemHealthListedLicensor\":\"广东省惠州市中药厂有限公司\",\"itemName\":\"抗骨增生片\",\"uom\":\"瓶\",\"recordNbr\":null,\"manufacturerLotNum\":\"20220322\",\"isBacteria\":0,\"manufactureCode\":null,\"remainStackStockCount\":2184,\"asnAutoBillNum\":\"704771165528395776\",\"ID\":\"704771165578727424\",\"BRANCHID\":\"599581702716788736\",\"tempControlScope\":null,\"itemIsUnpack\":1,\"isRetrospect\":0,\"itemBarcode\":null,\"freeQty\":0,\"ITEM_HEALTH_CATEGORY_NAME\":\"普通药品\",\"isInstrument\":0,\"productionPlace\":\"广东省惠州市仲恺高新区惠环西坑工业区\",\"barCode\":null,\"poAuditOpinion\":\"N/A\",\"rejectQty\":0,\"itemId\":\"0021290608\",\"receivedQty\":0,\"itemIsSpecial\":0,\"warehouseId\":\"599581702716788736\",\"stackStockCount\":507,\"shelfLifeDays\":720,\"itemHealthStoreCategory\":\"整散分开\",\"itemHealthIsDouble\":\"0\",\"TYPE_NAME\":null,\"qcMode\":null,\"isDelegate\":0,\"isSupervise\":0,\"registerNbr\":\"2019R000706\",\"srcHeaderId\":null,\"pieceBarCode\":null,\"caseConversionRate\":480,\"asnHeaderId\":\"704771165528395776\",\"industry\":null,\"batchId\":\"703306151885934592\",\"rcvRtReason\":null,\"categoryName\":\"普通药品\",\"remainShelfStockCount\":6942,\"manufacturer\":\"广东省惠州市中药厂有限公司\",\"isLock\":0,\"itemNum\":\"YCYGK0789\",\"showExpiredDate\":\"20230325\",\"managementExpiredDate\":null,\"itemWeight\":null,\"countryOriginId\":\"广东省惠州市仲恺高新区惠环西坑工业区\",\"oddCaseQty\":1,\"asnLineId\":\"704771165578727424\",\"shelfLifeUnit\":\"日\",\"isHosted\":0,\"mtlOwnerId\":\"E23A4BUUPPW\",\"itemIsImported\":0,\"manufacturerId\":null,\"batchNum\":\"703306151885934593\",\"specification\":\"100片（糖衣片）\",\"oddPieceQty\":1,\"categoryCode\":\"001\",\"itemHealthCommonName\":\"*\",\"approvalNumber\":\"国药准字Z44021879\",\"conversionRate\":480,\"asnLineRemark\":null,\"piecePriceTi\":1,\"itemHealthTwovoteflag\":null,\"storeTemperature\":\"常温\",\"piecePriceTe\":1,\"SEQNO\":\"0\",\"itemAssistantCode\":\"KGZSP\",\"itemHealthRegisterNbr\":\"2019R000706\",\"batchExpiredDate\":\"2023-03-25 00:00:00\",\"shelfLifeNum\":720,\"inStoreDay\":null,\"itemIsRecheck\":0,\"itemHealthStorenote\":null,\"categoryId\":\"001\",\"batchProductionDate\":\"2022-03-21 00:00:00\",\"_row_count\":1,\"warehouseAreaCodes\":null,\"warehouseAreaCategorys\":null,\"warehouseRoomCodes\":null,\"stockStatus\":\"0\",\"qty\":\"1.00\",\"oldPieceQty\":480,\"bldgId\":\"599581810778836992\",\"rqcReportNo\":null,\"containerCode\":null,\"locatorCode\":null,\"goodsCaseCode\":null,\"rcvReason1\":\"\",\"rcvReason2\":\"\",\"rcvrEason3\":\"\",\"comments\":null,\"whAreaCategory\":null,\"delegationPartyName\":null,\"operation\":null,\"isDoubleReceive\":null,\"caseBarCode\":null,\"rcvLinesPicDTOList\":null,\"shipperid\":null,\"rcvType\":\"1\",\"locatorName\":null,\"inventoryOpType\":null,\"bldgName\":\"曲靖康桥仓\",\"bldgCode\":\"001\",\"showProductionDateOld\":\"20220321\",\"showExpiredDateOld\":\"20230325\",\"batchProductionDateOld\":\"2022-03-21\",\"batchExpiredDateOld\":\"2023-03-25 00:00:00\",\"manufacturerLotNumOld\":\"20220322\",\"hostLocatorId\":null,\"lineNum\":1,\"mtlOwnerName\":\"曲靖市康桥医药有限责任公司\",\"warehouseName\":\"曲靖康桥仓\",\"srcBillType\":\"\",\"rcvLinesProfilesDTO\":{\"commonName\":\"*\",\"itemVolume\":null,\"itemHealthProduceLicense\":null,\"pieceConversionRate\":480,\"pieceQty\":480,\"shelfStockCount\":1989,\"manufacturerName\":\"广东省惠州市中药厂有限公司\",\"preQty\":480,\"showProductionDate\":null,\"itemZjm\":null,\"isCaseOrPiece\":1,\"srcLineId\":null,\"registerNbrEn\":null,\"allowDecimal\":\"-\",\"ITEM_HEALTH_CATEGORY\":\"001\",\"itemHealthListedLicensor\":\"广东省惠州市中药厂有限公司\",\"itemName\":\"抗骨增生片\",\"uom\":\"瓶\",\"recordNbr\":null,\"manufacturerLotNum\":\"325\",\"isBacteria\":0,\"manufactureCode\":null,\"remainStackStockCount\":2184,\"asnAutoBillNum\":\"704771165528395776\",\"ID\":\"704771165578727424\",\"BRANCHID\":\"599581702716788736\",\"tempControlScope\":null,\"itemIsUnpack\":1,\"isRetrospect\":0,\"itemBarcode\":null,\"freeQty\":0,\"ITEM_HEALTH_CATEGORY_NAME\":\"普通药品\",\"isInstrument\":0,\"productionPlace\":\"广东省惠州市仲恺高新区惠环西坑工业区\",\"barCode\":null,\"poAuditOpinion\":\"N/A\",\"rejectQty\":0,\"itemId\":\"0021290608\",\"receivedQty\":0,\"itemIsSpecial\":0,\"warehouseId\":\"599581702716788736\",\"stackStockCount\":507,\"shelfLifeDays\":720,\"itemHealthStoreCategory\":\"整散分开\",\"itemHealthIsDouble\":0,\"TYPE_NAME\":null,\"qcMode\":null,\"isDelegate\":0,\"isSupervise\":0,\"registerNbr\":\"2019R000706\",\"srcHeaderId\":null,\"pieceBarCode\":null,\"caseConversionRate\":480,\"asnHeaderId\":\"704771165528395776\",\"industry\":null,\"batchId\":null,\"rcvRtReason\":null,\"categoryName\":\"普通药品\",\"remainShelfStockCount\":6942,\"manufacturer\":\"广东省惠州市中药厂有限公司\",\"isLock\":0,\"itemNum\":\"YCYGK0789\",\"showExpiredDate\":null,\"managementExpiredDate\":null,\"itemWeight\":null,\"countryOriginId\":\"广东省惠州市仲恺高新区惠环西坑工业区\",\"oddCaseQty\":1,\"asnLineId\":\"704771165578727424\",\"shelfLifeUnit\":\"日\",\"isHosted\":0,\"mtlOwnerId\":\"E23A4BUUPPW\",\"itemIsImported\":0,\"manufacturerId\":null,\"batchNum\":null,\"specification\":\"100片（糖衣片）\",\"oddPieceQty\":0,\"categoryCode\":\"001\",\"itemHealthCommonName\":\"*\",\"approvalNumber\":\"国药准字Z44021879\",\"conversionRate\":480,\"asnLineRemark\":null,\"piecePriceTi\":1,\"itemHealthTwovoteflag\":null,\"storeTemperature\":\"常温\",\"piecePriceTe\":1,\"SEQNO\":\"0\",\"itemAssistantCode\":\"KGZSP\",\"itemHealthRegisterNbr\":\"2019R000706\",\"batchExpiredDate\":\"2022-03-23\",\"shelfLifeNum\":720,\"inStoreDay\":null,\"itemIsRecheck\":0,\"itemHealthStorenote\":null,\"categoryId\":\"001\",\"batchProductionDate\":\"2022-03-01\",\"_row_count\":1,\"warehouseAreaCodes\":null,\"warehouseAreaCategorys\":null,\"warehouseRoomCodes\":null,\"lineNum\":1},\"editFlag\":2}]}";
        System.out.println(JSON.toJSONString(RcvHeadersServiceImpl.addWithRelated(JSON.parseObject(s, RcvDTO.class))));
    }

    @Test
    public void findByCompanyId() {
        System.out.println(JSON.toJSONString(ChainRemoteCaller.findByCompanyId("599581702716788736")));
    }
} 
