package com.prolog.upcloud.base.wh.operate.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;
import java.util.Map;

@Data
public class LockStockDTO {
    @ApiModelProperty(value = "锁定原因", required = true)
    @NotEmpty(message = "锁定原因不能为空")
    private String lockreason;
    @ApiModelProperty(value = "锁定明细", required = true)
    @NotEmpty(message = "锁定数量不能为空")
    private Double lockqty;
    @ApiModelProperty(value = "锁定库存行id", required = true)
    @NotEmpty(message = "锁定库存行id不能为空！")
    private String id;
}
