package com.prolog.upcloud.base.wh.operate.enums;

import java.util.Arrays;

/**
 * @author wujunjie
 * @date 2021-05-29
 * @desc 补货业务类型
 */
public enum ReplenishBusinessType {
    /**
     * 紧急
     */
    URGENT,
    /**
     * 主动
     */
    INITIATIVE,
    /**
     * 被动
     */
    PASSIVE,
    /**
     * 波次
     */
    WAVE,
    /**
     * 顺带补货incidentalReplenish
     */
    INCIDENTAL,

    /**
     * 顺带
     */
    INCIDENTALLY;

    public static ReplenishBusinessType get(String type) {
        return Arrays.stream(ReplenishBusinessType.values()).filter(x -> x.name().equals(type)).findFirst().orElse(null);
    }
}
