package com.prolog.upcloud.base.wh.operate.enums;

import lombok.Getter;

/**
 * 移库类型
 *
 * @author 鄢菁KingYan
 * @date 2022/08/03
 */
@Getter
public enum ReplenishMoveFlag {

    UNSHELVE(0, "下架"), PUTAWAY(1, "上架"), DEVICE_UNSHELVE(2, "设备下架"), DEVICE_PUTAWAY(3, "设备上架");

    private final Integer code;
    private final String msg;

    ReplenishMoveFlag(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }
}
