package com.prolog.upcloud.base.wh.operate.model;

import com.prolog.framework.core.annotation.AutoKey;
import com.prolog.framework.core.annotation.Column;
import com.prolog.framework.core.annotation.Id;
import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@ApiModel
@Data
@Table(value = "wms_inv_stock_lock")
public class WmsInvStockLock {
    @ApiModelProperty(value = "ID")
    @Column(value = "id")
    @Id
    @AutoKey(type = AutoKey.TYPE_SNOWFLAKE)
    private String id;

    @ApiModelProperty(value = "库存唯一行号")
    @Column(value = "stockaccno")
    private String stockaccno;
    @ApiModelProperty(value = "锁定原因")
    @Column(value = "lockreason")
    private String lockreason;
    @ApiModelProperty(value = "锁定类型（1自动锁定 2手动锁定）")
    @Column(value = "locktype")
    private String locktype;
    @ApiModelProperty(value = "锁定数量")
    @Column(value = "lockqty")
    private Double lockqty;
    @ApiModelProperty(value = "解锁结论1.合格 2.待质检")
    @Column(value = "unlockres")
    private String unlockres;
    @ApiModelProperty(value = "锁定操作 1 锁定 2解锁")
    @Column(value = "lockoper")
    private String lockoper;
    @ApiModelProperty(value = "创建时间")
    @Column(value = "createdate")
    private Date createdate;
    @ApiModelProperty(value = "创建人")
    @Column(value = "createby")
    private String createby;


}
