package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

@Data
@ApiModel
public class ConfirmStereoVO {

    @ApiModelProperty(value = "ID")
    @NotBlank(message = "id不能为空")
    private String detailId;

    @ApiModelProperty(value = "目标托盘号")
    @NotBlank(message = "请录入目标托盘号")
    private String toContainerCode;

    @ApiModelProperty(value = "实际移位数量")
    @NotNull(message = "请录入移位数量")
    private BigDecimal actQuantity;

}
