package com.prolog.upcloud.base.wh.operate.vo;

import com.prolog.upcloud.base.wh.operate.model.WmsMoveD;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotNull;
import java.util.List;

@Data
public class MoveConfirmVo {

    @ApiModelProperty(value = "移库类型 0：下架、1：WMS上架、2：设备下架 3.设备上架")
    @NotNull(message = "{required}")
    @Range(min = 0, max = 1, message = "{invalid}")
    private Integer moveFlag;

    @ApiModelProperty(value = "子单据")
    //@Size(min = 1, message = "{required}")
    private String[] lineIds;

    @ApiModelProperty(value = "明细清单")
    private List<WmsMoveD> moveDetailList;
}
