package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;

/**
 * @author wujunjie
 * @desc 移库审核参数
 * @date 2021-04-06
 */
@Data
@ApiModel
public class MoveLineIdParamsVO {

    @ApiModelProperty(value = "移库子单ID")
    @Size(min = 1, message = "{required}")
    private String[] lineBillId;
}
