package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

@Data
public class MoveStereoAddVO {

    @ApiModelProperty(value = "托盘号")
    @NotBlank(message = "托盘号不能为空")
    private String containerCode;

    @ApiModelProperty(value = "货主ID")
    @NotBlank(message = "货主ID不能为空")
    private String cargoOwnerId;

    @ApiModelProperty(value = "货主名称")
    @NotBlank(message = "货主名称不能为空")
    private String cargoOwnerName;

    @ApiModelProperty(value = "仓库ID")
    @NotBlank(message = "仓库ID不能为空")
    private String warehouseId;

    @ApiModelProperty(value = "货位编码")
    @NotBlank(message = "货位编码不为空")
    private String locatorCode;

    @ApiModelProperty(value = "货位Id")
    @NotBlank(message = "货位Id不为空")
    private String locatorId;

}
