package com.prolog.upcloud.base.wh.operate.vo;

import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * OMS_STOCK_ADJUSTMENT_RESULT
 *
 * @author
 */
@Data
public class OmsStockAdjustmentResultVO implements Serializable {

    /**
     * 单据编号(WMS发起，WMS单号 ,erp发起，ERP 单号)
     */
    private String billno;

    /**
     * 商品编号
     */
    private String itemcode;
    /**
     * 商品ID
     */
    private String itemid;
    /**
     * 库存数量
     */
    private BigDecimal qty;

    /**
     * 原库存状态
     */
    private String sourceqty;

    /**
     * 新库存状态
     */
    private String newStockStatus;

    /**
     * 改变时间
     */
    private String updateDate;

    /**
     * 批号
     */
    private String lotNo;

    /**
     * 生产日期
     */
    private String pdateFrom;

    /**
     * 有效期至
     */
    private String validUntil;

    /**
     * 货主编码
     */
    private String consignorcode;

    /**
     * 调整原因
     */
    private String resource;

    /**
     * 操作人
     */
    private String informationby;


    /**
     * 调整类型
     */
    private String adjustType;

    /**
     * 备注
     */
    private String remark;

    /**
     * 仓库编码
     */
    private String branchcode;

    /**
     * 企业
     */
    private String penterpriseid;

    private static final long serialVersionUID = -7845812338211114579L;
}
