package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Data
@ApiModel
public class PdaMoveVO {

    @ApiModelProperty("移库单明细编码")
    @NotBlank(message = "{required}")
    @Length(max = 32, message = "{noMoreThan}")
    private String moveLineId;

    @ApiModelProperty("出/入库标志 0 出库 1入库")
    @NotNull(message = "{required}")
    private Integer inOrOut;
}
