package com.prolog.upcloud.base.wh.operate.constant;

/**
 * RabbitMq业务类型
 *
 * @author 鄢菁KingYan
 * @date 2022/05/27
 */
public interface RabbitMqConstant {

    /**
     * 出库任务推送——交换机
     */
    String WMS2EIS_PUSH_TASK_EXCHANGE = "wms2eisPushTaskExchange";
    /**
     * 出库任务推送——队列
     */
    String WMS2EIS_PUSH_TASK_QUEUE = "wms2eisPushTaskQueue";
    /**
     * 出库任务推送——路由键
     */
    String WMS2EIS_PUSH_TASK_ROUTING_KEY = "wms2eisPushTaskRoutingKey";

    //===============================================================
    /**
     * 调作业完成确认——交换机
     */
    String WMS2EIS_FINISH_TASK_EXCHANGE = "wms2eisFinishTaskExchange";
    /**
     * 调作业完成确认——交换机
     */
    String WMS2EIS_FINISH_TASK_EXCHANGE1 = "wms2eisFinishTaskExchange1";
    /**
     * 调作业完成确认——队列
     */
    String WMS2EIS_FINISH_TASK_QUEUE = "wms2eisFinishTaskQueue";

    /**
     * 调作业完成确认——路由键
     */
    String WMS2EIS_FINISH_TASK_ROUTING_KEY = "wms2eisFinishTaskRoutingKey";

    /**
     * 调作业完成确认——路由键
     */
    String WMS2EIS_FINISH_TASK_ROUTING_KEY1 = "wms2eisFinishTaskRoutingKey1";

    //===============================================================

    /**
     * 出库任务推送回告——交换机
     */
    String WMS2EIS_PUSH_TASK_CALLBACK_EXCHANGE = "wms2eisPushTaskCallbackExchange";
    /**
     * 出库任务推送回告——队列
     */
    String WMS2EIS_PUSH_TASK_CALLBACK_QUEUE = "wms2eisPushTaskCallbackQueue";
    /**
     * 出库任务推送回告——路由键
     */
    String WMS2EIS_PUSH_TASK_CALLBACK_ROUTING_KEY = "wms2eisPushTaskCallbackRoutingKey";
    //===============================================================

    /**
     * 盘点审核信息推送——交换机
     */
    String WMS2EIS_INVENTORY_REQUEST_EXCHANGE = "wms2eisInventoryRequestExchange";
    /**
     * 盘点审核信息推送——队列
     */
    String WMS2EIS_INVENTORY_REQUEST_QUEUE = "wms2eisInventoryRequestQueue";
    /**
     * 盘点审核信息推送——路由键
     */
    String WMS2EIS_INVENTORY_REQUEST_ROUTING_KEY = "wms2eisInventoryRequestRoutingKey";

    //===============================================================


    ///**
    // * 出库任务推送——交换机
    // */
    //String WMS2EIS_PUSH_TASK_EXCHANGE = "wms2eisPushTaskExchangeTest";
    ///**
    // * 出库任务推送——队列
    // */
    //String WMS2EIS_PUSH_TASK_QUEUE = "wms2eisPushTaskQueueTest";
    ///**
    // * 出库任务推送——路由键
    // */
    //String WMS2EIS_PUSH_TASK_ROUTING_KEY = "wms2eisPushTaskRoutingKeyTest";
    //
    ////===============================================================
    ///**
    // * 调作业完成确认——交换机
    // */
    //String WMS2EIS_FINISH_TASK_EXCHANGE = "wms2eisFinishTaskExchangeTest";
    ///**
    // * 调作业完成确认——队列
    // */
    //String WMS2EIS_FINISH_TASK_QUEUE = "wms2eisFinishTaskQueueTest";
    //
    ///**
    // * 调作业完成确认——路由键
    // */
    //String WMS2EIS_FINISH_TASK_ROUTING_KEY = "wms2eisFinishTaskRoutingKeyTest";
    ////===============================================================
    //
    ///**
    // * 出库任务推送回告——交换机
    // */
    //String WMS2EIS_PUSH_TASK_CALLBACK_EXCHANGE = "wms2eisPushTaskCallbackExchangeTest";
    ///**
    // * 出库任务推送回告——队列
    // */
    //String WMS2EIS_PUSH_TASK_CALLBACK_QUEUE = "wms2eisPushTaskCallbackQueueTest";
    ///**
    // * 出库任务推送回告——路由键
    // */
    //String WMS2EIS_PUSH_TASK_CALLBACK_ROUTING_KEY = "wms2eisPushTaskCallbackRoutingKeyTest";
    //
    ////===============================================================
    //
    ///**
    // * 盘点审核信息推送——交换机
    // */
    //String WMS2EIS_INVENTORY_REQUEST_EXCHANGE = "wms2eisInventoryRequestExchangeTest";
    ///**
    // * 盘点审核信息推送——队列
    // */
    //String WMS2EIS_INVENTORY_REQUEST_QUEUE = "wms2eisInventoryRequestQueueTest";
    ///**
    // * 盘点审核信息推送——路由键
    // */
    //String WMS2EIS_INVENTORY_REQUEST_ROUTING_KEY = "wms2eisInventoryRequestRoutingKeyTest";

}
