package com.prolog.upcloud.base.wh.operate.dao;

import com.prolog.framework.dao.mapper.BaseMapper;
import com.prolog.upcloud.base.wh.operate.model.WmsStereoD;
import com.prolog.upcloud.base.wh.operate.vo.StereoDtlVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @auther KingYan
 * @create 2022-07-13 18:00:14
 * @describe 合托单明细mapper类
 */
@Mapper
public interface WmsStereoDMapper extends BaseMapper<WmsStereoD> {

    List<StereoDtlVO> getStereoListByContainerCode(@Param("warehouseId") String warehouseId, @Param("containerCode") String containerCode);

    List<WmsStereoD> getListByHeadIds(@Param("headerIds") String[] headerIds);
}
