package com.prolog.upcloud.base.wh.operate.service.impl.eis;

import com.alibaba.fastjson.JSONObject;
import com.prolog.entity.vo.OutBoundRequestVO;
import com.prolog.inte.EisHandler;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.List;

@SpringBootTest
@RunWith(SpringRunner.class)
public class EisOperateHandlerTest {


    @Resource
    private EisHandler handler;

    @Test
    public void outBoundRequest() {

        String msg = warpOutBoundRequest();

        List<OutBoundRequestVO> list = JSONObject.parseArray(msg, OutBoundRequestVO.class);

        handler.outBoundRequest(list);

    }

    private static String warpOutBoundRequest() {
//        String msg = "[{\"groupOrderPolicy\":\"0\",\"msgId\":\"4b4570f2eab041eab858552404e67f55\",\"subList\":[{\"billNo\":\"912088676111093760\",\"businessType\":\"REPLENISH\",\"enterpriseId\":\"891063172566487040\",\"isCheck\":\"0\",\"isMaterial\":\"1\",\"isOver\":\"0\",\"itemId\":\"2155036\",\"lotId\":\"904352619110207488\",\"ownerId\":\"748963439141064888\",\"priority\":0.0,\"qty\":\"1.0000\",\"str1\":\"1\",\"str2\":\"1\",\"taskId\":\"912088677990141952\",\"taskLineId\":\"912088864137547776\",\"wmsLocationCode\":\"MJK\",\"workType\":\"30\"},{\"billNo\":\"912088676111093760\",\"businessType\":\"REPLENISH\",\"enterpriseId\":\"891063172566487040\",\"isCheck\":\"0\",\"isMaterial\":\"1\",\"isOver\":\"0\",\"itemId\":\"2155036\",\"lotId\":\"904352619110207488\",\"ownerId\":\"748963439141064888\",\"priority\":0.0,\"qty\":\"1.0000\",\"str1\":\"1\",\"str2\":\"1\",\"taskId\":\"912088677990141952\",\"taskLineId\":\"912088864141742080\",\"wmsLocationCode\":\"MJK\",\"workType\":\"30\"}],\"warehouseId\":\"891420072483098624\"}]";
//        String msg = "[{\"groupOrderPolicy\":\"4\",\"msgId\":\"61097c4b74e446a1b36c2a4d7fb47f22\",\"subList\":[{\"billNo\":\"911995735338258432\",\"businessType\":\"INV_CONSERVE\",\"companyId\":\"748963439141064888\",\"companyName\":\"\",\"containerNo\":\"954\",\"enterpriseId\":\"891063172566487040\",\"isMaterial\":\"1\",\"ownerId\":\"748963439141064888\",\"priority\":10.0,\"str1\":\"0\",\"str2\":\"0\",\"targetArea\":\"\",\"taskId\":\"\",\"taskLineId\":\"911995736084844544\",\"waveNo\":\"\",\"wmsLocationCode\":\"AGVQX\",\"workType\":\"50\"}],\"warehouseId\":\"891420072483098624\"}]";
        String msg = "[\n" +
                "    {\n" +
                "        \"groupOrderPolicy\": \"4\",\n" +
                "        \"msgId\": \"5e89a6bb2130407b88b18c0260c6da1b\",\n" +
                "        \"subList\":\n" +
                "        [\n" +
                "            {\n" +
                "                \"billNo\": \"911995735338258432\",\n" +
                "                \"businessType\": \"INV_CONSERVE\",\n" +
                "                \"companyId\": \"748963439141064888\",\n" +
                "                \"companyName\": \"\",\n" +
                "                \"containerNo\": \"954\",\n" +
                "                \"enterpriseId\": \"891063172566487040\",\n" +
                "                \"isMaterial\": \"1\",\n" +
                "                \"ownerId\": \"748963439141064888\",\n" +
                "                \"priority\": 10.0,\n" +
                "                \"str1\": \"0\",\n" +
                "                \"str2\": \"0\",\n" +
                "                \"targetArea\": \"\",\n" +
                "                \"taskId\": \"\",\n" +
                "                \"taskLineId\": \"911995736084844544\",\n" +
                "                \"waveNo\": \"\",\n" +
                "                \"wmsLocationCode\": \"AGVZ\",\n" +
                "                \"workType\": \"50\"\n" +
                "            }\n" +
                "        ],\n" +
                "        \"warehouseId\": \"891420072483098624\"\n" +
                "    }\n" +
                "]";
        return msg;
    }
}