package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author cheng.kong
 * @date 2022/7/25   18:08
 */
@Data
public class AssignLocationDto implements Serializable {

    @ApiModelProperty(value = "总数量")
    private BigDecimal sumQty;

    @ApiModelProperty(value = "可指定库存")  //可指定库存数量=可用库存-同企业仓货主同商品批号货位库存状态已指定数量
    private BigDecimal stockQty;

    @ApiModelProperty(value = "包装数量")
    private BigDecimal packagingQty;

    @ApiModelProperty(value = "锁定状态")
    private String lockStatus;

    @ApiModelProperty(value = "库存状态")
    private String stockStatus;

    @ApiModelProperty(value = "批号")
    private String lotNo;

    @ApiModelProperty(value = "生产日期")
    private Date productionDate;

    @ApiModelProperty(value = "有效期至")
    private Date expiredDate;

    @ApiModelProperty(value = "货位编码")
    private String locCode;

    @ApiModelProperty(value = "库区编码")
    private String areaCode;

    @ApiModelProperty(value = "库区名称")
    private String areaName;

    @ApiModelProperty(value = "库别")
    private String locType;

}
