package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
public class InvMoveTaskPrintDto {
    @ApiModelProperty("任务号")
    private String taskId;
    @ApiModelProperty("托盘号")
    private String containerno;
    @ApiModelProperty("运单号")
    private String shipno;
    @ApiModelProperty("订单编号")
    private String billno;
    @ApiModelProperty("创建时间")
    private Date createtime;
    @ApiModelProperty("总数量")
    private Double qty;
    @ApiModelProperty("总件数")
    private Double pcs;
    @ApiModelProperty("打印次数(补货标签)")
    private Double printcount1;
    @ApiModelProperty("打印次数(拣货标签)")
    private Double printcount2;
    @ApiModelProperty("打印次数(创新物流标签)")
    private Double printcount3;
    @ApiModelProperty("打印次数(出库清单)")
    private Double printcount4;
}
