package com.prolog.cs.biz.outbound.model.dto;

import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@ApiModel
@Data
public class MoveTaskPrintQueryDTO {
    @ApiModelProperty(value = "波次id", required = false)
    private String waveId;
    @ApiModelProperty(value = "订单编码", required = false)
    private String billCode;
    @ApiModelProperty(value = "补货任务id", required = true)
    private List<String> moveTaskIds;
    @ApiModelProperty(value = "源建筑物编码", required = false)
    private String srcBldgCode;
    @ApiModelProperty(value = "目的建筑物编码", required = false)
    private String destBldgCode;

    @ApiModelProperty(value = "部门", required = false)
    private String deptName;

    @ApiModelProperty(value = "下架员工", required = false)
    private String outstoreWorkerName;
}
