package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class PreReplenishDto {

    @ApiModelProperty(value = "唯一行id")
    private String lineId;

    @ApiModelProperty(value = "货主")
    private String consignorId;

    @ApiModelProperty(value = "货主")
    private String consignorName;

    @ApiModelProperty(value = "企业id")
    private String enterpriseId;

    @ApiModelProperty(value = "仓id")
    private String branchId;

    @ApiModelProperty(value = "仓编码")
    private String branchCode;

    @ApiModelProperty(value = "仓名称")
    private String branchName;

    @ApiModelProperty(value = "商品id")
    private String itemId;

    @ApiModelProperty(value = "商品编码")
    private String itemCode;

    @ApiModelProperty(value = "商品名称")
    private String itemName;

    @ApiModelProperty(value = "单位因子（包装数量/件数）")
    private BigDecimal conversionRate;

    @ApiModelProperty(value = "单位")
    private String uom;

    @ApiModelProperty(value = "商品大类编码")
    private String typeCode;

    @ApiModelProperty(value = "商品大类名称")
    private String typeName;

    @ApiModelProperty(value = "可补数量")
    private BigDecimal allowableQty;

    @ApiModelProperty(value = "可补件数")
    private BigDecimal allowablePcs;

    @ApiModelProperty(value = "应补数量")
    private BigDecimal shouldQty;

    @ApiModelProperty(value = "应补件数")
    private BigDecimal shouldPcs;

    @ApiModelProperty(value = "库别")
    private String areaCategory;

    @ApiModelProperty(value = "批次")
    private String batchId;

    @ApiModelProperty(value = "批次号")
    private String batchNo;

    @ApiModelProperty(value = "批次号")
    private String batchNum;

    @ApiModelProperty(value = "零货数量")
    private BigDecimal itemOdd;

    @ApiModelProperty(value = "零货库存")
    private BigDecimal lhStcokQty;
}
