package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class RFWholePickOrderDto {
    //RF整件索取出参
    @ApiModelProperty(value = "任务包号")
    private String pickOrderId;
    @ApiModelProperty(value = "任务Id")
    private String pickTaskDId;
    @ApiModelProperty(value = "容器号")
    private String containerCode;
    @ApiModelProperty(value = "商品id")
    private String itemId;
    @ApiModelProperty(value = "商品code")
    private String itemCode;
    @ApiModelProperty(value = "商品名称")
    private String itemName;
    @ApiModelProperty(value = "货位id")
    private String locatorId;
    @ApiModelProperty(value = "货位code")
    private String locatorCode;
    @ApiModelProperty(value = "是否监管")
    private Integer isSupervise;
    @ApiModelProperty(value = "单位因子（包装数量/件数）")
    private BigDecimal conversionRate;
    @ApiModelProperty(value = "商品规格")
    private String itemSpecs;
    @ApiModelProperty(value = "生产厂家")
    private String manufacturer;
    @ApiModelProperty(value = "收货单位(客户)名称")
    private String shipperName;
    @ApiModelProperty(value = "批号")
    private String manufacturerLotNum;
    @ApiModelProperty(value = "有效期至")
    private Date expiredDate;
    @ApiModelProperty(value = "生产日期")
    private Date productionDate;
    @ApiModelProperty(value = "显示有效期至")
    private String expiredDateShow;
    @ApiModelProperty(value = "显示生产日期")
    private String productionDateShow;
    @ApiModelProperty(value = "单据类型")
    private String billType;
    @ApiModelProperty(value = "单据类型")
    private String billTypeStr;
    @ApiModelProperty(value = "计划拣货数量")
    private BigDecimal qty;
    @ApiModelProperty(value = "顺带补货数量")
    private BigDecimal replenishQty;
}
