package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class RePrintWholeBulkDetailDto {
    @ApiModelProperty("拣货明细行id")
    private String pickTaskDId;
    @ApiModelProperty("商品id")
    private String itemId;
    @ApiModelProperty("商品编号")
    private String itemCode;
    @ApiModelProperty("商品名称")
    private String itemName;
    @ApiModelProperty(value = "规格")
    private String itemSpecs;
    @ApiModelProperty("批号")
    private String lotNo;
    @ApiModelProperty("显示有效期至")
    private String expiredDateShow;
    @ApiModelProperty("显示生产日期")
    private String productionDateShow;
    @ApiModelProperty("拣货员")
    private String pickerName;
    @ApiModelProperty("拣货员id")
    private String pickerId;
    @ApiModelProperty("下架货位")
    private String locatorCode;
    @ApiModelProperty("数量")
    private String qty;
    @ApiModelProperty("件数")
    private String pcs;
    @ApiModelProperty("零散数")
    private String odd;
    @ApiModelProperty("产地")
    private String productionPlace;
    @ApiModelProperty("库区编码")
    private String warehouseAreaCode;
    @ApiModelProperty("批次")
    private String batchId;
}
