package com.prolog.cs.biz.outbound.model.dto.faceorder;

import lombok.Data;
import lombok.NoArgsConstructor;

@NoArgsConstructor
@Data
public class JDKdFaceOrderAddDTO {

    /**
     * code : 1000
     * data : {"needRetry":false,"promiseTimeType":1,"transType":1,"waybillNo":"JDV016577003941"}
     * message : 成功
     * mills : 519
     * requestId : 240fea88-ef29-4c04-89df-1726e7a2d377
     * success : true
     */

    private int code;
    private DataBean data;
    private String message;
    private int mills;
    private String requestId;
    private boolean success;

    @NoArgsConstructor
    @Data
    public static class DataBean {
        /**
         * needRetry : false
         * promiseTimeType : 1
         * transType : 1
         * waybillNo : JDV016577003941
         */

        private boolean needRetry;
        private int promiseTimeType;
        private int transType;
        private String waybillNo;
    }
}
