package com.prolog.cs.biz.outbound.model.dto.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class JdBmdFaceOrderAddDto {


    @JsonProperty("packageCode")
    private String packageCode;
    @JsonProperty("waybillCode")
    private String waybillCode;
    @JsonProperty("printData")
    private PrintDataDTO printData;

    @NoArgsConstructor
    @Data
    public static class PrintDataDTO {
        @JsonProperty("waybillCodeLast")
        private String waybillCodeLast;
        @JsonProperty("senderAddress")
        private String senderAddress;
        @JsonProperty("jdInfo")
        private String jdInfo;
        @JsonProperty("senderName")
        private String senderName;
        @JsonProperty("specialMarks")
        private List<String> specialMarks;
        @JsonProperty("targetSortCenterName")
        private String targetSortCenterName;
        @JsonProperty("targetSiteId")
        private Integer targetSiteId;
        @JsonProperty("qrcodeUrl")
        private String qrcodeUrl;
        @JsonProperty("examineFlag")
        private String examineFlag;
        @JsonProperty("weight")
        private String weight;
        @JsonProperty("sourceCrossCode")
        private String sourceCrossCode;
        @JsonProperty("sourceTabletrolleyCode")
        private String sourceTabletrolleyCode;
        @JsonProperty("targetTabletrolleyCode")
        private String targetTabletrolleyCode;
        @JsonProperty("receiverAddress")
        private String receiverAddress;
        @JsonProperty("transportMode")
        private String transportMode;
        @JsonProperty("addedServicesList")
        private List<String> addedServicesList;
        @JsonProperty("waterMark")
        private String waterMark;
        @JsonProperty("targetCrossCode")
        private String targetCrossCode;
        @JsonProperty("waybillCodeFirst")
        private String waybillCodeFirst;
        @JsonProperty("businessOrderId")
        private String businessOrderId;
        @JsonProperty("transportType")
        private String transportType;
        @JsonProperty("packageName")
        private String packageName;
        @JsonProperty("sourceSortCenterName")
        private String sourceSortCenterName;
        @JsonProperty("receiverName")
        private String receiverName;
        @JsonProperty("receiverMobile")
        private String receiverMobile;
        @JsonProperty("senderMobile")
        private String senderMobile;
        @JsonProperty("packageCodeSuffix")
        private String packageCodeSuffix;
        @JsonProperty("roadCode")
        private String roadCode;
        @JsonProperty("aoiCode")
        private String aoiCode;
        @JsonProperty("preSortSiteName")
        private String preSortSiteName;
        @JsonProperty("qrHint")
        private String qrHint;
        @JsonProperty("freshType")
        private String freshType;
        @JsonProperty("packageCode")
        private String packageCode;
        @JsonProperty("waybillCode")
        private String waybillCode;
        @JsonProperty("settleType")
        private String settleType;
    }
}
