package com.prolog.cs.biz.outbound.model.dto.print;

import com.prolog.framework.core.annotation.Column;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

@Data
public class PrintAllVO {

    @NotBlank(message = "企业ID")
    private String enterpriseId;

    @NotBlank(message = "仓")
    private String warehouseId;

    @ApiModelProperty(value = "货主ID")
    @Column(value = "consignorid")
    private String consignorId;

    @ApiModelProperty(value = "条码")
    private String barcode;

    @ApiModelProperty(value = "物流商编码")
    private String carrierCode;

}
