package com.prolog.cs.biz.outbound.model.entity;

import com.prolog.framework.core.annotation.Column;
import com.prolog.framework.core.annotation.Id;
import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description  
 * @Date 2021-03-25 
 */
@Data
@ApiModel
@Table ( value ="wms_invoice_pdf", camelToUnderline = true)
public class InvoicePdfDO implements Serializable {
	private static final long serialVersionUID =  3170912106935625403L;

	@Id
	@ApiModelProperty(value = "唯一行号")
	@Column(value = "id")
	private String id;

	@Id
	@ApiModelProperty(value = "青牛订单号")
	@Column(value = "order_no")
	private String orderNo;

	@ApiModelProperty(value = "pdf路径")
	@Column(value = "pdf_url")
	private String pdfUrl;

	@ApiModelProperty(value = "货主")
	@Column(value = "consignor_id")
	private String consignorId;

	@ApiModelProperty(value = "企业id")
	@Column(value = "enterprise_id")
	private String enterpriseId;

	@ApiModelProperty(value = "仓id")
	@Column(value = "warehouse_id")
	private String warehouseId;

	@ApiModelProperty(value = "创建人")
	@Column(value = "create_by")
	private String createBy;

	@ApiModelProperty(value = "创建时间")
	@Column(value = "create_date")
	private Date createDate;

}
