package com.prolog.cs.biz.outbound.model.tms;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * TMS包裹类
 *
 * @author 鄢菁KingYan
 * @date 2023/10/07
 */
@Data
public class TmsShipBillPackage {
    @ApiModelProperty(value = "订单编号", required = true)
    private String orderNo;
    @ApiModelProperty(value = "订单ID", required = true)
    private String orderId;
    @ApiModelProperty(value = "企业ID", required = true)
    private String enterpriseId;
    @ApiModelProperty(value = "企业名称", required = true)
    private String enterpriseName;
    @ApiModelProperty(value = "仓库编码", required = true)
    private List<TmsShipBillPackageItem> headers;
}