package com.prolog.cs.biz.outbound.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @author cheng.kong
 * @date 2022/7/23   11:44
 */
@Data
public class FreightEnterVo implements Serializable {

    @ApiModelProperty("运单号")
    private String shipNo;

    @ApiModelProperty("货号")
    private String itemNo;

    @ApiModelProperty(value = "客户名称")
    private String customerName;

    @ApiModelProperty(value = "开始出库日期")
    private String outStartDate;

    @ApiModelProperty(value = "结束出库日期")
    private String outEndDate;

    @ApiModelProperty(value = "仓库id")
    private String warehouseId;

    @ApiModelProperty(value = "仓编码")
    private String warehouseCode;

    @ApiModelProperty(value = "仓名称")
    private String warehouseName;

    @ApiModelProperty(value = "企业ID")
    private String enterpriseId;
}
