package com.prolog.cs.biz.outbound.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class ReceiveDoBillDetailVO {
    @ApiModelProperty("行号")
    private String seqNo;
    @ApiModelProperty("单据编号")
    private String billNo;
    @ApiModelProperty("商品名称")
    private String itemName;
    @ApiModelProperty("商品编码")
    private String itemCode;
    @ApiModelProperty("包装单位")
    private String packUnits;
    @ApiModelProperty("商品规格")
    private String itemSpecs;
    @ApiModelProperty("包装数量")
    private String packTypeNum;
    @ApiModelProperty("重量")
    private String itemWeight;
    @ApiModelProperty("体积")
    private String itemVolume;
    @ApiModelProperty("数量")
    private String itemQty;
    @ApiModelProperty("冲红数量")
    private String redQty;
    @ApiModelProperty("发货数量(=整件数量*计量规格+零算数量)")
    private String deliveryQty;
    @ApiModelProperty("销售单价")
    private String price;
    @ApiModelProperty("金额")
    private String amt;
    @ApiModelProperty("折后单价")
    private String discountPrice;
    @ApiModelProperty("折后金额")
    private String discountAmt;
    @ApiModelProperty("批次")
    private String batchNo;
    @ApiModelProperty("批号")
    private String lotNo;
    @ApiModelProperty("灭菌批号")
    private String sterilizationBatchNo;
    @ApiModelProperty("灭菌时间")
    private String sterilizationTime;
    @ApiModelProperty("生产日期")
    private String pdateFrom;
    @ApiModelProperty("有效期至")
    private String validUntil;

    @ApiModelProperty("是否赠品")
    private String isGift;
}
