package com.prolog.cs.biz.outbound.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @author cheng.kong
 * @date 2022/7/25   18:06
 */
@Data
public class StockOutInvoiceOrder implements Serializable {

    @ApiModelProperty(value = "订单编号")
    private String orderNo;

    @ApiModelProperty(value = "是否冲红 0 否 1是")
    private String isReverse;

    @ApiModelProperty(value = "行业线")
    private String industryline;

    @ApiModelProperty(value = "冲红数据")
    private List<StockOutInvoiceReverse> reverseData;

}
