package com.prolog.cs.biz.outbound.model.vo;

import com.prolog.cs.biz.outbound.model.entity.WaveBillDDO;

import java.io.Serializable;
import java.math.BigDecimal;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@ApiModel
@Data
public class WaveBillDVO extends WaveBillDDO implements Serializable {


    private static final long serialVersionUID = -857536457662650662L;
    @ApiModelProperty(value = "整包数")
    private BigDecimal wholeQty;

    @ApiModelProperty(value = "包装单位（包装数量/件数）")
    private BigDecimal packagingUnit;

    @ApiModelProperty(value = "包装数量")
    private BigDecimal packagingQty;

    @ApiModelProperty("批准文号")
    private String itemHealthApprovalNbr;

    @ApiModelProperty("是否监管")
    private Integer itemHealthSuperviseflag;

    @ApiModelProperty(value = "库存数量")
    private BigDecimal stockQty;

    @ApiModelProperty(value = "库存不足数量")
    private BigDecimal unStockQty;

}
