package com.prolog.cs.biz.outbound.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @author cheng.kong
 * @date 2022/8/3   10:45
 */
@Data
public class WaveMonitorPageVO implements Serializable {

    @ApiModelProperty(value = "仓库id")
    private String warehouseId;

    @ApiModelProperty(value="波次号")
    private String waveNo;

    @ApiModelProperty(value = "波次时间")
    private String waveDate;

    @ApiModelProperty(value = "当前第几页", required = true)
    private Integer pageNum;

    @ApiModelProperty(value = "每页条数", required = true)
    private Integer pageSize;
}
