package com.prolog.cs.biz.outbound.model.vo.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

@NoArgsConstructor
@Data
public class DblCancel {


    @JsonProperty("carrierCode")
    private String carrierCode;
    @JsonProperty("params")
    private dblParamsDTO params;

    //德邦物流
    private String transportType;
    private String orderType;

    @NoArgsConstructor
    @Data
    public static class dblParamsDTO {
        @JsonProperty("cancelTime")
        private String cancelTime;
        @JsonProperty("logisticCompanyID")
        private String logisticCompanyID;
        @JsonProperty("logisticID")
        private String logisticID;
        @JsonProperty("mailNo")
        private String mailNo;
        @JsonProperty("remark")
        private String remark;
    }
}
