package com.prolog.cs.biz.outbound.model.vo.faceorder;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class ItemInfoVo{
    @ApiModelProperty(value = "数量")
    private BigDecimal itemQty;

    @ApiModelProperty(value = "商品编码")
    private String itemCode;

    @ApiModelProperty(value = "商品名称")
    private String itemName;

    @ApiModelProperty(value = "件数")
    private BigDecimal itemPcs;

    @ApiModelProperty(value = "体积")
    private BigDecimal itemVolume;

    @ApiModelProperty(value = "重量")
    private BigDecimal itemWeight;

    @ApiModelProperty(value = "批次")
    private String batchNo;

}