package com.prolog.cs.biz.outbound.model.vo.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class JdYyldCancel {


    @JsonProperty("carrierCode")
    private String carrierCode;
    @JsonProperty("params")
    private List<YyldParamsDTO> params;

    @NoArgsConstructor
    @Data
    public static class YyldParamsDTO {
        @JsonProperty("orderNo")
        private String orderNo;
        @JsonProperty("orderId")
        private String orderId;
        @JsonProperty("ownerNo")
        private String ownerNo;
    }
}
