package com.prolog.cs.biz.outbound.model.vo.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class SfCancel {


    @JsonProperty("carrierCode")
    private String carrierCode;
    @JsonProperty("params")
    private SfParamsDTO params;

    //顺丰快运
    private String expressTypeId;

    @NoArgsConstructor
    @Data
    public static class SfParamsDTO {
        @JsonProperty("dealType")
        private Integer dealType;
        @JsonProperty("orderId")
        private String orderId;
        @JsonProperty("totalHeight")
        private Double totalHeight;
        @JsonProperty("totalLength")
        private Double totalLength;
        @JsonProperty("totalVolume")
        private Double totalVolume;
        @JsonProperty("totalWeight")
        private Double totalWeight;
        @JsonProperty("totalWidth")
        private Double totalWidth;
        @JsonProperty("waybillNoInfoList")
        private List<WaybillNoInfoListDTO> waybillNoInfoList;

        @NoArgsConstructor
        @Data
        public static class WaybillNoInfoListDTO {
            @JsonProperty("waybillNo")
            private String waybillNo;
            @JsonProperty("waybillType")
            private Integer waybillType;
        }
    }
}
