package com.prolog.cs.biz.outbound.model.vo.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class YdKyCancel {


    @JsonProperty("carrierCode")
    private String carrierCode;
    @JsonProperty("orders")
    private List<OrdersDTOO> orders;

    @NoArgsConstructor
    @Data
    public static class OrdersDTOO {
        @JsonProperty("waybillCode")
        private String waybillCode;
        @JsonProperty("orderCode")
        private String orderCode;
        @JsonProperty("orderOrigin")
        private Integer orderOrigin;
        @JsonProperty("cancelType")
        private Integer cancelType;
        @JsonProperty("customerCode")
        private String customerCode;
        @JsonProperty("cancelReason")
        private String cancelReason;
        @JsonProperty("cancelReasonCode")
        private String cancelReasonCode;
    }
}
