package com.prolog.cs.biz.outbound.service;

import com.prolog.cs.biz.outbound.model.BillSortRuleVO;
import com.prolog.cs.biz.outbound.model.dto.BillSortRuleDto;

import java.util.List;

/**
 * @author
 * @date 2022/7/22   19:32
 */
public interface BillSortRuleService {

    /**
     * 查询订单排序规则list
     * @param billSortRuleVO
     * @return List<BillSortRuleVO> 排序规则集合
     */
    List<BillSortRuleVO> queryBillSortRuleList(BillSortRuleVO billSortRuleVO);

    /**
     * 保存订单排序规则
     * @param billSortRuleDto billSortRuleDto
     * @return Boolean Boolean
     */
    Boolean saveBillSortRule(BillSortRuleDto billSortRuleDto);
}
