package com.prolog.cs.biz.outbound.dao;

import com.prolog.cs.biz.outbound.model.PickOrder;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface PickOrderMapper extends BaseMapper<PickOrder> {

    List<PickOrder> getPickOrderList(@Param("bldgId")String bldgId,@Param("pickTaskType") Integer pickTaskType,@Param("parames") String parames, @Param("warehouseId")String warehouseId,@Param("status") String status,@Param("operatorCode") String operatorCode);

    PickOrder getPickOrderByPickTaskDId(@Param("pickTaskDId")String pickTaskDId);

    List<PickOrder> getPickOrderListV2(@Param("bldgId")String bldgId,@Param("pickTaskType") Integer pickTaskType,@Param("parames") String parames, @Param("warehouseId")String warehouseId,@Param("status") String status,@Param("operatorCode") String operatorCode,@Param("mjkFlag") String mjkFlag,@Param("billId") String billId);

}
