package com.prolog.cs.biz.outbound.dao;

import com.prolog.cs.biz.outbound.model.entity.WaveDO;
import com.prolog.framework.dao.mapper.BaseMapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface WaveMapper extends BaseMapper<WaveDO> {
    List<WaveDO> getWaveDos(@Param("warehouseId") String warehouseId,
                            @Param("waveId") String waveId,
                            @Param("billCode") String billCode,
                            @Param("consignorId") String consignorId,
                            @Param("status") String status,
                            @Param("type") String type
    );

}
