package com.prolog.cs.base.gsp.enums;

import lombok.Getter;

@Getter
public enum UpkeepTypeEnum {
    UNCLASSIFIED(0, "未分类"), FOCU_SPECIAL_DRUG(1, "重点特殊药品"), FOCU_MANAGE_DRUG(2, "重点专管药品"), FOCU_OTHER_DRUG(3, "重点其他药品"), FOCU_MEDICA_DEVICE(4, "重点医疗器械"), FOCU_NON_DRUG(5, "重点非药品"), GENERAL_DRUG(6, "一般药品"), GENERAL_DEVICE(7, "一般器械"), GENERAL_NON_DRUG(8, "一般非药品");

    private final int code;
    private final String msg;

    UpkeepTypeEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }
}
