package com.prolog.cs.base.gsp.vo;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.util.List;

@Data
public class ErpUnqualifiedLossVo {
    private LossData data;

    @Data
    public static class LossData{
        private List<LossH> bills;
    }


    @Data
    public static class LossH{
        //			"billno": "D0001",
        private String billno;
        //			"billtype": "D0_WKO",
        private String billtype;
        //			"billdate": "2020/4/16",
        private String billdate;
        //			"status": "10",
        private String status;
        //			"bill_cancel": "N",
        private String bill_cancel;
        //			"replan": "N",
        private String replan;
        //			"closedate": "2021/4/16",
        private String closedate;
        //			"businesstype": "WKO",
        private String businesstype;
        //			"customercode": "CST001",
        private String customercode;
        //			"customername": "测试客户",
        private String customername;
        //			"customertel": "12312312312",
        private String customertel;
        //			"delivertype": "",
        private String delivertype;
        //			"shipbillno": "Y00001",
        private String shipbillno;
        //			"prioritylevel": "50",
        private String prioritylevel;
        //			"operator": "张三",
        private String operator;
        //			"confirmer": "李四",
        private String confirmer;
        //			"sumpcs": "2",
        private String sumpcs;
        //			"sumqty": "100",
        private String sumqty;
        //			"sumitems": "2",
        private String sumitems;
        //			"deliver_lxr": "张三",
        private String deliver_lxr;
        //			"deliver_tel": "12312312312",
        private String deliver_tel;
        //			"provna": "湖北省",
        private String provna;
        //			"cityna": "武汉市",
        private String cityna;
        //			"distna": "硚口区",
        private String distna;
        //			"addres": "湖北省武汉市硚口区越秀财富中心24楼",
        private String addres;
        //			"mobile": "12312312312",
        private String mobile;
        //			"teleph": "",
        private String teleph;
        //			"consignor": "TEST001",
        private String consignor;
        //			"consignorname": "测试货主",
        private String consignorname;
        //			"branchid": "W01",
        private String branchid;
        //			"enterpriseid": "E01",
        private String enterpriseid;
        //			"remark": "接口测试单据",
        private String remark;
        //			"whole_flg": "0",
        private String whole_flg;
        //			"wkonum": "WKO001",
        private String wkonum;
        private List<LossD> details;
    }

    @Data
    public static class LossD{
        //                  "billno": "D0001",
        private String billno;
        //					"seqno": "1",
        private String seqno;
        //					"itemcode": "ITM001",
        private String itemcode;
        //					"itemname": "测试商品01",
        private String itemname;
        //					"itembarcode": "ITM001",
        private String itembarcode;
        //					"capacity": "1*10",
        private String capacity;
        //					"fmodel": "TEST",
        private String fmodel;
        //					"packcode": "",
        private String packcode;
        //					"packsize": "50",
        private String packsize;
        //					"pcs": "1",
        private String pcs;
        //					"odd": "0",
        private String odd;
        //					"qty": "50",
        private String qty;
        //					"stockunit": "个",
        private String stockunit;
        //					"refunitqty": "50",
        private String refunitqty;
        //					"refunitname": "个",
        private String refunitname;
        //					"lotno": "P001",
        private String lotno;
        //					"yielddate": "2020/4/16",
        private String yielddate;
        //					"expdate": "2021/4/16",
        private String expdate;
        //					"linestatus": "10",
        private String linestatus;
        //					"refbillno": "",
        private String refbillno;
        //					"refbilllineid": "",
        private String refbilllineid;
        //					"stockstatus": "1",
        private String stockstatus;
        //					"batchrequest": "",
        private String batchrequest;
        //					"invturmode": "",
        private String invturmode;
        //					"iscancel": "0",
        private String iscancel;
        //					"consignor": "TEST001",
        private String consignor;
        //					"consignorname": "测试货主",
        private String consignorname;
        //					"remark": "接口测试行01",
        private String remark;
        //					"wave_flg": "1",
        private String wave_flg;
        //					"prdline": "PRD01",
        private String prdline;
        //					"prdloc": "DSTLOC001",
        private String prdloc;
        //					"onlinedate": "2020/4/20",
        private String onlinedate;
        //					"dstloc": "DSTLOC001",
        private String dstloc;
        //					"onlinetime": "15:00",
        private String onlinetime;
        private List<LossRule> rule;
    }

    @Data
    public static class LossRule{
        //"lotno": "P001",
        private String lotno;
        //						"Supno": "SUP01",
        private String Supno;
        //						"Cnsg_flg": "0"
        private String Cnsg_flg;
    }

    @Override
    public String toString(){
        return JSONObject.toJSONString(this);
    }
}
