package com.prolog.cs.base.gsp.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

@Data
@ApiModel
public class RfGspUpkeepCheckVO implements Serializable {

    private static final long serialVersionUID = 4612011526535896850L;

    @ApiModelProperty(value = "主键ID")
    private String id;

    @ApiModelProperty(value = "仓库ID")
    private String warehouseId;

    @ApiModelProperty(value = "仓库名称")
    private String warehouseName;

    @ApiModelProperty(value = "货主ID")
    private String cargoOwnerId;

    @ApiModelProperty(value = "货主名称")
    private String cargoOwnerName;

    @ApiModelProperty(value = "商品Id")
    private String itemId;

    @ApiModelProperty(value = "商品名称")
    private String itemName;

    @ApiModelProperty(value = "商品编码")
    private String itemCode;

    @ApiModelProperty(value = "库别")
    private String warehouseAreaCategory;

    @ApiModelProperty(value = "库别")
    private String locatorId;

    @ApiModelProperty(value = "货位")
    private String locatorCode;

    @ApiModelProperty(value = "批号")
    private String lotNum;

    @ApiModelProperty(value = "计划养护数量")
    private String planStockQty;
}

