package com.prolog.cs.base.gsp.dao;

import com.prolog.cs.base.gsp.QueryDTO;
import com.prolog.cs.base.gsp.model.DxiGspQualityReviewD;
import com.prolog.cs.base.gsp.vo.GspQualityCheckMoveItemVo;
import com.prolog.cs.base.gsp.vo.GspQualityCheckMoveVo;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Description  
 * @Date 2022-05-27
 */
@Repository
public interface DxiGspQualityReviewDMapper extends BaseMapper<DxiGspQualityReviewD> {


    List<GspQualityCheckMoveVo> findQualityReview4MovePick(@Param("warehouseId")String warehouseId,@Param("cargoOwnerId")String cargoOwnerId,
                                                           @Param("requestBilltype")String requestBilltype, @Param("billno")String billno);

    List<GspQualityCheckMoveItemVo> findQualityReview4MoveItemPick(@Param("billId")String billId);
}
