package com.prolog.cs.base.gsp.dao;

import com.prolog.cs.base.gsp.model.GspUnqualifiedLossD;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Description  
 * @Date 2021-05-10 
 */
@Repository
public interface GspUnqualifiedLossDMapper extends BaseMapper<GspUnqualifiedLossD> {
    
    List<GspUnqualifiedLossD> listPagePick(GspUnqualifiedLossD queryVO);
    
    Long updateDestroyingQty(@Param("id") String id, @Param("destroyingQty") BigDecimal destroyingQty);
    
    Long updateDestroyedQty(@Param("id") String id, @Param("destroyedQty") BigDecimal destroyedQty);

}
