package com.prolog.cs.base.gsp.dao;

import cn.hutool.core.date.DateTime;
import com.prolog.cs.base.gsp.QueryDTO;
import com.prolog.cs.base.gsp.model.GspUpkeepCheck;
import com.prolog.cs.base.gsp.vo.RfGspUpkeepCheckVO;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Description
 * @Date 2021-05-10
 */
@Repository
public interface GspUpkeepCheckMapper extends BaseMapper<GspUpkeepCheck> {
    List<GspUpkeepCheck> findList(QueryDTO queryVO);

    List<RfGspUpkeepCheckVO> findUpkeepPageByRf(QueryDTO queryDTO);

    void updateOutboundInstructById(@Param("ids") List<String> ids, @Param("now") DateTime now);
}
