package com.prolog.cs.base.gsp.resource;

import com.prolog.framework.common.message.RestMessage;
import com.prolog.upcloud.base.wh.operate.dto.ReplenishPassiveDTO;
import com.prolog.upcloud.base.wh.operate.vo.ReplenishPassiveSaveVO;
import com.prolog.upcloud.base.wh.operate.vo.WmsMoveSaveVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(value = "${prolog.service.operate}")
public interface OperateClient {

    /**
     * 新增移库单
     *
     * @param saveVO 被动补货信息
     * @return
     */
    @PostMapping("/move/v1/add")
    public RestMessage addMove(@RequestBody WmsMoveSaveVO saveVO);
}
