package com.prolog.cs.biz.inbound.constant;

/**
 * 常量类
 * 
 * @author Administrator
 *
 */
public class BussinessConstant {
	
	// 默认创建人
	public static final String OMS_CREATEBY = "SYSTEM";

	// 数据字典-采购订单主表状态
	public static final String SYS_REFDATA_OMS_PO_BILL_H_STATUS = "OMS_PO_BILL_H_STATUS";
	// 数据字典-到货方式
	public static final String SYS_REFDATA_ARRIVAL_MODE = "ARRIVAL_MODE";
	// 数据字典-订单紧急等级
	public static final String SYS_REFDATA_PRIORITY_LEVEL = "PRIORITY_LEVEL";
	// 数据字典-运输条件
	public static final String SYS_REFDATA_PUB_TRANSLINE_TRANS_TYPE = "PUB_TRANSLINE_TRANS_TYPE";
	// 数据字典-采购订单明细状态
	public static final String SYS_REFDATA_OMS_PO_BILL_D_STATUS = "OMS_PO_BILL_D_STATUS";
	// 数据字典-销售订单主表状态
	public static final String SYS_REFDATA_OMS_ORDER_BILL_H_STATUS = "OMS_ORDER_BILL_H_STATUS";
	// 数据字典-销售订单明细状态
	public static final String SYS_REFDATA_OMS_ORDER_BILL_D_STATUS = "OMS_ORDER_BILL_D_STATUS";
	// 数据字典-交货单状态
	public static final String SYS_REFDATA_OMS_DO_BILL_STATUS = "OMS_DO_BILL_STATUS";
	// 数据字典-调拨订单状态
	public static final String SYS_REFDATA_OMS_ALLOT_BILL_H_STATUS = "OMS_ALLOT_BILL_H_STATUS";
	// 数据字典-调拨订单明细状态
	public static final String SYS_REFDATA_OMS_ALLOT_BILL_D_STATUS = "OMS_ALLOT_BILL_D_STATUS";
	// 数据字典-库存状态
	public static final String SYS_REFDATA_OMS_STOCK_STATUS = "OMS_STOCK_STATUS";
	// 数据字典-货主转换单状态
	public static final String SYS_REFDATA_OMS_CNS_CONVERSION_STATUS = "OMS_CNS_CONVERSION_STATUS";
	
	// 数据字典-损溢单状态
	public static final String SYS_REFDATA_GSP_GAINSLOSSES_BILL_STATUS = "GSP_GAINSLOSSES_BILL_STATUS";
	// 数据字典-损溢单类型
	public static final String SYS_REFDATA_GSP_GAINSLOSSES_BILL_TYPE = "GSP_GAINSLOSSES_BILL_TYPE";
	// 数据字典-养护计划主表状态
	public static final String SYS_REFDATA_GSP_MAINTENANCE_PLAN_H_STATUS = "GSP_MAINTENANCE_PLAN_H_STATUS";
	// 数据字典-养护计划明细表状态
	public static final String SYS_REFDATA_GSP_MAINTENANCE_PLAN_D_STATUS = "GSP_MAINTENANCE_PLAN_D_STATUS";
	// 数据字典-养护计划养护商品类别
	public static final String SYS_REFDATA_GSP_MAINTENANCE_PLAN_H_ITEM_TYPE = "GSP_MAINTENANCE_PLAN_H_ITEM_TYPE";
	// 数据字典-养护计划执行方式
	public static final String SYS_REFDATA_GSP_MAINTENANCE_PLAN_H_RUN_MODE = "GSP_MAINTENANCE_PLAN_H_RUN_MODE";
	// 数据字典-养护计划来源类型
    public static final String SYS_REFDATA_GSP_MAINTENANCE_PLAN_H_REF_BILLTYPE = "GSP_MAINTENANCE_PLAN_H_REF_BILLTYPE";
    // 数据字典-停售申请单状态
    public static final String SYS_REFDATA_GSP_STOPSELLBILL_STATUS = "GSP_STOPSELLBILL_STATUS";
    // 数据字典-停售申请单类型
    public static final String SYS_REFDATA_GSP_STOPSELLBILL_TYPE = "GSP_STOPSELLBILL_TYPE";
    // 申请复查单据类别
    public static final String SYS_REFDATA_REQUEST_BILLTYPE = "REQUEST_BILLTYPE";
			
	// 单据来源类型分组1(1 ERP对接2 SAP对接3 OMS录入 )
	// 单据来源类型分组2(1 销售订单2 采购退货订单3 调拨订单4 其他出库订单 )
	public static final String REF_BILLTYPE_ERP = "1";
	public static final String REF_BILLTYPE_SAP = "2";
	public static final String REF_BILLTYPE_OMS = "3";
	public static final String REF_BILLTYPE_XSDD = "1";
	public static final String REF_BILLTYPE_CGTHDD = "2";
	public static final String REF_BILLTYPE_DBDD = "3";
	public static final String REF_BILLTYPE_QTCHDK = "4";

	// 采购订单主表状态0 作废10 录入15 异常待处理20 审核25 部分预约30 全部预约99 已过账
	public static final String OMS_PO_BILL_H_STATUS_ZF = "0";
	public static final String OMS_PO_BILL_H_STATUS_LR = "10";
	public static final String OMS_PO_BILL_H_STATUS_YC = "15";
	public static final String OMS_PO_BILL_H_STATUS_SH = "20";
	public static final String OMS_PO_BILL_H_STATUS_BFYY = "25";
	public static final String OMS_PO_BILL_H_STATUS_QBYY = "30";
	public static final String OMS_PO_BILL_H_STATUS_YGZ = "99";

	// 采购订单明细状态0 作废10 录入
	public static final String OMS_PO_BILL_D_STATUS_ZF = "0";
	public static final String OMS_PO_BILL_D_STATUS_LR = "10";

	// 审核状态1 未审核2 审核中3 已通过4 已驳回5 待仲裁
	public static final String AUDIT_STATE_WSH = "1";
	public static final String AUDIT_STATE_SHZ = "2";
	public static final String AUDIT_STATE_YTG = "3";
	public static final String AUDIT_STATE_YBH = "4";
	public static final String AUDIT_STATE_DZC = "5";

	// 销售订单主表状态0 作废10 录入15 异常待处理20 审核25 部分预约30 全部预约 60出库完成 70已发货 80已签收 99 已过账
	public static final String OMS_ORDER_BILL_H_STATUS_ZF = "0";
	public static final String OMS_ORDER_BILL_H_STATUS_LR = "10";
	public static final String OMS_ORDER_BILL_H_STATUS_YC = "15";
	public static final String OMS_ORDER_BILL_H_STATUS_SH = "20";
	public static final String OMS_ORDER_BILL_H_STATUS_BFYY = "25";
	public static final String OMS_ORDER_BILL_H_STATUS_QBYY = "30";
	public static final String OMS_ORDER_BILL_H_STATUS_CKWC = "60";
	public static final String OMS_ORDER_BILL_H_STATUS_YFH = "70";
	public static final String OMS_ORDER_BILL_H_STATUS_YQS = "80";
	public static final String OMS_ORDER_BILL_H_STATUS_YGZ = "99";

	// 销售订单明细状态0 作废10 录入
	public static final String OMS_ORDER_BILL_D_STATUS_ZF = "0";
	public static final String OMS_ORDER_BILL_D_STATUS_LR = "10";

	// 取号标识-采购订单ID
	public static final String CODEENGINE_OMS_PO_BILL_H_BILLID = "OMS_PO_BILL_H_BILLID";
	// 取号标识-采购订单明细ID
	public static final String CODEENGINE_OMS_PO_BILL_D_LINEID = "OMS_PO_BILL_D_LINEID";
	// 取号标识-销售订单ID
	public static final String CODEENGINE_OMS_ORDER_BILL_H_BILLID = "OMS_ORDER_BILL_H_BILLID";
	// 取号标识-销售订单明细ID
	public static final String CODEENGINE_OMS_ORDER_BILL_D_LINEID = "OMS_ORDER_BILL_D_LINEID";
	// 取号标识-交货单ID
	public static final String CODEENGINE_OMS_DO_BILL_H_BILLID = "OMS_DO_BILL_H_BILLID";
	// 取号标识-交货单明细ID
	public static final String CODEENGINE_OMS_DO_BILL_D_LINEID = "OMS_DO_BILL_D_LINEID";
	// 取号标识-ASN单汇总ID
	public static final String CODEENGINE_OMS_ASN_BILL_H_ID = "OMS_ASN_BILL_H_ID";
	// 取号标识-ASN单明细ID
	public static final String CODEENGINE_OMS_ASN_BILL_D_LINEID = "OMS_ASN_BILL_D_LINEID";
	// 取号标识-调拨订单ID
	public static final String CODEENGINE_OMS_ALLOT_BILL_H_BILLID = "OMS_ALLOT_BILL_H_BILLID";
	// 取号标识-调拨订单明细ID
	public static final String CODEENGINE_OMS_ALLOT_BILL_D_LINEID = "OMS_ALLOT_BILL_D_LINEID";
	// 取号标识-库存调整单id
	public static final String CODEENGINE_INV_STOCK_ADJUST_RECORD_ID = "INV_STOCK_ADJUST_RECORD_ID";
	// 取号标识-损溢单ID
	public static final String CODEENGINE_GSP_GAINSLOSSES_BILL_BILLID = "GSP_GAINSLOSSES_BILL_BILLID";
	// 取号标识-养护计划主表ID
	public static final String CODEENGINE_GSP_MAINTENANCE_PLAN_H_BILLID = "GSP_MAINTENANCE_PLAN_H_BILLID";
	// 取号标识-养护计划明细ID
	public static final String CODEENGINE_GSP_MAINTENANCE_PLAN_D_LINEID = "GSP_MAINTENANCE_PLAN_D_LINEID";
	// 取号标识-销毁单ID
    public static final String CODEENGINE_GSP_DESTROY_REQUEST_ID = "GSP_DESTROY_REQUEST_ID";
    // 取号标识-货主转换单ID
    public static final String CODEENGINE_CNS_CONVERSION_ID = "OMS_CNS_CONVERSION_ID";
    // 取号标识-停售申请单ID
    public static final String CODEENGINE_GSP_STOPSELLBILL_ID = "GSP_STOPSELLBILL_ID";
    // 取号标识-质量复查单汇总ID
    public static final String CODEENGINE_GSP_QUALITY_REVIEWH_ID = "GSP_QUALITY_REVIEWH_ID";
    // 取号标识-质量复查单明细ID
    public static final String CODEENGINE_GSP_QUALITY_REVIEWD_ID = "GSP_QUALITY_REVIEWD_ID";
	// 取号标识-盘点损益单ID
	public static final String CODEENGINE_OMS_INVENTORY_ORDER_ID = "OMS_INVENTORY_ORDER_ID";
	// 取号标识-盘点损益单审核ID
	public static final String CODEENGINE_OMS_INVENTORY_AUDIT_ID = "OMS_INVENTORY_AUDIT_ID";
	// 取号标识-批号日期调整单ID
	public static final String CODEENGINE_OMS_LOT_STOCK_ADJUSTMENT_ID = "OMS_LOT_STOCK_ADJUSTMENT_ID";
	// 取号标识-批号日期调整回传单ID
	public static final String CODEENGINE_OMS_LOT_STOCK_ADJUST_RETURN_ID = "OMS_LOT_STOCK_ADJUST_RETURN_ID";
	// 取号标识-运输节点记录ID
    public static final String CODEENGINE_TRANSPORT_NODE_RECORD_ID = "TRANSPORT_NODE_RECORD_ID";
    // 取号标识-运输费用记录ID
    public static final String CODEENGINE_TRANSPORT_COST_ID = "TRANSPORT_COST_ID";
    // 取号标识-电子监管码ID
    public static final String CODEENGINE_SUPERVISION_CODE_ID = "SUPERVISION_CODE_ID";
    // 取号标识-养护记录ID
    public static final String CODEENGINE_MAINTENANCE_RECORD_ID = "MAINTENANCE_RECORD_ID";

	// 单据审核结果类型(11 采购订单12 ASN单13 销售订单14 交货单15 采购退货单16 销售退回单17 调拨订单18 停售申请单19 损溢单20
	// 质量复查单21 销毁单)
	public static final String OMS_AUDIT_TYPE_CGDD = "11";
	public static final String OMS_AUDIT_TYPE_ASND = "12";
	public static final String OMS_AUDIT_TYPE_XSDD = "13";
	public static final String OMS_AUDIT_TYPE_JHD = "14";
	public static final String OMS_AUDIT_TYPE_CGTH = "15";
	public static final String OMS_AUDIT_TYPE_XSTH = "16";
	public static final String OMS_AUDIT_TYPE_DBDD = "17";
	public static final String OMS_AUDIT_TYPE_TSSQ = "18";
	public static final String OMS_AUDIT_TYPE_SYD = "19";
	public static final String OMS_AUDIT_TYPE_ZLFC = "20";
	public static final String OMS_AUDIT_TYPE_XHD = "21";

	// 单据审核结果状态0 作废10 录入
	public static final String OMS_AUDIT_STATUS_ZF = "0";
	public static final String OMS_AUDIT_STATUS_LR = "10";

	// ASN单主状态 0-作废 10-录入 15 异常待处理 20-审核 25-已预约 30-已经进场 40-开始收货 60-全部到货 70-上架完成
	// 90已下发 99-已过账
	public static final String OMS_ASN_BILL_H_STATUS_ZF = "0";
	public static final String OMS_ASN_BILL_H_STATUS_LR = "10";
	public static final String OMS_ASN_BILL_H_STATUS_YC = "15";
	public static final String OMS_ASN_BILL_H_STATUS_SH = "20";
	public static final String OMS_ASN_BILL_H_STATUS_YY = "25";
	public static final String OMS_ASN_BILL_H_STATUS_JC = "30";
	public static final String OMS_ASN_BILL_H_STATUS_SS = "40";
	public static final String OMS_ASN_BILL_H_STATUS_DH = "60";
	public static final String OMS_ASN_BILL_H_STATUS_SJ = "70";
	public static final String OMS_ASN_BILL_H_STATUS_YXF = "90";
	public static final String OMS_ASN_BILL_H_STATUS_GZ = "99";

	// ASN单明细状态 0-作废 10-录入 90已下发
	public static final String OMS_ASN_BILL_D_STATUS_ZF = "0";
	public static final String OMS_ASN_BILL_D_STATUS_LR = "10";
	public static final String OMS_ASN_BILL_D_STATUS_YXF = "10";

	// ASN单审核状态1 未审核 2 已驳回 3 已通过 4 待仲裁 5 已仲裁
	public static final String OMS_ASN_BILL_H_EXAMINE_STATE_WSH = "1";
	public static final String OMS_ASN_BILL_H_EXAMINE_STATE_YBH = "2";
	public static final String OMS_ASN_BILL_H_EXAMINE_STATE_YTG = "3";
	public static final String OMS_ASN_BILL_H_EXAMINE_STATE_DZC = "4";
	public static final String OMS_ASN_BILL_H_EXAMINE_STATE_YZC = "5";

	// ASN单类型 1 采购入库 2 销售退货 3 调拨入库 4 移库入库 5 调账入库 6 越库入库 7 直调入库 8 代管入库 9 待检入库 10 器械入库
	// 11 赠品入库
	public static final String OMS_ASN_BILL_H_BILLTYPE_CGRK = "1";
	public static final String OMS_ASN_BILL_H_BILLTYPE_XSTH = "2";
	public static final String OMS_ASN_BILL_H_BILLTYPE_DBRK = "3";
	public static final String OMS_ASN_BILL_H_BILLTYPE_YKRK = "4";
	public static final String OMS_ASN_BILL_H_BILLTYPE_TZRK = "5";
	public static final String OMS_ASN_BILL_H_BILLTYPE_EKRK = "6";
	public static final String OMS_ASN_BILL_H_BILLTYPE_ZDRK = "7";
	public static final String OMS_ASN_BILL_H_BILLTYPE_DGRK = "8";
	public static final String OMS_ASN_BILL_H_BILLTYPE_DJRK = "9";
	public static final String OMS_ASN_BILL_H_BILLTYPE_QXRK = "10";
	public static final String OMS_ASN_BILL_H_BILLTYPE_ZPRK = "11";

	// ASN单来源单据类型 1 采购订单 2 销售退货订单 3 调拨订单 4 其他入库订单
	public static final String OMS_ASN_BILL_H_REFBILLTYPE_CG = "1";
	public static final String OMS_ASN_BILL_H_REFBILLTYPE_XSTH = "2";
	public static final String OMS_ASN_BILL_H_REFBILLTYPE_DB = "3";
	public static final String OMS_ASN_BILL_H_REFBILLTYPE_QT = "4";

	// 交货单类型(0 全部1 销售出库2 采购退货3 调拨出库4 移库出库5 调账出库6 越库出库7 直调出库8 代管出库9 待检出库10 器械出库11
	// 赠品出库)
	public static final String OMS_DO_BILL_TYPE_QB = "0";
	public static final String OMS_DO_BILL_TYPE_XSCK = "1";
	public static final String OMS_DO_BILL_TYPE_CGTH = "2";
	public static final String OMS_DO_BILL_TYPE_DBCK = "3";
	public static final String OMS_DO_BILL_TYPE_YKCK = "4";
	public static final String OMS_DO_BILL_TYPE_DZCK = "5";
	public static final String OMS_DO_BILL_TYPE_YUEKCK = "6";
	public static final String OMS_DO_BILL_TYPE_ZDCK = "7";
	public static final String OMS_DO_BILL_TYPE_DGCK = "8";
	public static final String OMS_DO_BILL_TYPE_DJCK = "9";
	public static final String OMS_DO_BILL_TYPE_QXCK = "10";
	public static final String OMS_DO_BILL_TYPE_ZPCK = "11";

	// 交货单状态(0 作废10 录入15 异常待处理20 审核60 出库完成70 已发货80 已签收90 已下发99 已过账)
	public static final String OMS_DO_BILL_STATUS_ZF = "0";
	public static final String OMS_DO_BILL_STATUS_LR = "10";
	public static final String OMS_DO_BILL_STATUS_YCCL = "15";
	public static final String OMS_DO_BILL_STATUS_SH = "20";
	public static final String OMS_DO_BILL_STATUS_CKWC = "60";
	public static final String OMS_DO_BILL_STATUS_YFH = "70";
	public static final String OMS_DO_BILL_STATUS_YQS = "80";
	public static final String OMS_DO_BILL_STATUS_YXF = "90";
	public static final String OMS_DO_BILL_STATUS_YGZ = "99";
	
	//运输节点记录状态  10 创建
	public static final String TRANSPORT_NODE_RECORD_YCJ = "10";
	
	//运输费用状态  10 创建
    public static final String TRANSPORT_COST_YCJ = "10";
    
    //电子监管码状态  10 创建
    public static final String SUPERVISION_CODE_YCJ = "10";

	// 交货单明细状态0 作废10 录入 90已下发
	public static final String OMS_DO_BILL_D_STATUS_ZF = "0";
	public static final String OMS_DO_BILL_D_STATUS_LR = "10";
	public static final String OMS_DO_BILL_D_STATUS_YXF = "10";

	// 交货单审核状态1 未审核 2 已驳回 3 已通过 4 待仲裁 5 已仲裁
	public static final String OMS_DO_BILL_H_EXAMINE_STATE_WSH = "1";
	public static final String OMS_DO_BILL_H_EXAMINE_STATE_YBH = "2";
	public static final String OMS_DO_BILL_H_EXAMINE_STATE_YTG = "3";
	public static final String OMS_DO_BILL_H_EXAMINE_STATE_DZC = "4";
	public static final String OMS_DO_BILL_H_EXAMINE_STATE_YZC = "5";

	// 业务单位类型(1 客户2 供应商3 收货仓库)
	public static final String COMPANY_TYPE_KH = "1";
	public static final String COMPANY_TYPE_GYS = "2";
	public static final String COMPANY_TYPE_CK = "3";

	// 调拨订单状态(0 作废10 录入20 审核30 出库完成40 已发货50-已经进场60-开始收货70-全部到货80-上架完成99 已过账)
	public static final String OMS_ALLOT_BILL_H_STATUS_ZF = "0";
	public static final String OMS_ALLOT_BILL_H_STATUS_LR = "10";
	public static final String OMS_ALLOT_BILL_H_STATUS_SH = "20";
	public static final String OMS_ALLOT_BILL_H_STATUS_CKWC = "30";
	public static final String OMS_ALLOT_BILL_H_STATUS_YFH = "40";
	public static final String OMS_ALLOT_BILL_H_STATUS_YJJC = "50";
	public static final String OMS_ALLOT_BILL_H_STATUS_KSSH = "60";
	public static final String OMS_ALLOT_BILL_H_STATUS_QBDH = "70";
	public static final String OMS_ALLOT_BILL_H_STATUS_SJWC = "80";
	public static final String OMS_ALLOT_BILL_H_STATUS_YGZ = "99";

	// 调拨订单明细状态0 作废10 录入
	public static final String OMS_ALLOT_BILL_D_STATUS_ZF = "0";
	public static final String OMS_ALLOT_BILL_D_STATUS_LR = "10";
	
	//库存调整单据状态0作废10已创建20审核30过账
	public static final String OMS_STOCK_ADJUST_BILL_STATUS_ZF = "0";
	public static final String OMS_STOCK_ADJUST_BILL_STATUS_CJ = "10";
	public static final String OMS_STOCK_ADJUST_BILL_STATUS_SH = "20";
	public static final String OMS_STOCK_ADJUST_BILL_STATUS_GZ = "30";
	//库存调整审核状态1通过/0不通过
	public static final String OMS_STOCK_ADJUST_AUDIT_STATUS_TG = "1";
	public static final String OMS_STOCK_ADJUST_AUDIT_STATUS_BTG = "0";
	
	// 货主转换单状态(0 作废10 录入20 已下传99 已过账)
	public static final String OMS_CNS_CONVERSION_STATUS_ZF = "0";
	public static final String OMS_CNS_CONVERSION_STATUS_LR = "10";
	public static final String OMS_CNS_CONVERSION_STATUS_YXC = "20";
	public static final String OMS_CNS_CONVERSION_STATUS_YGZ = "99";

	//库存帐页交易类型销售出库1 销售退回2 采购入库3 采退出库4 调拨出库5 调拨入库6 其他出库7 其他入库8
	public static final String INV_BOOK_RECORD_TRANS_TYPE_XSCK = "1";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_XSTH = "2";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_CGRK = "3";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_CTCK = "4";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_DBCK = "5";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_DBRK = "6";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_QTCK = "7";
	public static final String INV_BOOK_RECORD_TRANS_TYPE_QTRK = "8";
	
	//损溢单状态已作废0 已创建10 审核中20 已驳回30 已审核40
	public static final String GSP_GAINSLOSSES_BILL_STATUS_YZF = "0";
	public static final String GSP_GAINSLOSSES_BILL_STATUS_YCJ = "10";
	public static final String GSP_GAINSLOSSES_BILL_STATUS_SHZ = "20";
	public static final String GSP_GAINSLOSSES_BILL_STATUS_YBH = "30";
	public static final String GSP_GAINSLOSSES_BILL_STATUS_YSH = "40";
	
	//停售申请单状态  已作废0 已创建10 审核中20 已驳回30 已审核40
	public static final String GSP_STOPSELLBILL_STATUS_ZF = "0";
	public static final String GSP_STOPSELLBILL_STATUS_CJ = "10";
    public static final String GSP_STOPSELLBILL_STATUS_YBH = "20";
    
    //质量复查单状态  已作废0 已创建10 审核中20 已驳回30 已审核40
    public static final String GSP_QUALITY_REVIEW_H_STATUS_ZF = "0";
    public static final String GSP_QUALITY_REVIEW_H_STATUS_LR = "10";
    public static final String GSP_QUALITY_REVIEW_H_STATUS_YBH = "30";
    
    //质量复查单明细状态  已作废0 已创建10 审核中20 已驳回30 已审核40
    public static final String GSP_QUALITY_REVIEW_D_STATUS_ZF = "0";
    public static final String GSP_QUALITY_REVIEW_D_STATUS_LR = "10";
    
    //质量复查单数据来源  OMSINPUT OMS录入
    public static final String GSP_QUALITY_REVIEW_REFBILLTYPE_OMSINPUT = "OMSINPUT";
    
    //停售申请单数据来源  OMSINPUT OMS录入
    public static final String GSP_STOPSELLBILL_REFBILLTYPE_OMSINPUT = "OMSINPUT";
	
	//损溢单类型报损单1 报溢单2
	public static final String GSP_GAINSLOSSES_BILL_TYPE_BSD = "1";
	public static final String GSP_GAINSLOSSES_BILL_TYPE_BYD = "2";
	
	//损溢打印ID
	public static final String GSP_GAINSLOSSES_BILL_PRINT_TEMPID = "1111";
	
	//养护计划主表状态0 作废 10 录入 50 业务处理中 90 处理结束
	public static final String GSP_MAINTENANCE_PLAN_H_STATUS_ZF = "0";
	public static final String GSP_MAINTENANCE_PLAN_H_STATUS_LR = "10";
	public static final String GSP_MAINTENANCE_PLAN_H_STATUS_YWCL = "50";
	public static final String GSP_MAINTENANCE_PLAN_H_STATUS_CLJS= "90";
	
	//养护计划明细状态0 作废 10 录入 50 业务处理中 90 处理结束
	public static final String GSP_MAINTENANCE_PLAN_D_STATUS_ZF = "0";
	public static final String GSP_MAINTENANCE_PLAN_D_STATUS_LR = "10";
	public static final String GSP_MAINTENANCE_PLAN_D_STATUS_YWCL = "50";
	public static final String GSP_MAINTENANCE_PLAN_D_STATUS_CLJS= "90";
	
	// 销毁单状态0 作废10 录入30 已驳回
    public static final String GSP_DESTROY_REQUEST_STATUS_ZF = "0";
    public static final String GSP_DESTROY_REQUEST_STATUS_LR = "10";
    public static final String GSP_DESTROY_REQUEST_STATUS_BH = "30";
    
	// 盘点损益单状态(0 作废10 创建 20审核中 30已驳回 40已审核)
	public static final String OMS_INVENTORY_ORDER_STATUS_ZF = "0";
	public static final String OMS_INVENTORY_ORDER_STATUS_LR = "10";
	public static final String OMS_INVENTORY_ORDER_STATUS_SHZ = "20";
	public static final String OMS_INVENTORY_ORDER_STATUS_YBH = "30";
	public static final String OMS_INVENTORY_ORDER_STATUS_YSH = "40";
	
	// 盘点损益单审核状态(0 作废10 创建 20审核中 30已驳回 40已审核)
	public static final String OMS_INVENTORY_AUDIT_STATUS_ZF = "0";
	public static final String OMS_INVENTORY_AUDIT_STATUS_LR = "10";
	public static final String OMS_INVENTORY_AUDIT_STATUS_SHZ = "20";
	public static final String OMS_INVENTORY_AUDIT_STATUS_YBH = "30";
	public static final String OMS_INVENTORY_AUDIT_STATUS_YSH = "40";
	
	// 接口状态(N:未处理 E:处理异常 Y:处理完成）
	public static final String INF_STATUS_N = "N";
	public static final String INF_STATUS_E = "E";
	public static final String INF_STATUS_Y = "Y";
}
