package com.prolog.cs.biz.inbound.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
@Data
public class EisWmsRequestResponseDTO implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "仓库编号")
	private String warehouseId;

	@ApiModelProperty(value = "货主编号")
	private String ownerId;

	@ApiModelProperty(value = "单据编号")
	private String billNo;

	@ApiModelProperty(value = "行号")
	private String seqNo;

	@ApiModelProperty(value = "作业类型")
	private String workType;

	@ApiModelProperty(value = "业务类型")
	private String businessType;


	@ApiModelProperty(value = "容器编号")
	private String containerNo;
	/**
	 * EIS请求入库任务时，WMS创建并返回的，回告时带过来
	 */
	@ApiModelProperty(value = "指令ID（每行唯一）")
	private String msgId;
}
