package com.prolog.cs.biz.inbound.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.prolog.framework.core.annotation.Id;
import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description  
 * @Date 2021-04-11 
 */

@ApiModel
@Data
public class ReceiveAsnDetailDTO implements Serializable {

	@ApiModelProperty(value = "明细行号")
	private String seqNo;

	@ApiModelProperty(value = "商品编码")
	private String itemCode;

	@ApiModelProperty(value = "商品名称")
	private String itemName;

	@ApiModelProperty(value = "含税单价")
	private String price;

	@ApiModelProperty(value = "未税单价")
	private String tniPrice;

	@ApiModelProperty(value = "含税金额")
	private String amt;

	@ApiModelProperty(value = "未税金额")
	private String tniAmt;

	@ApiModelProperty(value = "批准文号")
	private String approvalNumber;

	@ApiModelProperty(value = "商品大类ID")
	private String categoryId;

	@ApiModelProperty(value = "商品大类名称")
	private String typeName;

	@ApiModelProperty(value = "包装数量")
	private String packSize;

	@ApiModelProperty(value = "包装单位")
	private String packUnits;

	@ApiModelProperty(value = "件数")
	private String itemPcs;

	@ApiModelProperty(value = "零数")
	private String itemOdd;

	@ApiModelProperty(value = "数量")
	private String itemQty;

	@ApiModelProperty(value = "批号")
	private String lotNo;

	@ApiModelProperty(value = "批次号")
	private String batchNo;

	@ApiModelProperty(value = "灭菌批号")
	private String sterilizelotno;

	@ApiModelProperty(value = "生产日期")
	private String pdateFrom;

	@ApiModelProperty(value = "有效期至")
	private String validUntil;

	@ApiModelProperty(value = "退货原因")
	private String rtReason;

	@ApiModelProperty(value = "行备注")
	private String lineRemark;
}
