package com.prolog.cs.biz.inbound.dto.rcv;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

/**
 * <p>
 * Copyright: Copyright (C) 2020 prolog-int, Inc. All rights reserved.
 * <p>
 * Company: 湖北普罗格科技股份有限公司
 *
 * @author 刘溢沅
 * @since 2022-08-22 16:28
 */
@NoArgsConstructor
@Data
public class RcvDetailsDTO {
    private Object examineState;
    private Object shipmentDistrictNo;
    private String mtlOwnerName;
    private BigDecimal pieceQty;
    private String pEnterprisename;
    private Object shipmentCommunityNo;
    private String createdate;
    private Object itemCategoryCode;
    private Object shipArriveTime;
    private String vendorCode;
    private BigDecimal remainqty;
    private Object saleBillNo;
    private Object closedReason;
    private Object needUser;
    private String asnAutoBillNum;
    private String mtlOwnerNum;
    private Object saleBillType;
    private String id;
    private Object srcBillId;
    private String rcvType;
    private BigDecimal totWeight;
    private String shipperid;
    private Object orgnId;
    private Object branchareaid;
    private Object orgnNum;
    private Object palletPlacedRule;
    private String buyerMane;
    private String srcBillType;
    private Object customerName;
    private Object shipmentTownName;
    private String warehouseId;
    private String rcvTypeName;
    private String billno;
    private String returnType;
    private String status;
    private String branchid;
    private String warehouseAreaCode;
    private String shipFromAdd;
    private String asnHeaderId;
    private String warehouseName;
    private Object shipmentDistrictName;
    private String bizUser;
    private Object delivererContactTel;
    private String billid;
    private Object customerId;
    private Object shipmentProvinceNo;
    private Object auditDate;
    private String shippercode;
    private BigDecimal onPassageDays;
    private String mtlOwnerId;
    private Object needDept;
    private Object srcAutoBillNum;
    private Object priorityLevel;
    private String transportationParty;
    private Object caozy;
    private BigDecimal caseQty;
    private Object branchAddress;
    private Object attainDate;
    private Object buyerNum;
    private String enterpriseId;
    private Object agent;
    private Object billDate;
    private BigDecimal taTe;
    private String vendorId;
    private Object shipmentCommunityName;
    private String shipperType;
    private Object shipmentProvinceName;
    private Object shipmentTownNo;
    private Object lastmodifydate;
    private Object shipLineId;
    private Object orgName;
    private Object shipmentCountryName;
    private Object customerNum;
    private String vendorName;
    private String asnRemark;
    private Object shipmentCityNo;
    private String consignorid;
    private Object shipmentCityName;
    private Object shipType;
    private Object shipFromDate;
    private Object shipmentAddress;
    private Object carriername;
    private String remark;
    private String warehouseCode;
    private Object lastmodifyby;
    private Object arrivalMode;
    private Object carrierId;
    private String createby;
    private BigDecimal totVolume;
    private Object rtReason;
    private String shippername;
    private Object department;
    private Object shipperZjm;
    private String expirationdate;
    private Object executorUser;
    private Object shipmentCountryNo;
    private BigDecimal taTi;

    private List<RcvLineDetailsDTO> rcvLineDetailsDTOS;
}
