package com.prolog.cs.biz.inbound.service;

import com.prolog.cs.biz.inbound.dto.PageParam;
import com.prolog.cs.biz.inbound.dto.failure.ExceptionLinesDTO;
import com.prolog.cs.biz.inbound.dto.failure.ExceptionLogDTO;
import com.prolog.cs.biz.inbound.dto.failure.ExceptionLogQueryDTO;
import com.prolog.cs.biz.inbound.dto.failure.ExceptionLogQueryVO;
import com.prolog.framework.authority.core.dto.UserDTO;
import com.prolog.framework.core.pojo.Page;

import java.util.Date;
import java.util.List;

/**
 * @Description
 * @Date 2021-03-24
 */

public interface OrderInboundStatusBackService {

	/**
	 * 发送入库订单状态数据到OMS
	 *
	 * @param
	 * @return
	 */
	public void sendInboundOrderStatusOms(String asnHeaderId, String remark, String holdCode, String packedBy, String extendProps, String doStatus);

}
