package com.prolog.cs.biz.inbound.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @Description
 * @Date 2021-11-19
 */

@ApiModel
@Data
public class CancelOrderOmsVO implements Serializable {
	private static final long serialVersionUID = 5958305350431815211L;

	@ApiModelProperty(value = "ASN订单编号")
	private String billno;

	@ApiModelProperty(value = "货主编码")
	private String consignorcode;

	@ApiModelProperty(value = "仓库编码")
	private String branchcode;

	@ApiModelProperty(value = "取消原因")
	private String cancelReason;

	@ApiModelProperty(value = "单据类型")
	private String orderType;

	@ApiModelProperty(value = "备注")
	private String remark;

	@ApiModelProperty(value = "扩展属性")
	private String extendProps;

	@ApiModelProperty(value = "企业id")
	private String penterpriseid;

	@ApiModelProperty(value = "企业名称")
	private String penterprisename;

	@ApiModelProperty(value = "消息")
	private String message;

	@ApiModelProperty(value = "是否成功")
	private Boolean success;


}
