package com.prolog.cs.biz.inbound.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @Description
 * @Date 2021-11-19
 */

@ApiModel("收货单上架完成后 入库单回传erp")
@Data
public class IncomingRecordBackErpVO implements Serializable {
	private static final long serialVersionUID = 5958305350431815211L;

	@ApiModelProperty(value = "商品编码")
	private String goodSn;

	@ApiModelProperty(value = "商品名称")
	private String goodName;

	@ApiModelProperty(value = "批号")
	private String fLot;

	@ApiModelProperty(value = "库存数量")
	private String stock;

	@ApiModelProperty(value = "有效期")
	private String expiryDate;

	@ApiModelProperty(value = "生产日期")
	private String produceDate;

	@ApiModelProperty(value = "行业线")
	private String industryline;

	@ApiModelProperty(value = "金蝶采购订单号")
	private String k3POnum;

	@ApiModelProperty(value = "wms单据编号")
	private String wmsBillId;

	@ApiModelProperty(value = "订单类型")
	private String billType;

	@ApiModelProperty(value = "库别编码")
	private String stockNum;

	@ApiModelProperty(value = "库别名称")
	private String stockName;

	@ApiModelProperty(value = "是否物料 0-否  1-是")
	private String itemIsGift;

	@ApiModelProperty(value = "wms入库时间")
	private String stockInTime;

}