package com.prolog.cs.biz.inbound.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 5.1 上架确认回告（EIS-WMS）请求实体类
 * 
 * @author chenhao
 *
 */
@Data
public class OutBoundUploadCircubParamVO implements Serializable {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "单据编号,取监管码表REF_BILL_LINE_ID")
	List<String> refbilllineids;

	@ApiModelProperty(value = "出库单据类型")
	String outType;

	@ApiModelProperty(value = "上传操作人名称")
	String userName;

	@ApiModelProperty(value = "出库单上传时对应的供应商ID或者客户ID")
	String acceptEnterpriseId;
}
