package com.prolog.cs.biz.inbound.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.prolog.cs.biz.inbound.model.ReceivingRecordBackD;
import com.prolog.framework.core.annotation.Table;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Description
 * @Date 2021-11-19
 */

@ApiModel
@Data
public class ReceivingRecordBackHVO implements Serializable {
	private static final long serialVersionUID = 5958305350431815211L;

	@ApiModelProperty(value = "ID标识")
	private String billid;

	@ApiModelProperty(value = "单据编号")
	private String billno;

	@ApiModelProperty(value = "入库单类型")
	private String billtype;

	@ApiModelProperty(value = "货主ID")
	private String consignorcode;

	@ApiModelProperty(value = "关联采购单号")
	private String refBillno;

	@ApiModelProperty(value = "收货员1")
	private String rcvoperator;

	@ApiModelProperty(value = "收货员2")
	private String rcvoperator2;

	@ApiModelProperty(value = "收货时间")
	private String shipmentDate;

	@ApiModelProperty(value = "到货方式")
	private String arrivalMode;

	@ApiModelProperty(value = "录入员")
	private String purorgName;

	@ApiModelProperty(value = "录入员")
	private String purorgId;

	@ApiModelProperty(value = "单据日期")
	private String billdate;

	@ApiModelProperty(value = "类型")
	private String type;

	@ApiModelProperty(value = "企业id")
	private String penterpriseid;

	@ApiModelProperty(value = "验收关联收货单号")
	private String glBillno;
}
