package com.prolog.cs.biz.inbound.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description 监管码/防窜码/唯一码记录表 
 * @Author Xiong  
 * @Date 2021-06-16 
 */
@Data
@ApiModel
public class RelationCodeResultVO implements Serializable {

    private static final long serialVersionUID =  2291818160143936395L;

	@ApiModelProperty(value = "监管码code")
	private String supervisionCode;

	@ApiModelProperty(value = "包装级别")
	private Integer packLevel;

	@ApiModelProperty(value = "企业ID")
	private String enterpriseId;

}
