package com.prolog.cs.biz.inbound.vo;

import com.prolog.cs.biz.inbound.model.SupervisionCode;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 5.1 上架确认回告（EIS-WMS）请求实体类
 * 
 * @author chenhao
 *
 */
@Data
public class UploadCircubParamVO implements Serializable {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "单据编号,取监管码表REF_BILL_LINE_ID")
	String billCode;

	@ApiModelProperty(value = "入库单据类型")
	String inType;

	@ApiModelProperty(value = "出库单据类型")
	String outType;

	@ApiModelProperty(value = "上传操作人名称")
	String userName;

	@ApiModelProperty(value = "单据编号对应的监管码")
	SupervisionCode supervisionCode;
}
