package com.prolog.cs.biz.inbound.config;

import com.prolog.cs.biz.inbound.mq.RabbitConfirmCallback;
import com.prolog.cs.data.exchange.client.SendCallback;
import org.springframework.amqp.rabbit.core.RabbitTemplate.ConfirmCallback;
import org.springframework.stereotype.Service;

@Service
public class RabbitConfirmCallbackConfig implements SendCallback{

	@Override
	public ConfirmCallback getConfirmCallback() {
		return new RabbitConfirmCallback();
	}

}
