package com.prolog.cs.biz.inbound.dao.failure;

import com.prolog.cs.biz.inbound.dto.failure.ExceptionLineQueryDTO;
import com.prolog.cs.biz.inbound.dto.failure.ExceptionLineQueryVO;
import com.prolog.cs.biz.inbound.model.failure.ExceptionLines;
import com.prolog.cs.biz.inbound.vo.LineQueryVO;
import com.prolog.framework.dao.mapper.BaseMapper;

import java.util.List;

/**
 * @Description
 * @Date 2021-03-24
 */
public interface ExceptionLinesMapper extends BaseMapper<ExceptionLines> {

	List<ExceptionLineQueryDTO> findList(ExceptionLineQueryVO queryVO);

	ExceptionLineQueryDTO findByPkId(String pkId);

	List<ExceptionLineQueryDTO> getReport(LineQueryVO lineQueryVO);

	void rejectBatch(String batchId);
//
//	void rejectByRqcNode(@Param("batchId") String batchId, @Param("taskId") String taskId,
//			@Param("pieceQty") BigDecimal pieceQty, @Param("rcvLineId") String rcvLineId);
}
