package com.prolog.cs.biz.inbound.dao.failure;

import com.prolog.cs.biz.inbound.dto.failure.ExceptionLogQueryDTO;
import com.prolog.cs.biz.inbound.dto.failure.ExceptionLogQueryVO;
import com.prolog.cs.biz.inbound.model.failure.ExceptionLog;
import com.prolog.framework.dao.mapper.BaseMapper;

import java.util.List;

/**
 * @Description  
 * @Date 2021-03-24 
 */
public interface ExceptionLogMapper extends BaseMapper<ExceptionLog> {
	
	List<ExceptionLogQueryDTO> findList(ExceptionLogQueryVO queryVO);
	
	ExceptionLogQueryDTO findByPkId(String pkId);
}
