package com.prolog.cs.biz.inbound.remote;

import com.prolog.framework.common.message.RestMessage;
import com.prolog.upcloud.base.wh.operate.vo.MoveConfirmParamsVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(value = "${prolog.service.operate}")
public interface OperateCaller {

	@PostMapping("replenish/v1/confirm")
	public RestMessage<Object> confirmReplenish(@RequestBody MoveConfirmParamsVO moveConfirmParamsVO);


	@PostMapping("replenish/v1/auto-confirm")
	RestMessage autoConfirmReplenish( @RequestBody MoveConfirmParamsVO moveConfirmParamsVO);


}
