package com.prolog.upcloud.base.wh.operate.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.io.Serializable;

@Data
public class AreaInfoByAreaCategoryDTO implements Serializable {

    @JsonProperty("库区ID(主键id)")
    private String warehouseAreaId;
    @JsonProperty("库区编码")
    private String warehouseAreaCode;
    @JsonProperty("库区名称")
    private String warehouseAreaName;
    @JsonProperty("类型（固定/灵活)")
    private String warehouseAreaType;
    @JsonProperty("作业距离（米）")
    private Object warehouseAreaDistance;
    @JsonProperty("库别名")
    private String warehouseAreaCategory;
    @JsonProperty("企业id")
    private String enterpriseId;
    @JsonProperty("库房ID")
    private String warehouseRoomId;
    @JsonProperty("所属仓库ID")
    private String warehouseId;
    @JsonProperty("所属仓配中心")
    private String dcId;
    @JsonProperty("数据访问控制级别")
    private String accessLevel;
    @JsonProperty("库区所在楼层。默认1楼(平面仓)")
    private Object floorNum;
    @JsonProperty("attribute1")
    private String attribute1;
    @JsonProperty("attribute2")
    private String attribute2;
    @JsonProperty("attribute3")
    private String attribute3;
    @JsonProperty("attribute4")
    private String attribute4;
    @JsonProperty("attribute5")
    private String attribute5;
    @JsonProperty("segment1")
    private Object segment1;
    @JsonProperty("segment2")
    private Object segment2;
    @JsonProperty("segment3")
    private Object segment3;
    @JsonProperty("segment4")
    private Object segment4;
    @JsonProperty("segment5")
    private Object segment5;
    @JsonProperty("是否可用 0：否 1：是")
    private String isEnable;
    @JsonProperty("创建日期")
    private String gmtCreate;
    @JsonProperty("创建者名称")
    private String creator;
    @JsonProperty("创建人名称")
    private String creatorName;
    @JsonProperty("修改时间")
    private String gmtModified;
    @JsonProperty("更新者名称")
    private String modifier;
    @JsonProperty("最后修改人")
    private String modifierName;
    @JsonProperty("拆零分组")
    private String splitGroup;
    @JsonProperty("拣货模式")
    private String pickMode;
    @JsonProperty("建筑物ID")
    private String bldgId;
    @JsonProperty("库别编码(字典)")
    private String warehouseAreaCategoryCode;
    @JsonProperty("建筑物编码")
    private String bldgCode;
    @JsonProperty("建筑物")
    private String bldgName;
    @JsonProperty("所属仓配中心名称")
    private String dcName;
    @JsonProperty("配送中心编码")
    private String dcCode;
    @JsonProperty("仓库名称")
    private String warehouseName;
    @JsonProperty("仓库编号")
    private String warehouseCode;
    @JsonProperty("推荐库别(名称)")
    private String warehouseRoomName;
    @JsonProperty("推荐库别(code)")
    private String warehouseRoomCode;
    @JsonProperty("作业模方法(纸单01/RF02/SCS03) 码表")
    private String warehouseWorkingMethod;
}
