package com.prolog.upcloud.base.wh.operate.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 顺带补货返回实体类
 *
 * @author 鄢菁KingYan
 * @date 2022/09/22
 */
@Data
@ApiModel
public class ReplenishIncidentallyDTO {

    @ApiModelProperty(value = "拣货任务号")
    private String pickTaskId;

    @ApiModelProperty(value = "拣货任务明细ID")
    private String pickTaskDId;

    @ApiModelProperty(value = "补货任务号")
    private String detailId;

    @ApiModelProperty(value = "商品名称")
    private String itemName;

    @ApiModelProperty(value = "商品规格")
    private String specification;

    @ApiModelProperty(value = "生产厂家")
    private String manufacturerName;

    @ApiModelProperty(value = "批号")
    private String manufacturerLotNum;

    @ApiModelProperty(value = "商品编号")
    private String itemCode;

    @ApiModelProperty(value = "包装")
    private String caseUom;

    @ApiModelProperty(value = "补货上架货位")
    private String locatorCode;

    @ApiModelProperty(value = "件数")
    private BigDecimal pcs;

    @ApiModelProperty(value = "零散数")
    private BigDecimal oddPieceQty;
}
