package com.prolog.upcloud.base.wh.operate.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Data
public class UnLockStockDTO {
    @ApiModelProperty(value = "解锁结论(1.合格 2.待质检)", required = true)
    @NotEmpty(message = "解锁结论不能为空")
    private String  iqcstatus;

    @ApiModelProperty(value = "解锁明细")
    private List<String> ids;
}
