package com.prolog.upcloud.base.wh.operate.enums;

import lombok.Getter;

/**
 * 移库类型
 *
 * @author 鄢菁KingYan
 * @date 2022/08/03
 */
@Getter
public enum StereoDStatus {

    INITIALIZATION(0, "初始"), FINISH(1, "完成");

    private final Integer code;
    private final String msg;

    StereoDStatus(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }
}
