package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * EIS出库任务回告返回参数VO
 *
 * @author 鄢菁KingYan
 * @date 2022/07/13
 */
@Data
public class CallOutTaskCallbackResultVO {

    @ApiModelProperty(value = "单据编号", required = true)
    private String billNo;
    @ApiModelProperty(value = "行号", required = true)
    private String seqNo;
    @ApiModelProperty(value = "作业类型", required = true)
    private String workType;
    @ApiModelProperty(value = "业务类型", required = true)
    private String businessType;
    @ApiModelProperty(value = "商品编号", required = true)
    private String itemCode;
    @ApiModelProperty(value = "批号", required = true)
    private String lotNo;
    @ApiModelProperty(value = "容器编号", required = false)
    private String containerNo;
    @ApiModelProperty(value = "指令ID", required = true)
    private String msgId;

}
