package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * EIS作业完成确认VO
 *
 * @author 鄢菁KingYan
 * @date 2022/07/13
 */
@Data
public class EisTaskFinishedConfirmVO {

    @ApiModelProperty(value = "容器编号", required = true)
    private String containerNo;

    @ApiModelProperty(value = "是否顺带补货", required = true, notes = "0：不顺带补货;1：顺带补货;(顺带补货时需要EIS清空托盘库存并自动清空点位回库)")
    private String bhflag = "0";

    @ApiModelProperty(value = "部分是包括托盘对应的拣选信息")
    private List<TaskFinishedConfirmSubListVO> subList;

}
