package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

@Data
@ApiModel
public class FinishStereoVO {

    @ApiModelProperty(value = "企业ID")
    @NotBlank(message = "企业ID不能为空")
    private String warehouseId;

    @ApiModelProperty(value = "托盘号")
    private String containerCode;

    @ApiModelProperty(value = "合托单号")
    @NotBlank(message = "合托单号不能为空")
    private String billNo;

}
