package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author wujunjie
 * @desc 移库、移位列表信息
 */
@Data
@ApiModel
public class MoveListVO {
	/**
	 * 主键ID
	 */
	@ApiModelProperty(value = "主键ID")
	private String moveHeaderId;

	@ApiModelProperty(value = "货主ID")
	private String cargoOwnerId;

	@ApiModelProperty(value = "货主名称")
	private String cargoOwnerName;

	@ApiModelProperty(value = "单据日期")
	private Date moveDate;

	@ApiModelProperty(value = "自动单号")
	private String autoBillNum;

	/**
	 * 移库单类型(SYS/ERP/GSP)
	 */
	@ApiModelProperty(value = "移库单类型")
	private String moveBillType;

	/**
	 * 移入建筑物
	 */
	@ApiModelProperty(value = "移入建筑物")
	private String moveInBldg;

	/**
	 * 移入建筑物
	 */
	@ApiModelProperty(value = "移入建筑物")
	private String moveInBldgName;

	/**
	 * 移出建筑物
	 */
	@ApiModelProperty(value = "移出建筑物")
	private String moveOutBldg;

	/**
	 * 移入建筑物
	 */
	@ApiModelProperty(value = "移入建筑物")
	private String moveOutBldgName;

	/**
	 * 业务员
	 */
	@ApiModelProperty(value = "业务员")
	private String excuteUser;
}
