package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 移位打印数据
 *
 * @author 鄢菁KingYan
 * @date 2022/07/13
 */
@Data
public class MovePrintDataDtlVO implements Serializable {

    private static final long serialVersionUID = 4612011526535896850L;

    @ApiModelProperty(value = "商品编码")
    private String itemCode;

    @ApiModelProperty(value = "商品名称")
    private String itemName;

    @ApiModelProperty(value = "包装单位")
    private String uom;

    @ApiModelProperty(value = "包装数量")
    private BigDecimal caseConversionRate;

    @ApiModelProperty(value = "数量")
    private String oddPieceQuantity;

    @ApiModelProperty(value = "原区域")
    private String outWarehouseAreaCategory;

    @ApiModelProperty(value = "目标区域")
    private String inWarehouseAreaCategory;

    @ApiModelProperty(value = "移除货位")
    private String outLocatorCode;

    @ApiModelProperty(value = "移入货位")
    private String inLocatorCode;
}
