package com.prolog.upcloud.base.wh.operate.vo;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@ApiModel
@Data
public class MovePrintDetailVO implements Serializable {

	private static final long serialVersionUID = 5859982161766076899L;

	@ApiModelProperty(value = "有效期至")
	private Date batchExpiredDate;

	@ApiModelProperty(value = "显示有效期至")
	private String batchExpiredDateShow;

	@ApiModelProperty(value = "批次id")
	private String batchId;

	@ApiModelProperty(value = "批次号")
	private String batchNum;

	@ApiModelProperty(value = "生产日期")
	private Date batchProductionDate;

	@ApiModelProperty(value = "显示生产日期")
	private String batchProductionDateShow;

	@ApiModelProperty(value = "包装含量(最大)")
	private BigDecimal caseConversionRate;

	@ApiModelProperty(value = "备注")
	private String comments;

	@ApiModelProperty(value = "包装含量")
	private BigDecimal conversionRate;

	@ApiModelProperty(value = "移入容器号")
	private String inContainerCode;
	@ApiModelProperty(value = "移入货格号")
	private String inGoodsCaseCode;

	@ApiModelProperty(value = "移入货位编码")
	private String inLocatorCode;

	@ApiModelProperty(value = "移入货位id")
	private String inLocatorId;

	@ApiModelProperty(value = "移入货位名称")
	private String inLocatorName;

	@ApiModelProperty(value = "移入库别")
	private String inWarehouseAreaCategory;

	@ApiModelProperty(value = "商品编码")
	private String itemCode;

	@ApiModelProperty(value = "商品id")
	private String itemId;

	@ApiModelProperty(value = "商品名称")
	private String itemName;

	@ApiModelProperty(value = "商品产地id")
	private String manufacturerId;

	@ApiModelProperty(value = "商品批号")
	private String manufacturerLotNum;

	@ApiModelProperty(value = "商品产地名称")
	private String manufacturerName;

	@ApiModelProperty(value = "移库单id")
	private String moveHeaderId;

	@ApiModelProperty(value = "移库单明细id")
	private String moveLineId;

	@ApiModelProperty(value = "明细零散数")
	private BigDecimal oddPieceQuantity;

	@ApiModelProperty(value = "移出容器号")
	private String outContainerCode;

	@ApiModelProperty(value = "移出货格号")
	private String outGoodsCaseCode;

	@ApiModelProperty(value = "移出货位编码")
	private String outLocatorCode;

	@ApiModelProperty(value = "移出货位id")
	private String outLocatorId;

	@ApiModelProperty(value = "移出货位名称")
	private String outLocatorName;

	@ApiModelProperty(value = "移出库别")
	private String outWarehouseAreaCategory;

	@ApiModelProperty(value = "明细数量")
	private BigDecimal pieceQuantity;

	@ApiModelProperty(value = "明细整件")
	private BigDecimal quantity;

	@ApiModelProperty(value = "商品规格说明")
	private String specification;

	@ApiModelProperty(value = "商品单位")
	private String uom;

	@ApiModelProperty(value = "工号id")
	private String warehouseWorkerId;

	@ApiModelProperty(value = "工号名称")
	private String warehouseWorkerName;

}
