package com.prolog.upcloud.base.wh.operate.vo;

import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel
public class MovePrintHeadVO implements Serializable {

	private static final long serialVersionUID = 825199645178380096L;

	@ApiModelProperty(value = "部门名称")
	private String deptName;

	@ApiModelProperty(value = "企业名称")
	private String enterpriseName = "昆药商业";

	@ApiModelProperty(value = "移库单id")
	private String moveHeaderId;

	@ApiModelProperty(value = "移入建筑物")
	private String moveInBldgName;

	@ApiModelProperty(value = "移出建筑物")
	private String moveOutBldgName;

	@ApiModelProperty(value = "打印人")
	private String printUser;

	@ApiModelProperty(value = "操作人工号")
	private String workerNo;
}
