package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description
 * @Date 2021-06-29
 */
@ApiModel
@Data
public class OmsInventoryResultVO implements Serializable {
	private static final long serialVersionUID = 4837262755876594212L;

	@ApiModelProperty(value = "单据编号")
	private String billno;

	@ApiModelProperty(value = "盘点员")
	private String inventoryby;

	@ApiModelProperty(value = "单据日期")
	private String billdate;

	@ApiModelProperty(value = "行号")
	private String seqNo;

	@ApiModelProperty(value = "商品编码")
	private String itemcode;

	@ApiModelProperty(value = "商品id")
	private String itemid;

	@ApiModelProperty(value = "损益数量")
	private BigDecimal causticQty;

	@ApiModelProperty(value = "损溢原因")
	private String causticReason;

	@ApiModelProperty(value = "批号")
	private String lotNo;

	@ApiModelProperty(value = "生产日期")
	private String pdateFrom;

	@ApiModelProperty(value = "有效期至")
	private String validUntil;

	@ApiModelProperty(value = "类型")
	private String causticType;

	@ApiModelProperty(value = "操作员")
	private String operatorName;

	@ApiModelProperty(value = "审核员")
	private String confirmer;

	@ApiModelProperty(value = "审核日期")
	private String auditDate;

	@ApiModelProperty(value = "物流质管意见")
	private String opinion;

	@ApiModelProperty(value = "数量")
	private BigDecimal qty;

	@ApiModelProperty(value = "不合格品数量")
	private BigDecimal unqualifiedQty;

	@ApiModelProperty(value = "不合格原因")
	private String unqualifiedResource;

	@ApiModelProperty(value = "不合格来源")
	private String unqualifiedSource;

	@ApiModelProperty(value = "仓库编码")
	private String branchcode;

	@ApiModelProperty(value = "企业ID")
	private String penterpriseid;

	@ApiModelProperty(value = "货主")
	private String consignorcode;

}
