package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

/**
 * 补货上架确认明细
 *
 * @author 鄢菁KingYan
 * @date 2022/08/03
 */
@Data
public class ReplenishDetailLocationVO {
    /**
     * 明细ID
     */
    @ApiModelProperty("明细ID")
    @NotBlank(message = "明细ID不能为空")
    private String lineId;

    /**
     * 目标货位ID
     */
    @ApiModelProperty("目标货位ID")
    private String toLocationId;

    /**
     * 目标货位编码
     */
    @ApiModelProperty("目标货位编码")
    @NotBlank(message = "目标货位编码不能为空")
    private String toLocationCode;
}

