package com.prolog.upcloud.base.wh.operate.vo;

import com.prolog.upcloud.base.strategy.dto.ReplenishRuleDTO;
import com.prolog.upcloud.base.wh.operate.model.WmsReplenishD;
import lombok.Data;

import java.util.List;

@Data
public class ReplenishLineIdVO {

    /**
     * 需要上架的单据
     */
    private List<WmsReplenishD> putawayList;
    /**
     * 需要下架的单据
     */
    private List<WmsReplenishD> unShelveList;

    /**
     * 补货规则
     */
    private List<ReplenishRuleDTO> rules;

    /**
     * 仓库id
     */
    private String warehouseId;
}
