package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.Valid;
import javax.validation.constraints.NotBlank;
import java.util.List;

/**
 * @author wujunjie
 * @desc 被动补货信息
 * @date 2021-05-14
 */
@Data
@ApiModel
public class ReplenishPassiveSaveVO {

    /**
     * 仓库ID
     */
    private String warehouseId;

    /**
     * 企业ID
     */
    private String enterpriseId;

    /**
     * 仓配中心ID
     */
    private String dcId;

    /**
     * 操作人
     */
    private String opUser;

    /**
     * 操作人ID
     */
    private String opUserId;

    /**
     * 补货明细
     */
    private List<ReplenishPassiveSaveDetailVO> details;
}
