package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class ReplenishUnshelveVO {

    @ApiModelProperty("ID")
    private String id;

    @ApiModelProperty("托盘号/拣货任务ID")
    private String hrdId;

    @ApiModelProperty("商品ID")
    private String itemId;

    @ApiModelProperty("商品名称")
    private String itemName;

    @ApiModelProperty("商品编号")
    private String itemCode;

    @ApiModelProperty("批次ID")
    private String batchId;

    @ApiModelProperty(value = "包装数量")
    private BigDecimal caseConversionRate;

    @ApiModelProperty(value = "商品规格")
    private String specification;

    @ApiModelProperty(value = "生产厂家名称")
    private String manufacturerName;

    @ApiModelProperty(value = "批号")
    private String manufacturerLotNum;

    @ApiModelProperty("生产日期")
    private String batchProductionDateShow;

    @ApiModelProperty("显示有效期至")
    private String batchExpiredDateShow;

    @ApiModelProperty(value = "客户名称")
    private String customerName;

    @ApiModelProperty(value = "拣货数量")
    private BigDecimal pieceQuantity;

    @ApiModelProperty(value = "拣货件数")
    private Integer pcs;

    @ApiModelProperty(value = "OMS订单号")
    private String omsBillNo;

    @ApiModelProperty(value = "客户名称")
    private String shipperName;

    @ApiModelProperty(value = "货位")
    private String locator;

    @ApiModelProperty(value = "单据类型")
    private String billType;

    @ApiModelProperty(value = "业务类型")
    private String businessType;

    @ApiModelProperty(value = "容器号")
    private String containerCode;

    @ApiModelProperty(value = "标签")
    private String barcode;
}
