package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

@Data
public class StereoDtlVO implements Serializable {

    @ApiModelProperty("立库单明细ID")
    private String detailId;

    @ApiModelProperty("合托单号")
    private String billNo;

    @ApiModelProperty("立库单ID")
    private String headerId;

    @ApiModelProperty("商品Id")
    private String itemId;

    @ApiModelProperty("商品编码")
    private String itemCode;

    @ApiModelProperty("商品名称")
    private String itemName;

    @ApiModelProperty("货位ID")
    private String locatorId;

    @ApiModelProperty("货位编码")
    private String locatorCode;

    @ApiModelProperty("仓库ID")
    private String warehouseId;

    @ApiModelProperty("批号")
    private String manufacturerLotNum;

    @ApiModelProperty(value = "生产厂家名称")
    private String manufacturerName;

    @ApiModelProperty("规格")
    private String specification;

    @ApiModelProperty("库存数量")
    private BigDecimal quantity;

    @ApiModelProperty("移位数量")
    private BigDecimal actQuantity;

    @ApiModelProperty("显示生产日期")
    private String batchProductionDateShow;

    @ApiModelProperty("托盘号")
    private String containerCode;

    @ApiModelProperty(value = "显示有效期至")
    private String batchExpiredDateShow;

    @ApiModelProperty("包装数量")
    private String caseConversionRate;

    @ApiModelProperty("货主名称")
    private String cargoOwnerName;

    @ApiModelProperty("货主ID")
    private String cargoOwnerId;

    @ApiModelProperty("批次ID")
    private String batchId;

    @ApiModelProperty("库存状态")
    private String stockStatus;

    @ApiModelProperty("库存主键ID")
    private String lockStockLotId;

}
