package com.prolog.upcloud.base.wh.operate.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Size;
import java.util.List;

@Data
public class StockLotLockVO {
    @ApiModelProperty(value = "库存编码", dataType = "List", required = true)
    @Size(min = 1, message = "{required}")
    private List<String> ids;

    @ApiModelProperty(value = "解锁结论",required = true)
    private String stockStatus;
}
