package com.prolog.upcloud.base.wh.operate.constant;

public interface EisConstant {

    /**
     * 发起方（wms)
     */
    String INITIATOR_WMS = "WMS";

    /**
     * 发起方(eis)
     */
    String INITIATOR_EIS = "EIS";

    /**
     * 日志状态：初始化
     */
    Integer INIT = 0;
    /**
     * 日志状态：成功
     */
    Integer SUCCESS = 1;
    /**
     * 日志状态：失败
     */
    Integer FAIL = 2;

    String YES = "1";

    String NO = "0";

    /**
     * 未发送（WMS->EIS)
     */
    Integer OUTBOUND_INSTRUCT_NO_SEND = 0;
    /**
     * 已发未达（WMS->EIS)
     */
    Integer OUTBOUND_INSTRUCT_UN_DELIVERY = 1;
    /**
     * 已收到（EIS->WMS)
     */
    Integer OUTBOUND_INSTRUCT_DELIVERY = 2;

    /**
     * EIS接口：任务完成回库推送
     */
    /**
     * EIS接口：盘点审核信息推送
     */
    String INVENTORY_REQUEST = "/api/v1/wms/operation/inventoryRequest";

    /**
     * eis大货位（与EIS约定）
     */
    String EIS_LOCATION = "F3";

}
