package com.prolog.upcloud.base.wh.operate.convert;

import com.prolog.cs.basic.item.model.vo.ItemBaseInfoVO;
import com.prolog.upcloud.base.inventory.vo.BatchNumberListVO;
import com.prolog.upcloud.base.inventory.vo.WmsInvStockQtyVO;
import com.prolog.upcloud.base.strategy.dto.stock.StockLocatorDTO;
import com.prolog.upcloud.base.wh.operate.model.WmsReplenishD;
import com.prolog.upcloud.base.wh.operate.vo.ReplenishPdaDetailVO;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;

@Mapper(componentModel = "spring")
public interface ReplenishConvert {

    ReplenishPdaDetailVO wmsReplenishD2ReplenishPdaDetailVO(WmsReplenishD dInfo);

    void completeReplenishPdaDetailVOByItem(@MappingTarget ReplenishPdaDetailVO vo, ItemBaseInfoVO item);

    void completeReplenishPdaDetailVOByBatchNumber(@MappingTarget ReplenishPdaDetailVO vo, BatchNumberListVO batch);

    StockLocatorDTO wmsInvStockQtyVO2StockLocatorDTO(WmsInvStockQtyVO v);
}