package com.prolog.upcloud.base.wh.operate.dao;

import com.prolog.framework.dao.mapper.BaseMapper;
import com.prolog.upcloud.base.wh.operate.model.OmsStockAdjustmentRecord;
import com.prolog.upcloud.base.wh.operate.vo.MoveErpHeadListVO;
import com.prolog.upcloud.base.wh.operate.vo.MoveErpListVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface OmsStockAdjustmentRecordMapper extends BaseMapper<OmsStockAdjustmentRecord> {

    List<MoveErpHeadListVO> getOmsMoveHeadList(@Param("enterpriseId") String enterpriseId, @Param("warehouseId") String warehouseId, @Param("billType") String billType);

    List<MoveErpListVO> getOmsMoveList(@Param("enterpriseId") String enterpriseId,
                                       @Param("erpBillId") String erpBillId,
                                       @Param("erpBillNo") String erpBillNo,
                                       @Param("billType") String billType);
}
