package com.prolog.upcloud.base.wh.operate.dao;

import com.prolog.framework.dao.mapper.BaseMapper;
import com.prolog.upcloud.base.wh.operate.model.WmsCargoChange;
import com.prolog.upcloud.base.wh.operate.vo.OmsCnsConversionListVO;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author wujunjie
 */
@Repository
public interface WmsCargoChangeMapper extends BaseMapper<WmsCargoChange> {

    /**
     * 获取移库标志对应的移库单列表
     *
     * @param detailIds 明细ID集合
     * @param moveFlag  移库标志
     * @return 已完成转换单列表
     */
    List<WmsCargoChange> getMoveDoneList(String[] detailIds, String moveFlag);
}
