package com.prolog.upcloud.base.wh.operate.dao;

import com.prolog.framework.core.pojo.Page;
import com.prolog.framework.dao.mapper.BaseMapper;
import com.prolog.upcloud.base.wh.operate.model.WmsMoveD;
import com.prolog.upcloud.base.wh.operate.vo.MoveDListVO;
import com.prolog.upcloud.base.wh.operate.vo.MoveQueryDVO;
import com.prolog.upcloud.base.wh.operate.vo.StereoDtlVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface WmsMoveDMapper extends BaseMapper<WmsMoveD> {
    int updateStatusByHeaderId(@Param("moveHeaderId") String moveHeaderId, @Param("status") String status);

    int getUncomfirmContainerNum(@Param("status") String status, @Param("moveLineIds") String[] lineIds, @Param("outcontainercode") String outcontainercode);

    Long updateEisFinishFlag(@Param("moveLineIds") List<String> lineIds);

    List<MoveDListVO> selectMoveDInfoList(@Param("enterpriseId") String enterpriseId, @Param("query") MoveQueryDVO moveQueryDVO);


}
