package com.prolog.upcloud.base.wh.operate.dao;

import com.prolog.framework.dao.mapper.BaseMapper;
import com.prolog.upcloud.base.wh.operate.model.WmsStereoH;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @auther KingYan
 * @create 2022-07-13 18:00:14
 * @describe 合托单主表mapper类
 */
@Mapper
public interface WmsStereoHMapper extends BaseMapper<WmsStereoH> {

    List<WmsStereoH> getStereoByConditions(@Param("warehouseId") String warehouseId, @Param("billNo") String billNo, @Param("containerCodes") String[] containerCodes, @Param("status") Integer status);
}
