package com.prolog.upcloud.base.wh.operate.resource;

import com.prolog.cs.basic.chain.model.cargo.BaseCargoOwnerMst;
import com.prolog.framework.common.message.RestMessage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;
import java.util.Set;

/**
 * @author wujunjie
 */
@FeignClient(value = "${prolog.service.chain}")
public interface ChainResource {

    @PostMapping("/baseCargoOwnerMst/v1.0/getByIds")
    RestMessage<Map<String, BaseCargoOwnerMst>> getCargoOwerByIds(Set<String> cargoOwnerIds);

    @GetMapping("/baseCargoOwnerMst/v1.0/infoById")
    RestMessage<Map<String, Object>> getCargoOwerById(@RequestParam("cargoOwnerId") String cargoOwnerId);
}
