package com.prolog.upcloud.base.wh.operate.resource;

import com.prolog.cs.biz.inbound.dto.CargoChangeIn;
import com.prolog.cs.biz.inbound.dto.rqc.RqcLinesDTO;
import com.prolog.cs.biz.inbound.dto.rqc.WmsInRqcSampleDTO;
import com.prolog.framework.common.message.RestMessage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

/**
 * @author wujunjie
 */
@FeignClient(value = "${prolog.service.inbound}")
public interface InBoundClient {

    @PostMapping("/rcvHeaders/v1.0/cargoChangeIn")
    RestMessage cargoChangeIn(@RequestBody List<CargoChangeIn> changeIns);


    /**
     * 获取抽检的集合
     */
    @PostMapping("/wmsInRqcSample/v1/get-prelist")
    RestMessage<List<WmsInRqcSampleDTO>> getPreList(@RequestBody List<RqcLinesDTO> rqcLinesDTOList);

}
