package com.prolog.cs.biz.outbound.enums;

import lombok.Getter;

@Getter
public enum PickTaskDFLowStatus {
    INITIALIZE("0", "初始化"), GENERATE("1", "生成拣货任务"), TASK_CLAIMED("2", "拣货已索取"), TASK_CONFIRMED("3", "拣货已确认"), IN_REVIEW_CLAIMED("4", "内复核已索取"), IN_REVIEW_CONFIRMED("5", "内复核已确认"), OUT_REVIEW_CLAIMED("6", "外复核已索取"), OUT_REVIEW_CONFIRMED("7", "外复核已确认");

    private final String code;

    private final String name;

    PickTaskDFLowStatus(String code, String name) {
        this.code = code;
        this.name = name;
    }
}
