package com.prolog.cs.biz.outbound.model;

import com.prolog.framework.core.annotation.Column;
import com.prolog.framework.core.annotation.Id;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
public class SYZJPrintAgain {

    @ApiModelProperty(value = "起始时间")
    private Date startDate;

    @ApiModelProperty(value = "结束时间")
    private Date endDate;

    @ApiModelProperty(value = "订单明细行id")
    private String lineid;

    @ApiModelProperty(value = "商品名称")
    private String itemName;

    @ApiModelProperty(value = "批号")
    private String lotNo;

    @ApiModelProperty(value = "出库单号")
    private String billno;

    @ApiModelProperty(value = "商品编号")
    private String itemcode;

    @ApiModelProperty(value = "商品id")
    private String itemid;

    @ApiModelProperty(value = "订单时间")
    private Date billDate;

    @ApiModelProperty(value = "是否上传首营资料")
    private String isSy;

    @ApiModelProperty(value = "是否上传质检报告")
    private String isZj;

    @ApiModelProperty(value = "打印次数")
    private String count;

    @ApiModelProperty(value = "批次")
    private String batchId;

    private Integer pageNum;

    private Integer pageSize;
}
