package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
public class BillPackageDTO {
	@ApiModelProperty(value = "标签ID")
	private String barcodeId;
	@ApiModelProperty(value = "标签")
	private String barcode;
	@ApiModelProperty(value = "复核时间")
	private Date checkTime2;
	@ApiModelProperty(value = "复核人")
	private String checkerName;
	@ApiModelProperty(value = "拼箱编号")
	private String lclNo;
	@ApiModelProperty(value = "复核状态（null-初始状态（整件，内复核未完成成）, 0-未复核，1-已索取，5-已复核，6-已同步TMS）")
	private String checkStatus;
	@ApiModelProperty(value = "企业名称")
	private String enterpriseName;
	@ApiModelProperty(value = "企业ID")
	private String enterpriseId;
	@ApiModelProperty(value = "订单号")
	private String billNo;
	@ApiModelProperty(value = "订单ID")
	private String billId;
	@ApiModelProperty(value = "货主编码")
	private String consignorCode;
	@ApiModelProperty(value = "货主名称")
	private String consignorName;
	@ApiModelProperty(value = "运单号")
	private String shipBillNo;
	@ApiModelProperty(value = "货主ID")
	private String consignorId;
	@ApiModelProperty(value = "体积")
	private String volume;
	@ApiModelProperty(value = "高度")
	private String height;
	@ApiModelProperty(value = "重量")
	private String weight;

}
