package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @author cheng.kong
 * @date 2022/7/23   12:30
 */
@Data
public class FreightEnterDto implements Serializable {

    @ApiModelProperty(value = "波次订单明细id")
    private String id;

    @ApiModelProperty("运单号")
    private String shipNo;

    @ApiModelProperty("货号")
    private String itemNo;

    @ApiModelProperty(value = "客户编号")
    private String customerCode;

    @ApiModelProperty(value = "客户名称")
    private String customerName;

    @ApiModelProperty("联系方式")
    private String contactWay;

    @ApiModelProperty(value = "企业ID")
    private String enterpriseId;

    @ApiModelProperty(value = "仓库id")
    private String warehouseId;

    @ApiModelProperty(value = "仓编码")
    private String warehouseCode;

    @ApiModelProperty(value = "仓名称")
    private String warehouseName;

    @ApiModelProperty("客户代收款")
    private Double agencyFund;

    @ApiModelProperty("运费")
    private Double freightPrice;

    @ApiModelProperty("上门费")
    private Double visitPrice;

    @ApiModelProperty("箱数")
    private Double boxNumber;

    @ApiModelProperty("付运费方式")
    private String freightWayCode;

    @ApiModelProperty("付运费方式")
    private String freightWayName;

}
