package com.prolog.cs.biz.outbound.model.dto;

import com.prolog.framework.core.annotation.Id;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class InfTaskOutDTO {

    @Id
    @ApiModelProperty(value = "主键id")
    private String msgId;

    @ApiModelProperty(value = "WMS单据任务号")
    private String taskId;

    @ApiModelProperty(value = "仓库主键id")
    private String warehouseId;

    @ApiModelProperty(value = "作业类型")
    private String workType;

    @ApiModelProperty(value = "业务类型")
    private String businessType;

    @ApiModelProperty(value = "优先级")
    private Integer priority;

    @ApiModelProperty(value = "明细ID")
    private String seqNo;

    @ApiModelProperty(value = "容器号")
    private String containerNo;

    @ApiModelProperty(value = "货主id")
    private String ownerId;

    @ApiModelProperty(value = "商品id")
    private String itemId;

    @ApiModelProperty(value = "批号ID")
    private String lotId;

    @ApiModelProperty(value = "包装ID")
    private String packId;

    @ApiModelProperty(value = "数量")
    private BigDecimal qty;

    @ApiModelProperty(value = "企业id")
    private String enterpriseId;

    @ApiModelProperty(value = "源区域")
    private String originalArea;

    @ApiModelProperty(value = "源点位")
    private String originalLocation;

    @ApiModelProperty(value = "目标区域")
    private String targetArea;

    @ApiModelProperty(value = "目标点位")
    private String targetLocation;

    @ApiModelProperty(value = "WMS大货位")
    private String wmslocationCode;
}
