package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel
public class ItemQueryDTO {

    @ApiModelProperty(value = "当前页码")
    private Integer pageSize;

    @ApiModelProperty(value = "每页数量")
    private Integer pageNum;

    @ApiModelProperty(value = "交货单ID")
    private String billid;

    @ApiModelProperty(value = "商品编码")
    private String itemcode;

    @ApiModelProperty(value = "商品名称")
    private String itemname;

    @ApiModelProperty(value = "商品大类名称")
    private String typeName;

    @ApiModelProperty(value = "仓库ID")
    private String branchid;

    @ApiModelProperty(value = "出库仓库库区ID")
    private String branchareaid;
}
