package com.prolog.cs.biz.outbound.model.dto;

import com.prolog.framework.core.annotation.Id;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class LicenseImageDTO {

    @Id
    @ApiModelProperty(value = "主键id")
    private String msgId;

    @ApiModelProperty(value = "货主编码")
    private String consignorcode;

    @ApiModelProperty(value = "单位编号")
    private String companycode;

    @ApiModelProperty(value = "证照类型 1代表货品、V：供应商C：客户")
    private String certificateType;

    @ApiModelProperty(value = "证照地址")
    private String certificateUrl;

    @ApiModelProperty(value = "文件名称")
    private String fileName;

    @ApiModelProperty(value = "文件类型")
    private String fileType;

    @ApiModelProperty("消息")
    private String message;

    @ApiModelProperty("是否成功")
    private Boolean success;
}
