package com.prolog.cs.biz.outbound.model.dto;

import com.prolog.cs.biz.outbound.model.OutcomingRecordD;
import lombok.Data;
import org.apache.poi.hpsf.Decimal;

import java.util.Date;
import java.util.List;

@Data
public class PrintAgDateDto {
    private String billid;
    private String billno;
    private String billtype;
    private String branchid;
    private String branchcode;
    private String branchname;
    private String consignorid;
    private String consignorcode;
    private String consignorname;
    private String consignorBillNo;
    private String refbilltype;
    private String refbillid;
    private String refbillno;
    private String salespersonId;
    private String salespersonName;
    private String purorgId;
    private String purorgName;
    private String brancharea;
    private String branchAddress;
    private String businessNo;
    private String shipperType;
    private String shipperId;
    private String shippercode;
    private String shippername;
    private String priorityLevel;
    private String arrivalMode;
    private String shilineId;
    private String carrierId;
    private String carrierName;
    private String status;
    private Date billOutTime;
    private Date confirmtime;
    private String operator;
    private String confirmer;
    private Double totPcs;
    private Double totQty;
    private Double totBoxNum;
    private Double totWeight;
    private Double totVolume;
    private String externalreviewer;
    private String checkdate;
    private String wmsschedtime;
    private String remark;
    private String createby;
    private String createdate;
    private String lastmodifyby;
    private Date lastmodifydate;
    private String enterpriseid;
    private String enterprisename;
    private String stageCodeMin;
    private String stageCodeMax;
    private String custPerson;
    private String custPersonTel;
    private String receiveAddress;
    private String billDate;
    private String printCount;
    private String czy;
    private String lineName;
    private String contractList;
    private String grshFlag;
    private String isAccompanyInvoice;
    private String rejectHandleType;
    private String barCodeId;
    private Integer outboundPrintCount;
    private Integer reportPrintCount;
    private List<OutcomingRecordD> outcomingRecordDList;
}
