package com.prolog.cs.biz.outbound.model.dto;

import cn.hutool.core.date.DateUtil;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class PrintAgainVo {
    @ApiModelProperty("任务号")
    private String taskId;
    @ApiModelProperty("拣选单号")
    private String pickOrderId;
    @ApiModelProperty("订单编号")
    private String billNo;
    @ApiModelProperty("容器号")
    private String containerCode;
    @ApiModelProperty("容器号")
    private String enterpriseId;
    @ApiModelProperty("创建时间起")
    private Date startTime;
    @ApiModelProperty("创建时间终")
    private Date endTime;
    @ApiModelProperty(hidden = true)
    private String startTimeStr;
    @ApiModelProperty(hidden = true)
    private String endTimeStr;
    @ApiModelProperty("分页参数")
    private Integer pageNum;
    @ApiModelProperty("分页参数")
    private Integer pageSize;
    @ApiModelProperty("查询明显时的IDS")
    private List<String> ids;
    @ApiModelProperty("仓")
    private String warehouseId;
    @ApiModelProperty("运单号")
    private String shipNo;
    @ApiModelProperty("收货单位名称")
    private String shipperName;
    @ApiModelProperty("面单条码")
    private String barcode;
    public String getStartTimeStr(){
        return DateUtil.formatDateTime(startTime);
    }

    public String getEndTimeStr(){
        return DateUtil.formatDateTime(endTime);
    }
}
