package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class RePrintWholeBulkDto {
    @ApiModelProperty("拣货单")
    private String id;
    @ApiModelProperty("日期")
    private String pickTime;
    @ApiModelProperty("货主编码")
    private String consignorId;
    @ApiModelProperty("货主编码")
    private String consignorCode;
    @ApiModelProperty("货主名称")
    private String consignorName;
    @ApiModelProperty("货主名称")
    private String shipperType;
    @ApiModelProperty("单据编号")
    private String billId;
    @ApiModelProperty("单位id")
    private String shipperId;
    @ApiModelProperty("单位编号")
    private String shipperCode;
    @ApiModelProperty("单位名称")
    private String shipperName;
    @ApiModelProperty("复核台")
    private String stationName;
    @ApiModelProperty("客户备注")
    private String remark;
    @ApiModelProperty("拣货员")
    private String pickerName;
    @ApiModelProperty(value = "暂存区起始")
    private String stageCodeMin;
    @ApiModelProperty(value = "暂存区终止")
    private String stageCodeMax;
}
