package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description 容器校验DTO
 * @Date 2022-11-10
 */
@Data
@ApiModel
public class ValidateContainerNoDTO implements Serializable {

    private static final long serialVersionUID = 2251650632155130119L;

    @ApiModelProperty(value = "主键")
    private String msgId;

    @ApiModelProperty(value = "容器号")
    private String containerNo;

    @ApiModelProperty(value = "错误信息")
    private String errorMsg;
}
