package com.prolog.cs.biz.outbound.model.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel
public class WmsOutPriorityReqDTO {

    @ApiModelProperty(value = "仓库编号")
    private String warehouseId;

    @ApiModelProperty(value = "货主编号")
    private String ownerId;

    @ApiModelProperty(value = "单据编号")
    private String billNo;

    @ApiModelProperty(value = "作业类型")
    private String workType;

    @ApiModelProperty(value = "业务类型")
    private String businessType;

    @ApiModelProperty(value = "订单优先级")
    private Integer priority;

    @ApiModelProperty(value = "指令ID（每行唯一）")
    private String msgId;

    private String taskId;
}
