package com.prolog.cs.biz.outbound.model.dto.check;

import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class CheckMakeRedDTO {

    @ApiModelProperty(value = "拣货任务明细", required = true)
    private String pickTaskDId;

    @ApiModelProperty(value = "冲红原因")
    private String redReason;

    @ApiModelProperty(value = "冲红数量")
    private BigDecimal redQty;

    @ApiModelProperty(value = "商品明细行id")
    private String billDId;

    @ApiModelProperty(value = "订单id")
    private String billId;


    @ApiModelProperty(value = "原单行ID")
    private String srcLineId;

    @ApiModelProperty(value = "原单ID")
    private String srcId;


    @ApiModelProperty(value = "容器编码")
    private String containerCode;

    @ApiModelProperty(value = "复核台编码")
    private String stationCode;

    @ApiModelProperty(value = "1=转移到盘点库（默认）2=还原原货位")
    private Integer redDoMethod;

    @ApiModelProperty(value = "是否二次复核，0，不是，1是")
    private Integer isDoubleCheck;

    @ApiModelProperty(value = "拼箱码")
    private Integer lclNo;
}
