package com.prolog.cs.biz.outbound.model.dto.check;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class OuterCheckBarcodeDetailDTO {

    @ApiModelProperty(value = " 标签号")
    private String barcode;

    @ApiModelProperty(value = " 商品编号")
    private String itemCode;

    @ApiModelProperty(value = " 商品名称")
    private String itemName;

    @ApiModelProperty("规格")
    private String specification;

    @ApiModelProperty(value = "生产厂家")
    private String manufacturer;

    @ApiModelProperty(value = "批号")
    private String manufacturerLotNum;

    @ApiModelProperty("显示生产日期")
    private String batchProductionDateShow;

    @ApiModelProperty("显示有效期至")
    private String batchExpiredDateShow;

    @ApiModelProperty(value = "数量")
    private BigDecimal qty;

    @ApiModelProperty(value = "件数")
    private BigDecimal uomQty;

    @ApiModelProperty(value = "包装单位")
    private String uom;

    @ApiModelProperty(value = "库存状态（1合格/2不合格/3待检/4退货）")
    private String stockStatus;
}
