package com.prolog.cs.biz.outbound.model.dto.check;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
public class OuterTaskV2DTO {

    @ApiModelProperty(value = " 出库单号")
    private String pickTaskId;

    @ApiModelProperty(value = " 订单组id")
    private String billGroupId;

    @ApiModelProperty(value = "状态 0：拣货中；1拣货完成")
    private Integer status;

    @ApiModelProperty(value = "状态名称")
    private String statusName;

    @ApiModelProperty(value = "整件数")
    private int zjCount;

    @ApiModelProperty(value = "拼箱数")
    private int lsCount;

    @ApiModelProperty(value = "共计")
    private int jsCount;

    @ApiModelProperty(value = "包裹明细")
    private List<OuterLblPkgDTO> lblPkgDTOList;
}
