package com.prolog.cs.biz.outbound.model.dto.faceorder;

import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * EMS快递
 */
@Data
@NoArgsConstructor
public class EmsFaceOrderAddDTO {

    /**
     * carrierEmsResultInfo : {"routeCode":"030-035-R02-909","receiver":{"address":"湖北省武汉市硚口区硚口路中山大道1号","name":"16888888888","mobile":"16888888888"},"sender":{"address":"江西省赣州市章贡区经济技术开发区凤凰路7号","name":"4009158120","mobile":"4009158120"},"waybillNo":"9746557007887","createOrderInfo":"{\"serialNo\":\"0a5c8719-a750-4e42-8eef-b8a47f883408\",\"retCode\":\"00000\",\"retMsg\":\"成功！\",\"retBody\":\"{\\\"routeCode\\\":\\\"030-035-R02-909\\\",\\\"markDestinationCode\\\":\\\"R02\\\",\\\"packageCode\\\":\\\"\\\",\\\"logisticsOrderNo\\\":\\\"12312313\\\",\\\"packageCodeName\\\":\\\"R02\\\",\\\"markDestinationName\\\":\\\"R02\\\",\\\"waybillNo\\\":\\\"9746557007887\\\"}\",\"retDate\":\"2023-09-13 09:58:25\",\"success\":true}"}
     * wayBillNo : 9746557007887
     */

    private CarrierEmsResultInfoBean carrierEmsResultInfo;
    private String wayBillNo;

    @NoArgsConstructor
    @Data
    public static class CarrierEmsResultInfoBean {
        /**
         * routeCode : 030-035-R02-909
         * waybillNo : 9746557007887
         * createOrderInfo : {"serialNo":"0a5c8719-a750-4e42-8eef-b8a47f883408","retCode":"00000","retMsg":"成功！","retBody":"{\"routeCode\":\"030-035-R02-909\",\"markDestinationCode\":\"R02\",\"packageCode\":\"\",\"logisticsOrderNo\":\"12312313\",\"packageCodeName\":\"R02\",\"markDestinationName\":\"R02\",\"waybillNo\":\"9746557007887\"}","retDate":"2023-09-13 09:58:25","success":true}
         */
        private String routeCode;
        private String waybillNo;
        private String createOrderInfo;
    }
}
