package com.prolog.cs.biz.outbound.model.dto.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class JdBmdFaceOrder {


    @JsonProperty("carrierCode")
    private String carrierCode;
    @JsonProperty("companyCode")
    private String companyCode;
    @JsonProperty("params")
    private List<JdBmdParamsDTO> params;

    @NoArgsConstructor
    @Data
    public static class JdBmdParamsDTO {
        @JsonProperty("customerCode")
        private String customerCode;
        @JsonProperty("scene")
        private Integer scene;
        @JsonProperty("billCodeValue")
        private String billCodeValue;
        @JsonProperty("billCodeType")
        private String billCodeType;
    }
}
