package com.prolog.cs.biz.outbound.model.dto.faceorder;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class SfFaceOrderCdDTO {


    /**
     * success : true
     * errorCode : S0000
     * errorMsg : null
     * msgData : {"orderId":"N24050397095","waybillNoInfoList":[{"waybillType":2,"waybillNo":"SF2072570556029","boxNo":null,"length":null,"width":null,"height":null,"weight":null,"volume":null},{"waybillType":1,"waybillNo":"SF1639410493566","boxNo":null,"length":null,"width":null,"height":null,"weight":null,"volume":null}]}
     */

    private boolean success;
    private String errorCode;
    private Object errorMsg;
    private MsgDataBean msgData;

    @NoArgsConstructor
    @Data
    public static class MsgDataBean {
        /**
         * orderId : N24050397095
         * waybillNoInfoList : [{"waybillType":2,"waybillNo":"SF2072570556029","boxNo":null,"length":null,"width":null,"height":null,"weight":null,"volume":null},{"waybillType":1,"waybillNo":"SF1639410493566","boxNo":null,"length":null,"width":null,"height":null,"weight":null,"volume":null}]
         */

        private String orderId;
        private List<WaybillNoInfoListBean> waybillNoInfoList;

        @NoArgsConstructor
        @Data
        public static class WaybillNoInfoListBean {
            /**
             * waybillType : 2
             * waybillNo : SF2072570556029
             * boxNo : null
             * length : null
             * width : null
             * height : null
             * weight : null
             * volume : null
             */

            private Integer waybillType;
            private String waybillNo;
            private Object boxNo;
            private Object length;
            private Object width;
            private Object height;
            private Object weight;
            private Object volume;
        }
    }
}
