package com.prolog.cs.biz.outbound.model.dto.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class YdKyFaceOrderInfo {


    @JsonProperty("success")
    private Boolean success;
    @JsonProperty("error_code")
    private String errorCode;
    @JsonProperty("error_msg")
    private String errorMsg;
    @JsonProperty("remark")
    private String remark;
    @JsonProperty("result_info")
    private List<ResultInfoDTO> resultInfo;

    @NoArgsConstructor
    @Data
    public static class ResultInfoDTO {
        @JsonProperty("serial_no")
        private String serialNo;
        @JsonProperty("mailno")
        private String mailno;
        @JsonProperty("mailno_sub")
        private List<String> mailnoSub;
        @JsonProperty("receiver_site")
        private String receiverSite;
        @JsonProperty("receiver_site_code")
        private Integer receiverSiteCode;
        @JsonProperty("receiver_super_site")
        private String receiverSuperSite;
        @JsonProperty("receiver_super_site_code")
        private Integer receiverSuperSiteCode;
        @JsonProperty("receiver_center")
        private String receiverCenter;
        @JsonProperty("receiver_center_code")
        private Integer receiverCenterCode;
        @JsonProperty("sender_site")
        private String senderSite;
        @JsonProperty("sender_site_code")
        private String senderSiteCode;
        @JsonProperty("route")
        private String route;
        @JsonProperty("cargo_area")
        private String cargoArea;
        @JsonProperty("error_code")
        private String errorCode;
        @JsonProperty("error_msg")
        private String errorMsg;
    }
}
