package com.prolog.cs.biz.outbound.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class PickTaskDVo {
    @ApiModelProperty("主键")
    private String pk;
    @ApiModelProperty("商品Id")
    private String itemId;
    @ApiModelProperty("商品编号")
    private String itemCode;
    @ApiModelProperty("商品")
    private String itemName;
    @ApiModelProperty(value = "规格")
    private String itemSpecs;
    @ApiModelProperty(value = "有效期至")
    private Date expiredDate;
    @ApiModelProperty(value = "单位")
    private String uom;
    @ApiModelProperty("货位")
    private String locateId;
    @ApiModelProperty("货位")
    private String locateCode;
    @ApiModelProperty("批号")
    private String manufacturerLotNum;
    @ApiModelProperty("总拣货数量")
    private BigDecimal qty;
    @ApiModelProperty("周转箱拣货数量")
    private List<ContainerQtyVo> containerQtyList;
    @ApiModelProperty("库存数量")
    private BigDecimal stockQty;
    @ApiModelProperty("cang")
    private String warehouseId;
    @ApiModelProperty("建筑id")
    private String bldgId;
    @ApiModelProperty("orderId")
    private String pickOrderId;
    @ApiModelProperty("是否已确认")
    private Integer unConfirmCount;
    @ApiModelProperty("是否已确认")
    private Boolean confirmStatus;
}
