package com.prolog.cs.biz.outbound.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class RefDoVo {
    @ApiModelProperty("单据编号")
    private String djbh;
    @ApiModelProperty("单位ID")
    private String dwid;
    @ApiModelProperty("开票日期")
    private Date rq;
    @ApiModelProperty("业务员")
    private String ry_ywy;
    @ApiModelProperty("制单人")
    private String zdr;
    @ApiModelProperty("提货方式")
    private String thfs;
    @ApiModelProperty("部门名称")
    private String bmmc;
    @ApiModelProperty("备注")
    private String khbz;
    @ApiModelProperty("订单类型")
    private String ddlx;
    @ApiModelProperty("收货地址")
    private String shdz;
    @ApiModelProperty("收货人")
    private String shr;
    @ApiModelProperty("联系方式")
    private String lxfs;
    @ApiModelProperty("是否打印资质")
    private String sf_zzdy;
    @ApiModelProperty("模板编号")
    private String mb_bh;
    @ApiModelProperty("物流名称")
    private String wlmc;
    @ApiModelProperty("备注")
    private String beizhu;
    @ApiModelProperty("加减款")
    private BigDecimal jjk;
    @ApiModelProperty("经营许可证号")
    private String jyxkzh;
    @ApiModelProperty("创新会员卡号")
    private String cxhykh;
    @ApiModelProperty("创新会员卡名称")
    private String cxhymch;
    @ApiModelProperty("身份证号")
    private String idcard;
    @ApiModelProperty("企业ID")
    private String p_enterpriseid;
    @ApiModelProperty("仓库ID")
    private String branchid;
    @ApiModelProperty("货主内码，ERP下传")
    private String yzid;
    @ApiModelProperty("下传状态")
    private String wmflg;
    @ApiModelProperty("下传日期")
    private Date dmrq;
    @ApiModelProperty("修改时间")
    private Date xgtime;
    @ApiModelProperty("序号")
    private String dj_sort;
    @ApiModelProperty("商品ID")
    private String spid;
    @ApiModelProperty("数量")
    private BigDecimal sl;
    @ApiModelProperty("件数")
    private BigDecimal js;
    @ApiModelProperty("零散数")
    private BigDecimal lss;
    @ApiModelProperty("批号")
    private String ph;
    @ApiModelProperty("含税价格")
    private String price;
}
