package com.prolog.cs.biz.outbound.model.vo.check;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@ApiModel("容器任务复核信息")
@Data
public class InnerCheckContainerVO {

    @ApiModelProperty(value = "容器编码")
    private String containerCode;

    @ApiModelProperty(value = "总品种")
    private Integer totalVarieties;

    @ApiModelProperty(value = "合计批号")
    private Integer totalLot;

    @ApiModelProperty(value = "已经检查的品种数量")
    private Integer checkedVarieties;

    @ApiModelProperty(value = "未检查的数量")
    private Integer unCheckedVarieties;

    @ApiModelProperty(value = "已经检查的批号")
    private Integer checkedLot;

    @ApiModelProperty(value = "未检查的批号")
    private Integer unCheckedLot;

    @ApiModelProperty(value = "总数量")
    private BigDecimal totalNum;

    @ApiModelProperty(value = "已经检查的数量")
    private BigDecimal checkedNum;

    @ApiModelProperty(value = "未检查的数量")
    private BigDecimal unCheckedNum;

    @ApiModelProperty(value = "订单待复核任务数量")
    private long orderUncheckedTaskNum;

    @ApiModelProperty(value = "订单红冲数量")
    private BigDecimal redNum;
}
