package com.prolog.cs.biz.outbound.model.vo.check;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 外复核索取入参
 */
@Data
public class OuterCheckGainVO {

    @ApiModelProperty(value = "订单编号")
    private String srcBillCode;

    @ApiModelProperty(value = "条码")
    private String barcode;

    @ApiModelProperty(value = "工号")
    private String operatorCode;

    @ApiModelProperty(value = "仓库id")
    private String warehouseId;

    @ApiModelProperty(value = "建筑物id")
    private String bldgId;

    @ApiModelProperty(value = "提货人姓名")
    private String takeGoodsName;

    @ApiModelProperty(value = "提货人电话")
    private String takeGoodsPhone;


    public OuterCheckGainVO() {
    }

    public OuterCheckGainVO(String srcBillCode, String barcode) {
        this.srcBillCode = srcBillCode;
        this.barcode = barcode;
    }
}
