package com.prolog.cs.biz.outbound.model.vo.faceorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class YdCancel {


    @JsonProperty("carrierCode")
    private String carrierCode;
    @JsonProperty("params")
    private List<ParamsDTO> params;

    @NoArgsConstructor
    @Data
    public static class ParamsDTO {
        @JsonProperty("order_serial_no")
        private String orderSerialNo;
        @JsonProperty("mailno")
        private String mailno;
    }
}
