package com.prolog.cs.biz.outbound.service;

import com.prolog.cs.biz.outbound.model.entity.BillDPrePositionDO;
import com.prolog.cs.biz.outbound.model.vo.BillDPrePositionVO;
import com.prolog.framework.common.message.RestMessage;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author denglt
 * @since 2021-06-12
 */
public interface BillDPrePositionService {
          RestMessage<Boolean> assignPosition(List<BillDPrePositionVO> positions);

        /**
         * 新增或编辑
         *
         * @param entity 实体
         * @return Boolean
         */
        Boolean edit(BillDPrePositionDO entity);


        Boolean isExist(String id);

    RestMessage<List<BillDPrePositionDO>> getPositions(String billDId);

    /**
         * 判断字段是否重复 true:重复 false:不重复
         *
         * @param notId       id
         * @param columnName  字段名称
         * @param columnValue 字段值
         * @return Boolean
         */
}
