package com.prolog.cs.biz.outbound.service;

import java.math.BigDecimal;

/**
 * @Description
 * @Date 2021-03-24
 */

public interface OrderOutboundStatusBackService {

	/**
	 * 发送出库订单状态数据到OMS
	 *
	 * @param billId 单据ID，remark 备注，holdCode 冻结编码, packedBy 验箱人员, extendProps 扩展属性,doStatus 状态, casesShpd 总箱数
	 * @return
	 */
	public void sendOutboundOrderStatusOms(String billId, String remark, String holdCode, String packedBy, String extendProps, String doStatus, BigDecimal casesShpd);

}
