
package com.prolog.cs.biz.outbound.controller.tms;

import com.prolog.cs.biz.outbound.service.TmsService;
import com.prolog.framework.common.message.RestMessage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "tms控制类")
@RestController
@RequestMapping("/tms")
public class TmsController {

	@Autowired
	private TmsService tmsService;

	@ApiOperation(value = "定时任务调用-推送包裹消息给TMS")
	@PostMapping("/pushPackage")
	public RestMessage<Object> pushPackage() {
		tmsService.pushPackage();
		return RestMessage.newInstance(true, "执行成功", null);
	}

}
