package com.prolog.cs.biz.outbound.dao;

import com.prolog.cs.biz.outbound.model.PickUpRecord;
import com.prolog.framework.dao.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface PickUpRecordMapper extends BaseMapper<PickUpRecord> {

    List<PickUpRecord> getPickUpRecordList(@Param("shipperName")String shipperName,@Param("srcCode") String srcCode,@Param("startDate") String startDate,@Param("endDate") String endDate,@Param("warehouseId") String warehouseId,@Param("enterpriseId") String enterpriseId,@Param("bldgId") String bldgId);

}
