package com.prolog.cs.biz.outbound.dao;

import com.prolog.cs.biz.outbound.model.entity.WorkStageRuntimeDO;
import com.prolog.cs.biz.outbound.model.vo.WorkStageVO;
import com.prolog.framework.dao.mapper.BaseMapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface WorkStageRuntimeMapper extends BaseMapper<WorkStageRuntimeDO> {

    List<WorkStageVO> findWorkStage(@Param("warehouseId") String warehouseId,
                                    @Param("waveId") String waveId,
                                    @Param("billGroupId") String billGroupId);

    long updateStatus(@Param("billGroupId") String billGroupId);
}
