package com.prolog.cs.biz.outbound.funcflow;

import com.prolog.cs.platform.power.model.Employee;
import com.prolog.function.annotation.Func;

import java.util.List;
import java.util.Map;

public class BarCodeFunc {

    @FunctionalInterface
    @Func(name = "扣减库存,并回传ERP", category = "出库/复核管理/外复核/外复核确认", description = "扣减库存,并回传ERP")
    public interface invStockConfirm {
        void invStockConfirm(List<String> srcCodes,List<String> omsBillIds, String warehouseId);
    }

    @FunctionalInterface
    @Func(name = "更新状态", category = "出库/复核管理/外复核/外复核确认", description = "更新状态")
    public interface updateOuterCheck {
        Map<String,List<String>> updateOuterCheck(List<String> srcCodes, String operatorCode, String warehouseId, String bldgId, String enterpriseId, Employee employee);
    }


}
