package com.prolog.cs.biz.outbound.funcflow.innnercheckfunc;

import com.prolog.cs.biz.outbound.model.dto.check.CheckConfirmDTO;
import com.prolog.cs.biz.outbound.model.entity.InnerCheckDDO;
import com.prolog.cs.biz.outbound.model.entity.WaveBillDO;
import com.prolog.cs.biz.outbound.model.vo.check.InnerCheckConfirmCheckVO;
import com.prolog.framework.common.message.RestMessage;
import com.prolog.function.annotation.Func;

import java.util.List;


@Func(name = "内复核确认", category = "出库/复核管理/内复核", description = "内复核确认")
@FunctionalInterface
public interface InnerCheckConfirmFunc {

    /**
     *
     */
    RestMessage<InnerCheckConfirmCheckVO> innerCheckConfirmFunc(CheckConfirmDTO checkConfirmDTO, List<InnerCheckDDO> innerCheckDs);

}