package com.prolog.cs.biz.outbound.resource;

import com.prolog.cs.biz.outbound.model.out.ContainerBindTaskDto;
import com.prolog.eis.core.dto.business.outboundtask.OutboundTaskIssueDto;
import com.prolog.framework.common.message.RestMessage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @author zzz
 * @desc
 * @date 2021/12/17
 */
@FeignClient(value = "${prolog.service.eis}")
public interface EisAgvResource {

    @PostMapping("/outbound/genOutboundTask")
    RestMessage<Boolean> genOutboundTask(@RequestBody OutboundTaskIssueDto dto);
    
    @GetMapping("/outbound/containerOffShelf")
    RestMessage<ContainerBindTaskDto> containerOffShelf(@RequestParam("containerNo") String containerNo);
}
