package com.prolog.cs.biz.outbound.resource;

import com.prolog.cs.biz.outbound.model.dto.InfTaskOutBackDTO;
import com.prolog.framework.bz.common.print.ReportData;
import com.prolog.framework.common.message.RestMessage;
import com.prolog.upcloud.base.wh.operate.dto.ReplenishIncidentallyDTO;
import com.prolog.upcloud.base.wh.operate.vo.*;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(value = "${prolog.service.gsp}")
public interface GspResource {

	/**
	 * EIS养护回告
	 * @param upkeepList
	 * @return
	 */
	@PostMapping("/gspUpkeepCheck/gspUpKeepOutBack")
	RestMessage gspUpKeepOutBack(@RequestBody List<InfTaskOutBackDTO> upkeepList);

}
