package com.prolog.cs.biz.outbound.resource;

import com.prolog.cs.platform.power.model.Employee;
import com.prolog.framework.common.message.RestMessage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(value = "${prolog.service.power}")
public interface PowerResource {

	/**
	 *
	 * @param jobnumber
	 * @param warehouseId
	 * @param enterpriseId
	 * @return
	 */
    @GetMapping("/employee/bynum")
	RestMessage<Employee> getByNum(@RequestParam(value = "jobnumber")String jobnumber, @RequestParam(value = "warehouseId") String warehouseId, @RequestParam(value = "enterpriseId") String enterpriseId);

}
